[![CI](https://github.com/JuliaGeometry/GeometryBasics.jl/actions/workflows/ci.yml/badge.svg)](https://github.com/JuliaGeometry/GeometryBasics.jl/actions/workflows/ci.yml)
[![Codecov](https://codecov.io/gh/JuliaGeometry/GeometryBasics.jl/branch/master/graph/badge.svg)](https://codecov.io/gh/JuliaGeometry/GeometryBasics.jl)

[![Docs - stable](https://img.shields.io/badge/docs-stable-lightgrey.svg)](http://juliageometry.github.io/GeometryBasics.jl/stable/)
[![Docs - dev](https://img.shields.io/badge/docs-dev-blue.svg)](http://juliageometry.github.io/GeometryBasics.jl/dev/)

# GeometryBasics.jl

Basic geometry types.

This package aims to offer a standard set of geometry types that easily work
with metadata, query frameworks on geometries and different memory layouts. The
aim is to create a solid basis for graphics/plotting, finite element analysis,
geo applications, and general geometry manipulations - while offering a Julian
API that still allows performant C-interop.

This package is a replacement for the discontinued [GeometryTypes](https://github.com/JuliaGeometry/GeometryTypes.jl/).

**Documentation:** http://juliageometry.github.io/GeometryBasics.jl/stable/

## Contributing

Make sure your changes don't break the documentation.

To build the documentation locally, you first need to instantiate the `docs/` project:

```
julia --project=docs/
pkg> instantiate
pkg> dev .
```

Then use `julia --project=docs/ docs/make.jl` to build the documentation. This
will also run the doctests defined in Markdown files. The doctests should be
written for the Julia version configured in [ci.yml](.github/workflows/ci.yml)
(`:docs` section).

#=
ported from:
http://docs.ros.org/jade/api/convex_decomposition/html/triangulate_8cpp_source.html

The MIT License (MIT)

Copyright (c) 2006 John W. Ratcliff

Permission is hereby granted, free of charge, to any person obtaining a copy of this software and associated documentation files (the "Software"), to deal in the Software without restriction, including without limitation the rights to use, copy, modify, merge, publish, distribute, sublicense, and/or sell copies of the Software, and to permit persons to whom the Software is furnished to do so, subject to the following conditions:

The above copyright notice and this permission notice shall be included in all copies or substantial portions of the Software.

THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.
=#
"""
    area(vertices::AbstractVector{Point{3}}, face::NgonFace)

Calculate the area of one face.
"""
function area(vertices::AbstractVector{<:Point}, face::NgonFace)
    return 0.5 * norm(orthogonal_vector(vertices[face]))
end

"""
    area(vertices::AbstractVector{Point}, faces::AbstractVector{NgonFace})

Calculate the area of all faces.
"""
function area(vertices::AbstractVector{<:Point}, faces::AbstractVector{<:NgonFace})
    return sum(x -> area(vertices, x), faces)
end

"""
    area(vertices::AbstractVector{Point}})

Calculate the area of a polygon.

For 2D points, the oriented area is returned (negative when the points are
oriented clockwise).
"""
function area(vertices::AbstractVector{Point{2,T}}) where {T}
    length(vertices) < 3 && return zero(T)
    return T(0.5) * orthogonal_vector(vertices)[3]
end

function area(vertices::AbstractVector{Point{3,T}}) where {T}
    length(vertices) < 3 && return zero(T)
    return T(0.5) * norm(orthogonal_vector(vertices))
end


"""
    in(point, triangle)

Determine if a point is inside of a triangle.
"""
function Base.in(P::T, triangle::Triangle) where {T<:Point}
    A, B, C = coordinates(triangle)

    ap = A .- P
    bp = B .- P
    cp = C .- P

    u = cross(bp, cp)
    v = cross(cp, ap)
    w = cross(ap, bp)

    t0 = zero(eltype(T))
    dot(u, v) < t0 && return false
    dot(u, w) < t0 && return false
    return true
end


function snip(contour::AbstractVector{<:Point}, u, v, w, n, V)
    A = contour[V[u]]
    B = contour[V[v]]
    C = contour[V[w]]
    x = (((B[1] - A[1]) * (C[2] - A[2])) - ((B[2] - A[2]) * (C[1] - A[1])))
    if 0.0000000001f0 > x
        return false
    end

    for p in 1:n
        ((p == u) || (p == v) || (p == w)) && continue
        P = contour[V[p]]
        if P in Triangle(A, B, C)
            return false
        end
    end
    return true
end

"""
    decompose(facetype, contour::AbstractArray{<:Point})

Triangulate a Polygon without hole.

Returns a Vector{`facetype`} defining indexes into `contour`.
"""
function decompose(::Type{F}, points::AbstractVector{<:Point}) where {F<:AbstractFace}
    #= allocate and initialize list of Vertices in polygon =#
    result = F[]

    # the algorithm doesn't like closed contours
    contour = if isapprox(last(points), first(points))
        @view points[1:(end - 1)]
    else
        @view points[1:end]
    end

    n = length(contour)
    if n < 3
        error("Not enough points in the contour. Found: $contour")
    end

    #= we want a counter-clockwise polygon in V =#
    if 0 < area(contour)
        V = Int[i for i in 1:n]
    else
        V = Int[i for i in n:-1:1]
    end

    nv = n

    #=  remove nv-2 Vertices, creating 1 triangle every time =#
    count = 2 * nv   #= error detection =#
    v = nv
    while nv > 2
        #= if we loop, it is probably a non-simple polygon =#
        if 0 >= count
            return result
        end
        count -= 1

        #= three consecutive vertices in current polygon, <u,v,w> =#
        u = v
        (u > nv) && (u = 1) #= previous =#
        v = u + 1
        (v > nv) && (v = 1) #= new v =#
        w = v + 1
        (w > nv) && (w = 1) #= next =#
        if snip(contour, u, v, w, nv, V)
            #= true names of the vertices =#
            a = V[u]
            b = V[v]
            c = V[w]
            #= output Triangle =#
            push!(result, convert_simplex(F, TriangleFace(a, b, c))...)
            #= remove v from remaining polygon =#
            s = v
            t = v + 1
            while t <= nv
                V[s] = V[t]
                s += 1
                t += 1
            end
            nv -= 1
            #= reset error detection counter =#
            count = 2 * nv
        end
    end

    return result
end

function earcut_triangulate(polygon::Vector{Vector{Point{2,Float64}}})
    lengths = map(x -> UInt32(length(x)), polygon)
    len = UInt32(length(lengths))
    array = ccall((:u32_triangulate_f64, libearcut), Tuple{Ptr{GLTriangleFace},Cint},
                  (Ptr{Ptr{Float64}}, Ptr{UInt32}, UInt32), polygon, lengths, len)
    return unsafe_wrap(Vector{GLTriangleFace}, array[1], array[2]; own=true)
end

function earcut_triangulate(polygon::Vector{Vector{Point{2,Float32}}})
    lengths = map(x -> UInt32(length(x)), polygon)
    len = UInt32(length(lengths))
    array = ccall((:u32_triangulate_f32, libearcut), Tuple{Ptr{GLTriangleFace},Cint},
                  (Ptr{Ptr{Float32}}, Ptr{UInt32}, UInt32), polygon, lengths, len)
    return unsafe_wrap(Vector{GLTriangleFace}, array[1], array[2]; own=true)
end

function earcut_triangulate(polygon::Vector{Vector{Point{2,Int64}}})
    lengths = map(x -> UInt32(length(x)), polygon)
    len = UInt32(length(lengths))
    array = ccall((:u32_triangulate_i64, libearcut), Tuple{Ptr{GLTriangleFace},Cint},
                  (Ptr{Ptr{Int64}}, Ptr{UInt32}, UInt32), polygon, lengths, len)
    return unsafe_wrap(Vector{GLTriangleFace}, array[1], array[2]; own=true)
end

function earcut_triangulate(polygon::Vector{Vector{Point{2,Int32}}})
    lengths = map(x -> UInt32(length(x)), polygon)
    len = UInt32(length(lengths))
    array = ccall((:u32_triangulate_i32, libearcut), Tuple{Ptr{GLTriangleFace},Cint},
                  (Ptr{Ptr{Int32}}, Ptr{UInt32}, UInt32), polygon, lengths, len)
    return unsafe_wrap(Vector{GLTriangleFace}, array[1], array[2]; own=true)
end

best_earcut_eltype(x) = Float64
best_earcut_eltype(::Type{Float64}) = Float64
best_earcut_eltype(::Type{<:AbstractFloat}) = Float32
best_earcut_eltype(::Type{Int64}) = Int64
best_earcut_eltype(::Type{Int32}) = Int32
best_earcut_eltype(::Type{<:Integer}) = Int64

function faces(polygon::Polygon{Dim,T}) where {Dim,T}
    PT = Point{Dim,best_earcut_eltype(T)}
    points = [decompose(PT, polygon.exterior)]
    foreach(x -> push!(points, decompose(PT, x)), polygon.interiors)
    return earcut_triangulate(points)
end

module IntervalSetsExt

using IntervalSets
using GeometryBasics

GeometryBasics.HyperRectangle(ints::Vararg{ClosedInterval, N}) where {N} = HyperRectangle{N}(ints...)
GeometryBasics.HyperRectangle{N}(ints::Vararg{ClosedInterval, N}) where {N} = HyperRectangle{N}(
    Vec(leftendpoint.(ints)),
    Vec(rightendpoint.(ints) .- leftendpoint.(ints))
)
GeometryBasics.HyperRectangle{N,T}(ints::Vararg{ClosedInterval, N}) where {N,T} = HyperRectangle{N,T}(
    Vec(leftendpoint.(ints)),
    Vec(rightendpoint.(ints) .- leftendpoint.(ints))
)

end

"""
    coordinates(geometry)

Returns the positions/coordinates of a geometry.

This is allowed to return lazy iterators. Use `decompose(ConcretePointType, geometry)`
to get a `Vector{ConcretePointType}` with `ConcretePointType` being something like
`Point3f`.
"""
function coordinates(points::AbstractVector{<:Point})
    return points
end

"""
    faces(geometry)

Returns the faces of a geometry.

This is allowed to return lazy iterators. Use `decompose(ConcreteFaceType, geometry)`
to get a `Vector{ConcreteFaceType}` with `ConcreteFaceType` being something like `GLTriangleFace`.
"""
function faces(f::AbstractVector{<:AbstractFace})
    return f
end

"""
    normals(primitive)

Returns the normals of a geometry.

This is allowed to return lazy iterators. Use `decompose_normals(ConcreteVecType, geometry)`
to get a `Vector{ConcreteVecType}` with `ConcreteVecType` being something like `Vec3f`.
"""
function normals(primitive, nvertices=nothing; kw...)
    # doesn't have any specific algorithm to generate normals
    # so will be generated from faces + positions
    # which we indicate by returning nothing!
    # Overload normals(primitive::YourPrimitive), to calculate the normals
    # differently
    return nothing
end

function faces(primitive, nvertices=nothing; kw...)
    # doesn't have any specific algorithm to generate faces
    # so will try to triangulate the coordinates!
    return nothing
end

"""
    texturecoordinates(primitive)

Returns the texturecoordinates of a geometry.

This is allowed to return lazy iterators. Use `decompose_uv(ConcreteVecType, geometry)`
(or `decompose_uvw`) to get a `Vector{ConcreteVecType}` with `ConcreteVecType` being
something like `Vec2f`.
"""
texturecoordinates(primitive, nvertices=nothing) = nothing

"""
    Tessellation(primitive, nvertices)

When generating a mesh from an abstract geometry, we can typically generate it
at different levels of detail, i.e. with different amounts of vertices. The
`Tessellation` wrapper allows you to specify this level of detail. When generating
a mesh from a tessellated geometry, the added information will be passed to
`coordinates`, `faces`, etc.

```julia
sphere = Sphere(Point3f(0), 1)
m1 = mesh(sphere) # uses a default value for tessellation
m2 = mesh(Tessellation(sphere, 64)) # uses 64 for tessellation
length(coordinates(m1)) != length(coordinates(m2))
```

For grid based tessellation, you can also use a tuple:

```julia
rect = Rect2(0, 0, 1, 1)
Tessellation(rect, (5, 5))
```
"""
struct Tessellation{Dim,T,Primitive,NGrid} <: AbstractGeometry{Dim, T}
    primitive::Primitive
    nvertices::NTuple{NGrid,Int}
end

Base.@deprecate_binding Tesselation Tessellation

function Tessellation(primitive::GeometryPrimitive{Dim,T},
                     nvertices::NTuple{N,<:Integer}) where {Dim,T,N}
    return Tessellation{Dim,T,typeof(primitive),N}(primitive, Int.(nvertices))
end

Tessellation(primitive, nvertices::Integer) = Tessellation(primitive, (nvertices,))

# This is a bit lazy, I guess we should just refactor these methods
# to directly work on Tessellation - but this way it's backward compatible and less
# refactor work :D
nvertices(tessellation::Tessellation) = tessellation.nvertices
nvertices(tessellation::Tessellation{T,N,P,1}) where {T,N,P} = tessellation.nvertices[1]

function coordinates(tessellation::Tessellation)
    return coordinates(tessellation.primitive, nvertices(tessellation))
end
faces(tessellation::Tessellation) = faces(tessellation.primitive, nvertices(tessellation))
normals(tessellation::Tessellation) = normals(tessellation.primitive, nvertices(tessellation))
function texturecoordinates(tessellation::Tessellation)
    return texturecoordinates(tessellation.primitive, nvertices(tessellation))
end

## Decompose methods
# Dispatch type to make `decompose(UV{Vec2f}, primitive)` work
# and to pass through tessellation information

struct UV{T} end
UV(::Type{T}) where {T} = UV{T}()
UV() = UV(Vec2f)
struct UVW{T} end
UVW(::Type{T}) where {T} = UVW{T}()
UVW() = UVW(Vec3f)
struct Normal{T} end
Normal(::Type{T}) where {T} = Normal{T}()
Normal() = Normal(Vec3f)

"""
    decompose(::Type{TargetType}, primitive)
    decompose(::Type{TargetType}, data::AbstractVector)

Dependent on the given type, extracts data from the primitive and converts its
eltype to `TargetType`.

Possible `TargetType`s:
- `<: Point` extracts and converts positions (calling `coordinates()`)
- `<: AbstractFace` extracts and converts faces (calling `faces()`)
- `<: Normal{<: Vec}` extracts and converts normals, potentially generating them (calling `normals()`)
- `<: UV{<: Vec}` extracts and converts 2D texture coordinates, potentially generating them (calling `texturecoordinates()`)
- `<: UVW{<: Vec}` extracts and converts 3D texture coordinates, potentially generating them (calling `texturecoordinates()`)
"""
function decompose(::Type{F}, primitive::AbstractGeometry) where {F<:AbstractFace}
    f = faces(primitive)
    if isnothing(f)
        if ndims(primitive) == 2
            # if 2d, we can fallback to Polygon triangulation
            return decompose(F, Polygon(decompose(Point, primitive)))
        else
            return nothing
        end
    end
    return decompose(F, f)
end

function decompose(::Type{F}, f::AbstractVector) where {F<:AbstractFace}
    fs = faces(f)
    isnothing(fs) && error("No faces defined for $(typeof(f))")
    return collect_with_eltype(F, fs)
end

# TODO: Should this be a completely different function?
function decompose(::Type{F}, f::AbstractVector, views::Vector{UnitRange{IT}}) where {F<:AbstractFace, IT<:Integer}
    fs = faces(f)
    isnothing(fs) && error("No faces defined for $(typeof(f))")
    if isempty(views)
        return collect_with_eltype(F, fs), views
    else
        output = F[]
        new_views = sizehint!(UnitRange{IT}[], length(views))
        for range in views
            start = length(output) + 1
            collect_with_eltype!(output, view(fs, range))
            push!(new_views, start:length(output))
        end
        return output, new_views
    end
end

function decompose(::Type{P}, primitive) where {P<:Point}
    return collect_with_eltype(P, coordinates(primitive))
end

function decompose(::Type{Point}, primitive::AbstractGeometry{Dim,T}) where {Dim,T}
    return collect_with_eltype(Point{Dim,T}, coordinates(primitive))
end

function decompose(::Type{Point{Dim}}, primitive::AbstractGeometry{Dim,T}) where {Dim,T}
    return collect_with_eltype(Point{Dim,T}, coordinates(primitive))
end

function decompose(::Type{PointT{T}}, primitive::AbstractGeometry{Dim}) where {Dim, T}
    return collect_with_eltype(Point{Dim,T}, coordinates(primitive))
end

function decompose(::Type{T}, primitive) where {T}
    return collect_with_eltype(T, primitive)
end

decompose_uv(primitive) = decompose(UV(), primitive)
decompose_uvw(primitive) = decompose(UVW(), primitive)
decompose_normals(primitive) = decompose(Normal(), primitive)

decompose_uv(T, primitive) = decompose(UV(T), primitive)
decompose_uvw(T, primitive) = decompose(UVW(T), primitive)
decompose_normals(T, primitive) = decompose(Normal(T), primitive)

function decompose(::Normal{T}, primitive) where {T}
    _n = normals(primitive)
    if isnothing(_n)
        # For 3D primitives, we can calculate the normals from the vertices + faces
        if ndims(primitive) == 3
            n = normals(decompose(Point, primitive), faces(primitive), T)
        else
            points = decompose(Point, primitive)
            n = [T(0, 0, 1) for p in points]
        end
    else
        n = _n
    end
    return collect_with_eltype(T, n)
end

function decompose(UVT::Union{UV{T},UVW{T}}, primitive) where {T}
    # This is the fallback for texture coordinates if a primitive doesn't overload them
    # We just take the positions and normalize them
    uv = texturecoordinates(primitive)
    if uv === nothing
        # If the primitive doesn't even have coordinates, we're out of options and return
        # nothing, indicating that texturecoordinates aren't implemented
        positions = decompose(Point, primitive)
        isnothing(positions) && return nothing
        # We should generate 3D uvw's if uv's are requested
        # TODO: we should probably enforce that UV has a 2D type and UVW a 3D type
        (length(T) != length(eltype(positions))) && return nothing

        # Let this overlord do the work
        return decompose(UVT, positions)
    end
    return collect_with_eltype(T, uv)
end

function decompose(::Union{UV{T},UVW{T}}, positions::AbstractVector{<:VecTypes}) where {T}
    N = length(T)
    positions_nd = decompose(Point{N,eltype(T)}, positions)
    bb = Rect(positions_nd) # Make sure we get this as points
    mini, w = minimum(bb), widths(bb)
    return map(positions_nd) do p
        return T((p .- mini) ./ w)
    end
end

#! /usr/bin/env julia

using Documenter
using GeometryBasics

DocMeta.setdocmeta!(GeometryBasics, :DocTestSetup, :(using GeometryBasics); recursive=true)

makedocs(format=Documenter.HTML(prettyurls=get(ENV, "CI", "false") == "true"),
         sitename="GeometryBasics.jl",
         pages=[
                "index.md",
                "primitives.md",
                "polygons.md",
                "meshes.md",
                "decomposition.md",
                "boundingboxes.md",
                "static_array_types.md",
                "api.md",
               ],
         modules=[GeometryBasics])

deploydocs(repo="github.com/JuliaGeometry/GeometryBasics.jl.git", push_preview=true)

"""
    Pyramid(middle::Point3, length::Real, width::Real)

A Pyramid is an axis-aligned primitive where the tip of the Pyramid extends by 
`length` from `middle` in z direction and the square base extends by `width`
in ±x and ±y direction from `middle`. 
"""
struct Pyramid{T} <: GeometryPrimitive{3,T}
    middle::Point{3,T}
    length::T
    width::T
end

function Pyramid(middle::Point{3, T1}, length::T2, width::T3) where {T1, T2, T3}
    T = promote_type(T1, T2, T3)
    return Pyramid(Point3{T}(middle), T(length), T(width))
end

function coordinates(p::Pyramid{T}) where {T}
    leftup = Point{3,T}(-p.width, p.width, 0) / 2
    leftdown = Point(-p.width, -p.width, 0) / 2
    tip = Point{3,T}(p.middle + Point{3,T}(0, 0, p.length))
    lu = Point{3,T}(p.middle + leftup)
    ld = Point{3,T}(p.middle + leftdown)
    ru = Point{3,T}(p.middle - leftdown)
    rd = Point{3,T}(p.middle - leftup)
    return Point{3,T}[tip, rd, ru, lu, ld]
end

function normals(p::Pyramid)
    w = p.width; h = p.length
    ns = normalize.(Vec3f[(h, 0, w), (0, h, w), (-h, 0, w), (0, -h, w), (0, 0, -1)])
    fs = [GLTriangleFace(1), GLTriangleFace(2), GLTriangleFace(3), GLTriangleFace(4), QuadFace(5)]
    return FaceView(ns, fs)
end

function faces(::Pyramid)
    return [
        GLTriangleFace(1, 2, 3),
        GLTriangleFace(1, 3, 4),
        GLTriangleFace(1, 4, 5),
        GLTriangleFace(1, 5, 2),
        QuadFace(2, 3, 4, 5)
    ]
end

using Test, Random, OffsetArrays
using GeometryBasics
using LinearAlgebra
using GeometryBasics: MetaMesh
using GeoInterface
using GeoJSON
using Extents
using StaticArrays

@testset "GeometryBasics" begin
@testset "algorithms" begin
    cube = Rect(Vec3f(-0.5), Vec3f(1))
    cube_faces = decompose(TriangleFace{Int}, faces(cube))
    cube_vertices = decompose(Point{3,Float32}, cube)
    @test area(cube_vertices, cube_faces) == 6
    mesh = Mesh(cube_vertices, cube_faces)
    @test GeometryBasics.volume(mesh) ≈ 1
    @test GeometryBasics.volume(cube) ≈ 1

    rect = Rect(1, 2, 7.5, 2.0)
    @test GeometryBasics.area(rect) ≈ 15

    points_cwise = Point2f[(0,0), (0,1), (1,1)]
    points_ccwise = Point2f[(0,0), (1,0), (1,1)]
    @test area(points_cwise) ≈ -0.5
    @test area(points_ccwise) ≈ 0.5
    @test area(OffsetArray(points_cwise, -2)) ≈ -0.5

    points3d = Point3f[(0,0,0), (0,0,1), (0,1,1)]
    @test area(OffsetArray(points3d, -2)) ≈ 0.5
end

@testset "embedding metadata" begin
    @testset "Meshes" begin
        @testset "per vertex attributes" begin
            points = rand(Point{3, Float64}, 8)
            tfaces = TetrahedronFace{Int}[(1, 2, 3, 4), (5, 6, 7, 8)]
            normals = rand(Vec{3, Float64}, 8)
            stress = LinRange(0, 1, 8)
            mesh = Mesh(points, tfaces; normal = normals, stress = stress)

            @test hasproperty(mesh, :stress)
            @test hasproperty(mesh, :normal)
            @test mesh.stress === stress
            @test mesh.normal === normals
            @test mesh.position === points
            @test GeometryBasics.faces(mesh) === tfaces
            @test propertynames(mesh) == (:vertex_attributes, :faces, :views, :position, :normal, :stress)
        end
    end

    @testset "Mesh with metadata" begin
       m = triangle_mesh(Sphere(Point3f(0), 1))
       m_meta = MetaMesh(m; boundingbox=Rect(1.0, 1.0, 2.0, 2.0))
       @test m_meta[:boundingbox] === Rect(1.0, 1.0, 2.0, 2.0)
       @test collect(keys(m_meta)) == [:boundingbox,]
    end
end

@testset "view" begin
    @testset "TupleView" begin
        x = [1, 2, 3, 4, 5, 6]
        y = TupleView{2, 1}(x)
        @test y == [(1, 2), (2, 3), (3, 4), (4, 5), (5, 6)]

        y = TupleView{2}(x)
        @test y == [(1, 2), (3, 4), (5, 6)]

        y = TupleView{2, 3}(x)
        @test y == [(1, 2), (4, 5)]

        y = TupleView{3, 1}(x)
        @test y == [(1, 2, 3), (2, 3, 4), (3, 4, 5), (4, 5, 6)]

        y = TupleView{2, 1}(x, connect = true)
        @test y == [(1, 2), (2, 3), (3, 4), (4, 5), (5, 6), (6, 1)]

    end

    @testset "connected views" begin
        numbers = [1, 2, 3, 4, 5, 6]
        x = connect(numbers, Point{2})
        @test x == Point{2, Int}[(1, 2), (3, 4), (5, 6)]
        xf = connect(numbers, Point2f)
        @test xf == Point2f[(1, 2), (3, 4), (5, 6)]

        line = connect(x, Line, 1)
        @test line == [Line(Point{2, Int}(1, 2), Point{2, Int}(3, 4)), Line(Point{2, Int}(3, 4), Point{2, Int}(5, 6))]
        linef = connect(xf, Line, 1)
        @test linef == [Line(Point2f(1, 2), Point2f(3, 4)), Line(Point2f(3, 4), Point2f(5, 6))]

        triangles = connect(x, Triangle)
        @test triangles == [Triangle(Point(1, 2), Point(3, 4), Point(5, 6))]
        x = connect([1, 2, 3, 4, 5, 6, 7, 8], Point{2})
        tetrahedra = connect(x, NSimplex{4})
        @test tetrahedra == [Tetrahedron(x[1], x[2], x[3], x[4])]

        @test length(tetrahedra[1]) == 4
        @test all(coordinates(tetrahedra[1]) .== x)

        @testset "matrix non-copy point views" begin
            # point in row
            points = [1 2; 1 4; 66 77]
            comparison = [Point(1, 2), Point(1, 4), Point(66, 77)]
            @test connect(points, Point{2}) == comparison
            # point in column
            points = [1 1 66; 2 4 77]
            # huh, reinterpret array doesn't seem to like `==`
            @test all(((a,b),)-> a==b, zip(connect(points, Point{2}), comparison))
        end
    end

    @testset "reinterpret" begin
        numbers = collect(reshape(1:6, 2, 3))
        points = reinterpret(Point{2, Int}, numbers)
        @test points[1] === Point(1, 2)
        @test points[2] === Point(3, 4)
        numbers[4] = 0
        @test points[2] === Point(3, 0)
    end
end

@testset "constructors" begin
    @testset "Mesh" begin
        numbers = [1, 2, 3, 4, 5, 6]
        points = connect(numbers, Point{2})

        mesh = Mesh(points, [1,2,3])
        @test faces(mesh) == [TriangleFace(1, 2, 3)]

        x = Point{3}(1.0)
        mesh = Mesh([x], [TriangleFace(1, 1, 1)])
        @test coordinates(mesh) == [x]
        @test faces(mesh) == [TriangleFace(1, 1, 1)]

        points = connect([1, 2, 3, 4, 5, 6, 7, 8], Point{2})
        f = connect([1, 2, 3, 4], SimplexFace{4})
        mesh = Mesh(points, f)
        @test collect(mesh) == [Tetrahedron(points...)]
        @test faces(mesh) == [TetrahedronFace{Int64}(1,2,3,4)]
        @test decompose(LineFace{Int64}, mesh) == LineFace{Int64}[(1, 2), (1, 3), (1, 4), (2, 3), (2, 4), (3, 4)]
        @test decompose(GLTriangleFace, mesh) == GLTriangleFace[(2, 3, 4), (1, 3, 4), (1, 2, 4), (1, 2, 3)]

        points = rand(Point3f, 8)
        tfaces = [GLTriangleFace(1, 2, 3), GLTriangleFace(5, 6, 7)]
        ns = rand(Vec3f, 8)
        uv = rand(Vec2f, 8)
        mesh = Mesh(points, tfaces)
        meshuv = MetaMesh(points, tfaces; uv=uv)
        meshuvnormal = MetaMesh(points, tfaces; normal=ns, uv=uv)
        t = Tessellation(Rect2f(0, 0, 2, 2), (30, 30))

        m = GeometryBasics.mesh(t; pointtype=Point3f, facetype=QuadFace{Int})
        m2 = GeometryBasics.mesh(m, facetype=QuadFace{GLIndex})
        @test GeometryBasics.faces(m2) isa Vector{QuadFace{GLIndex}}
        @test GeometryBasics.coordinates(m2) isa Vector{Point3f}
    end
end

@testset "decompose/triangulation" begin
    @test isempty(decompose(Vec3f, []))
    @test decompose(Vec3f, []) isa Vector{Vec3f}
    primitive = Sphere(Point3f(0), 1)
    @test ndims(primitive) === 3
    mesh = triangle_mesh(primitive)
    @test decompose(Point, mesh) isa Vector{Point3f}
    @test decompose(Point, primitive) isa Vector{Point3f}

    primitive = Rect2(0, 0, 1, 1)
    mesh = triangle_mesh(primitive)

    @test decompose(Point, mesh) isa Vector{Point2f}
    @test decompose(Point, primitive) isa Vector{Point2{Int}}

    primitive = Rect3(0, 0, 0, 1, 1, 1)
    triangle_mesh(primitive)

    primitive = Sphere(Point3f(0), 1)
    m_normal = normal_mesh(primitive)
    @test GeometryBasics.normals(m_normal) isa Vector{Vec3f}
    primitive = Rect2(0, 0, 1, 1)
    m_normal = normal_mesh(primitive)
    @test GeometryBasics.normals(m_normal) isa Vector{Vec3f}
    primitive = Rect3(0, 0, 0, 1, 1, 1)
    m_normal = normal_mesh(primitive)
    @test GeometryBasics.normals(m_normal) isa GeometryBasics.FaceView{Vec3f, Vector{Vec3f}, Vector{GLTriangleFace}}

    points = decompose(Point2f, Circle(Point2f(0), 1))
    tmesh = triangle_mesh(points)
    @test GeometryBasics.normals(tmesh) == nothing

    m = GeometryBasics.mesh(Sphere(Point3f(0), 1))
    @test GeometryBasics.normals(m) == nothing
    m_normals = decompose_normals(m)
    @test m_normals isa Vector{Vec3f}

    @test texturecoordinates(m) == nothing
    r2 = Rect2(0.0, 0.0, 1.0, 1.0)
    @test collect(texturecoordinates(r2)) == Point2f[(0.0, 1.0), (1.0, 1.0), (1.0, 0.0), (0.0, 0.0)]
    r3 = Rect3(0.0, 0.0, 1.0, 1.0, 2.0, 2.0)
    @test first(texturecoordinates(r3)) == Vec3(0, 0, 0)
    uv = decompose_uv(m)
    @test_broken false # Rect(Point.(uv)) == Rect(0, 0, 1, 1) # decompose_uv must now produces 2D uvs
    uvw = GeometryBasics.decompose_uvw(m)
    @test Rect(Point.(uvw)) == Rect(Point3f(0), Vec3f(1))

    points = decompose(Point2f, Circle(Point2f(0), 1))
    m = GeometryBasics.mesh(points)
    @test coordinates(m) === points

    fs = [QuadFace(1,2,3,4), QuadFace(3,4,5,6), QuadFace(7,8,9,10)]
    views = [1:2, 3:3]
    new_fs, new_views = decompose(GLTriangleFace, fs, views)
    @test new_fs == GLTriangleFace[(1, 2, 3), (1, 3, 4), (3, 4, 5), (3, 5, 6), (7, 8, 9), (7, 9, 10)]
    @test new_views == [1:4, 5:6]
end

@testset "convert mesh + meta" begin
    m = uv_normal_mesh(Circle(Point2f(0), 1f0))
    # For 2d primitives normal is just the upvector
    @test m.normal == [Vec3f(0, 0, 1) for p in coordinates(m)]
end

@testset "mesh conversion" begin
    s = Sphere(Point3(0.0), 1.0)
    m = GeometryBasics.mesh(s)
    @test m isa Mesh{3, Float64}
    @test coordinates(m) isa Vector{Point{3, Float64}}
    @test GeometryBasics.faces(m) isa Vector{GLTriangleFace}
    # Check, that decompose isn't making a copy for matching eltype
    @test coordinates(m) === decompose(Point{3, Float64}, m)

    tmesh = triangle_mesh(m)
    @test coordinates(tmesh) === decompose(Point3f, tmesh)

    nmesh = normal_mesh(m)
    @test coordinates(nmesh) === decompose(Point3f, nmesh)
    @test GeometryBasics.normals(nmesh) === decompose_normals(nmesh)

    m = GeometryBasics.mesh(s, pointtype=Point3f)
    @test m isa Mesh{3, Float32}
    @test coordinates(m) isa Vector{Point3f}
    @test GeometryBasics.faces(m) isa Vector{GLTriangleFace}
end

@testset "Lines" begin
    a = Line(Point(0.0, 0.0), Point(4.0, 1.0))
    b = Line(Point(0.0, 0.25), Point(3.0, 0.25))
    c = Line(Point(0.0, 0.25), Point(0.5, 0.25))
    d = Line(Point(0.0, 0.0), Point(0.0, 4.0))
    e = Line(Point(1.0, 0.0), Point(0.0, 4.0))
    f = Line(Point(5.0, 0.0), Point(6.0, 0.0))

    multi_line = [a,b,c,d,e,f]
    @test coordinates(multi_line) == vcat([[x.points...] for x in multi_line]...)

    @testset "intersects" begin
        @test intersects(a, b) === (true, Point(1.0, 0.25))
        @test intersects(a, c) === (false, Point(0.0, 0.0))
        @test intersects(d, d) === (false, Point(0.0, 0.0))
        found, point = intersects(d, e)
        @test found && point ≈ Point(0.0, 4.0)
        @test intersects(a, f) === (false, Point(0.0, 0.0))
        @test intersects(a, d) === (true, Point(0.0, 0.0))
        @test intersects(a, d, eps = 1e-6) === (false, Point(0.0, 0.0))

        # issue #168
        # If these tests fail then you can increase the tolerance on the checks so
        # long as you know what you're doing :)
        line_helper(a, b, c, d) = Line(Point(a, b), Point(c, d))
        b, loc = intersects(line_helper(-3.1, 15.588457268119894, 3.1, 15.588457268119894),
                            line_helper(2.0866025403784354, 17.37050807568877, -4.0866025403784505, 13.806406460551015))
        @test b
        @test loc ≈ Point(-1.0000000000000058, 15.588457268119894)

        b, loc = intersects(line_helper(5743.933982822018, 150.0, 5885.355339059327, -50.0),
                            line_helper(5760.0, 100.0, 5760.0, 140.0))
        @test b
        @test loc ≈ Point(5760.0, 127.27922061357884)
    end

    ps = [Point2f(1), Point2f(2)]
    @test GeometryBasics.simple_concat(ps, 2:2, Point2f(3)) == [Point2f(2), Point2f(3)]
    ps = [Point2f(i) for i in 1:4]
    @test collect(GeometryBasics.consecutive_pairs(ps)) == collect(zip(ps[1:end-1], ps[2:end]))

    ps = Point2f[(0,0), (1,0), (0,1), (1,2), (0,2), (1,1), (0,0)]
    idxs, ips = GeometryBasics._self_intersections(ps)
    @test idxs == [(2, 6), (3, 5)]
    @test ips == [Point2f(0.5), Point2f(0.5, 1.5)]
    idxs2, ips2 = self_intersections(ps)
    @test ips2 == ips
    @test idxs2 == [2, 6, 3, 5]

    ps = [Point2f(cos(x), sin(x)) for x in 0:4pi/5:4pi+0.1]
    idxs, ips = GeometryBasics._self_intersections(ps)
    @test idxs == [(1, 3), (1, 4), (2, 4), (2, 5), (3, 5)]
    @test all(ips .≈ Point2f[(0.30901694, 0.2245140), (-0.118034005, 0.36327127), (-0.38196602, 0), (-0.118033946, -0.3632713), (0.309017, -0.22451389)])
    idxs2, ips2 = self_intersections(ps)
    @test ips2 == ips
    @test idxs2 == [1, 3, 1, 4, 2, 4, 2, 5, 3, 5]

    @test_throws ErrorException split_intersections(ps)
    ps = Point2f[(0,0), (1,0), (0,1), (1,1), (0, 0)]
    idxs, ips = GeometryBasics._self_intersections(ps)
    sps = split_intersections(ps)
    @test sps[1] == [ps[3], ps[4], ips[1]]
    @test sps[2] == [ps[5], ps[1], ps[2], ips[1]]
end



@testset "Offsetintegers" begin
    x = 1
    @test GeometryBasics.raw(x) isa Int
    @test GeometryBasics.value(x) == x

    x = ZeroIndex(1)
    @test eltype(x) == Int

    x = OffsetInteger{0}(1)
    @test typeof(x) == OffsetInteger{0,Int}

    for x1 in [OffsetInteger{0}(2), 2, 0x02]
        @test Base.to_index(x1) == 2
        @test -(x1)    == OffsetInteger{0,Int}(-2)
        @test abs(x1)  == OffsetInteger{0,Int}(2)
        for x in [OffsetInteger{0}(1), 1, 0x01]
            @test +(x, x1) == OffsetInteger{0,Int}(3)
            @test *(x, x1) == OffsetInteger{0,Int}(2)
            @test -(x, x1) == OffsetInteger{0,Int}(-1)
            #test for /
            @test div(x, x1) == OffsetInteger{0,Int}(0)
            @test !==(x, x1)
            @test !>=(x, x1)
            @test <=(x, x1)
            @test !>(x, x1)
            @test <(x, x1)
        end
    end
end

@testset "Tests from GeometryTypes" begin
    include("geometrytypes.jl")
end

@testset "Rectangles and Bounding Boxes" begin
    include("rectangles.jl")
end

@testset "Point & Vec type" begin
    include("fixed_arrays.jl")
end

@testset "Some mesh issues" begin
    include("meshes.jl")
end

@testset "GeoInterface" begin
    include("geointerface.jl")
end

@testset "Deprecations" begin
    # https://github.com/JuliaLang/julia/issues/38780
    # @test_warn Tesselation(Rect2f(0, 0, 2, 2), 10)
    @test Tesselation(Rect2f(0, 0, 2, 2), 10) ==  Tessellation(Rect2f(0, 0, 2, 2), 10)
end

include("polygons.jl")

using Aqua
# Aqua tests
# Intervals brings a bunch of ambiquities unfortunately
# seems like we also run into https://github.com/JuliaTesting/Aqua.jl/issues/86
# Aqua.test_ambiguities([GeometryBasics, Base, Core])
# Aqua.test_unbound_args(GeometryBasics)
Aqua.test_undefined_exports(GeometryBasics)
Aqua.test_project_extras(GeometryBasics)
Aqua.test_stale_deps(GeometryBasics, ignore = [:PrecompileTools])
Aqua.test_deps_compat(GeometryBasics)
Aqua.test_piracies(GeometryBasics)
Aqua.test_persistent_tasks(GeometryBasics)

end  # testset "GeometryBasics"

const Point1{T} = Point{1,T}
export Point1
const Point1d = Point1{Float64}
export Point1d
const Point1f = Point1{Float32}
export Point1f
const Point1i = Point1{Int64}
export Point1i
const Point1ui = Point1{UInt64}
export Point1ui
const Vec1{T} = Vec{1,T}
export Vec1
const Vec1d = Vec1{Float64}
export Vec1d
const Vec1f = Vec1{Float32}
export Vec1f
const Vec1i = Vec1{Int64}
export Vec1i
const Vec1ui = Vec1{UInt64}
export Vec1ui
const Mat1{T} = Mat{1,1,T,1}
export Mat1
const Mat1d = Mat1{Float64}
export Mat1d
const Mat1f = Mat1{Float32}
export Mat1f
const Mat1i = Mat1{Int64}
export Mat1i
const Mat1ui = Mat1{UInt64}
export Mat1ui
const Point2{T} = Point{2,T}
export Point2
const Point2d = Point2{Float64}
export Point2d
const Point2f = Point2{Float32}
export Point2f
const Point2i = Point2{Int64}
export Point2i
const Point2ui = Point2{UInt64}
export Point2ui
const Vec2{T} = Vec{2,T}
export Vec2
const Vec2d = Vec2{Float64}
export Vec2d
const Vec2f = Vec2{Float32}
export Vec2f
const Vec2i = Vec2{Int64}
export Vec2i
const Vec2ui = Vec2{UInt64}
export Vec2ui
const Mat2{T} = Mat{2,2,T,4}
export Mat2
const Mat2d = Mat2{Float64}
export Mat2d
const Mat2f = Mat2{Float32}
export Mat2f
const Mat2i = Mat2{Int64}
export Mat2i
const Mat2ui = Mat2{UInt64}
export Mat2ui
const Point3{T} = Point{3,T}
export Point3
const Point3d = Point3{Float64}
export Point3d
const Point3f = Point3{Float32}
export Point3f
const Point3i = Point3{Int64}
export Point3i
const Point3ui = Point3{UInt64}
export Point3ui
const Vec3{T} = Vec{3,T}
export Vec3
const Vec3d = Vec3{Float64}
export Vec3d
const Vec3f = Vec3{Float32}
export Vec3f
const Vec3i = Vec3{Int64}
export Vec3i
const Vec3ui = Vec3{UInt64}
export Vec3ui
const Mat3{T} = Mat{3,3,T,9}
export Mat3
const Mat3d = Mat3{Float64}
export Mat3d
const Mat3f = Mat3{Float32}
export Mat3f
const Mat3i = Mat3{Int64}
export Mat3i
const Mat3ui = Mat3{UInt64}
export Mat3ui
const Point4{T} = Point{4,T}
export Point4
const Point4d = Point4{Float64}
export Point4d
const Point4f = Point4{Float32}
export Point4f
const Point4i = Point4{Int64}
export Point4i
const Point4ui = Point4{UInt64}
export Point4ui
const Vec4{T} = Vec{4,T}
export Vec4
const Vec4d = Vec4{Float64}
export Vec4d
const Vec4f = Vec4{Float32}
export Vec4f
const Vec4i = Vec4{Int64}
export Vec4i
const Vec4ui = Vec4{UInt64}
export Vec4ui
const Mat4{T} = Mat{4,4,T,16}
export Mat4
const Mat4d = Mat4{Float64}
export Mat4d
const Mat4f = Mat4{Float32}
export Mat4f
const Mat4i = Mat4{Int64}
export Mat4i
const Mat4ui = Mat4{UInt64}
export Mat4ui

"""
    TupleView{T, N, Skip, A}

TupleView, groups elements of an array as tuples.
N is the dimension of the tuple, M tells how many elements to skip to the next tuple.
By default TupleView{N} defaults to skip N items.
# a few examples:

```julia

x = [1, 2, 3, 4, 5, 6]
TupleView{2, 1}(x):
> [(1, 2), (2, 3), (3, 4), (4, 5), (5, 6)]

TupleView{2}(x):
> [(1, 2), (3, 4), (5, 6)]

TupleView{2, 3}(x):
> [(1, 2), (4, 5)]

TupleView{3, 1}(x):
> [(1, 2, 3), (2, 3, 4), (3, 4, 5), (4, 5, 6)]
```

TupleView can be used together with reinterpret:

```julia
x = [1, 2, 3, 4]
y = reinterpret(Point{2, Int}, TupleView{2, 1}(x))
> [Point(1, 2), Point(2, 3), Point(3, 4)]
```

"""
struct TupleView{T,N,Skip,A} <: AbstractVector{T}
    data::A
    connect::Bool
end

coordinates(tw::TupleView) = coordinates(tw.data)

function Base.size(x::TupleView{T,N,M}) where {T,N,M}
    nitems = length(x.data) ÷ (N - (N - M))
    nitems = nitems - max(N - M, 0)
    return (nitems + x.connect,) # plus one item if we connect
end

function Base.getindex(x::TupleView{T,N,M}, index::Integer) where {T,N,M}
    return ntuple(i -> x.data[mod1(((index - 1) * M) + i, length(x.data))], N)
end

function TupleView{N}(x::AbstractVector; connect=false) where {N}
    return TupleView{N,N}(x, connect=connect)
end

function TupleView{N,M}(x::AbstractVector{T}; connect=false) where {T,N,M}
    return TupleView{NTuple{N,T},N,M,typeof(x)}(x, connect)
end

"""
    connect(points::AbstractVector{<: Point}, P::Type{<: Polytope{N}}, skip::Int = N)

Creates a view that connects a number of points to a Polytope `P`.
Between each polytope, `skip` elements are skipped until the next starts.
Example:
```julia
x = connect(Point[(1, 2), (3, 4), (5, 6), (7, 8)], Line, 2)
x == [Line(Point(1, 2), Point(3, 4)), Line(Point(5, 6), Point(7, 8))]
"""
function connect(points::AbstractVector{Point},
                         P::Type{<:Polytope{N,T} where {N,T}},
                         skip::Int=length(P)) where {Point <: Point}
    return map(Polytope(P, Point), TupleView{length(P),skip}(points))
end

function connect(points::AbstractVector{T}, ::Type{<:Point{N}}, skip::Int=N) where {T <: Real,N}
    return connect(points, Point{N, T}, skip)
end
function connect(points::AbstractVector{_T}, ::Type{<:Point{N, T}}, skip::Int=N) where {T <: Real, N, _T <: Real}
    return map(Point{N,T}, TupleView{N,skip}(points))
end

function connect(indices::AbstractVector{T}, P::Type{<:AbstractFace{N}},
                         skip::Int=N) where {T <: Integer, N}
    return connect(indices, Face(P, T), skip)
end
function connect(indices::AbstractVector{_T}, P::Type{<:AbstractFace{N, T}},
                         skip::Int=N) where {T <: Integer, N, _T <: Integer}
    return collect(reinterpret(Face(P, T), TupleView{N, skip}(indices)))
end

function connect(points::AbstractMatrix{T}, ::Type{<:Point{N}}) where {T <: Real, N}
    return connect(points, Point{N, T})
end
function connect(points::AbstractMatrix{_T}, P::Type{Point{N, T}}) where {T <: Real, N, _T <: Real}
    return if size(points, 1) === N
        return reinterpret(Point{N,T}, points)
    elseif size(points, 2) === N
        seglen = size(points, 1)
        columns = ntuple(N) do i
            return view(points, ((i - 1) * seglen + 1):(i * seglen))
        end
        return P.(columns...)
    else
        error("Dim 1 or 2 must be equal to the point dimension!")
    end
end

function connect(elements::AbstractVector, faces::AbstractVector{<: AbstractFace})
    return [elements[i] for f in faces for i in f]
end

using Test, GeometryBasics
using IntervalSets: (..)

@testset "Cylinder" begin
    @testset "constructors" begin
        v1 = rand(Point{3,Float64})
        v2 = rand(Point{3,Float64})
        R = rand()
        s = Cylinder(v1, v2, R)
        @test typeof(s) == Cylinder{Float64}
        @test origin(s) == v1
        @test extremity(s) == v2
        @test radius(s) == R
        @test height(s) == norm(v2 - v1)
        #@test norm(direction(s) - Point{3,Float64}((v2-v1)./norm(v2-v1)))<1e-10
        @test isapprox(direction(s), (v2 - v1) ./ norm(v2 .- v1))
    end

    @testset "decompose" begin
        v1 = Point{3,Float64}(1, 2, 3)
        v2 = Point{3,Float64}(4, 5, 6)
        R = 5.0
        s = Cylinder(v1, v2, R)
        positions = Point{3,Float64}[
            (4.535533905932738, -1.5355339059327373, 3.0),
            (3.0412414523193148, 4.041241452319315, -1.0824829046386295),
            (-2.535533905932737, 5.535533905932738, 2.9999999999999996),
            (-1.0412414523193152, -0.04124145231931431, 7.0824829046386295),
            (7.535533905932738, 1.4644660940672627, 6.0),
            (6.041241452319315, 7.041241452319315, 1.9175170953613705),
            (0.46446609406726314, 8.535533905932738, 6.0),
            (1.9587585476806848, 2.9587585476806857, 10.08248290463863),
            (1, 2, 3),
            (4, 5, 6)
        ]

        @test decompose(Point3{Float64}, Tessellation(s, 8)) ≈ positions

        _faces = TriangleFace[
            (9, 2, 1), (9, 3, 2), (9, 4, 3), (9, 1, 4), (1, 2, 6), (1, 6, 5),
            (2, 3, 7), (2, 7, 6), (3, 4, 8), (3, 8, 7), (4, 1, 5), (4, 5, 8),
            (10, 5, 6), (10, 6, 7), (10, 7, 8), (10, 8, 5)]

        @test _faces == decompose(TriangleFace{Int}, Tessellation(s, 8))

        m = triangle_mesh(Tessellation(s, 8))
        @test m === triangle_mesh(m)
        @test GeometryBasics.faces(m) == decompose(GLTriangleFace, _faces)
        @test GeometryBasics.coordinates(m) ≈ positions

        m = normal_mesh(s) # just test that it works without explicit resolution parameter
        @test hasproperty(m, :position)
        @test hasproperty(m, :normal)
        @test length(faces(m)) == length(faces(m.normal))
        @test faces(m) isa AbstractVector{GLTriangleFace}
        @test faces(m.normal) isa AbstractVector{GLTriangleFace}

        ns = GeometryBasics.FaceView(
            Vec{3, Float32}[
                [0.70710677, -0.70710677, 0.0], [0.4082483, 0.4082483, -0.8164966],
                [-0.70710677, 0.70710677, -9.9991995f-17], [-0.4082483, -0.4082483, 0.8164966],
                [-0.57735026, -0.57735026, -0.57735026], [0.57735026, 0.57735026, 0.57735026]
            ], [
                GLTriangleFace(5, 5, 5), GLTriangleFace(5, 5, 5),
                GLTriangleFace(5, 5, 5), GLTriangleFace(5, 5, 5),
                QuadFace{Int64}(1, 2, 2, 1), QuadFace{Int64}(2, 3, 3, 2),
                QuadFace{Int64}(3, 4, 4, 3), QuadFace{Int64}(4, 1, 1, 4),
                GLTriangleFace(6, 6, 6), GLTriangleFace(6, 6, 6),
                GLTriangleFace(6, 6, 6), GLTriangleFace(6, 6, 6)
            ]
        )

        @test ns == decompose_normals(Tessellation(s, 8))

        muv = uv_mesh(s)
        @test !hasproperty(muv, :uv) # not defined yet
    end
end

@testset "HyperRectangles" begin
    @testset "Constructors" begin
        # TODO: Do these actually make sense?
        # Should they not be Rect(NaN..., 0...)?
        @testset "Empty Constructors" begin
            for constructor in [Rect, Rect{2}, Rect2, RectT, Rect2f]
                @test constructor() == Rect{2, Float32}(Inf, Inf, -Inf, -Inf)
            end
            for constructor in [Rect{3}, Rect3, Rect3f]
                @test constructor() == Rect{3, Float32}((Inf, Inf, Inf), (-Inf, -Inf, -Inf))
            end

            for T in [UInt32, Int16, Float64]
                a = typemax(T)
                b = typemin(T)
                for constructor in [Rect{2, T}, Rect2{T}, RectT{T, 2}]
                    @test constructor() == Rect{2, T}(a, a, b, b)
                end
                for constructor in [Rect{3, T}, Rect3{T}, RectT{T, 3}]
                    @test constructor() == Rect{3, T}(Point(a, a, a), Vec(b, b, b))
                end
            end
        end

        @testset "Constructor arg conversions" begin
            function expected_rect(::Type{<: Rect}, arg1, arg2)
                return Rect{min(length(arg1), length(arg2)), promote_type(eltype(arg1), eltype(arg2))}(arg1, arg2)
            end
            function expected_rect(::Type{<: Rect{N}}, arg1, arg2) where {N}
                return Rect{N, promote_type(eltype(arg1), eltype(arg2))}(arg1, arg2)
            end
            function expected_rect(::Type{<: Rect{N, T}}, arg1, arg2) where {N, T}
                return Rect{N, T}(arg1, arg2)
            end

            @testset "2D args -> 2D Rect" begin
                for constructor in [Rect, RectT,   Rect2, Rect{2}, RectT{Int32},
                                    Rect2f, Rect{2, Float16}, Rect2{UInt32}, RectT{Float64, 2}]
                    @testset "$constructor" begin
                        @test constructor(1,2,3,4)           == expected_rect(constructor, Point(1,2), Vec(3,4))
                        @test constructor(1.0,2,3,4)         == expected_rect(constructor, Point(1.0,2), Vec(3,4))
                        @test constructor(Point2f(1,2),3,4)  == expected_rect(constructor, Point2f(1,2), Vec(3,4))
                        @test constructor(Vec2(1,2),3,4.0)   == expected_rect(constructor, Point(1,2), Vec(3,4.0))
                        @test constructor((1,2),Point2(3,4)) == expected_rect(constructor, Point(1,2), Vec(3,4))
                        @test constructor(1.0,2,Vec2(3,4))   == expected_rect(constructor, Point(1,2), Vec(3,4))
                        @test_throws ArgumentError constructor(1,2,3)
                    end
                end
            end

            @testset "3D args -> 3D Rect" begin
                for constructor in [Rect, RectT,   Rect3, Rect{3}, RectT{Float64},
                                    Rect3d, Rect{3, Int16}, Rect3{UInt8}, RectT{Float32, 3}]
                    @testset "$constructor" begin
                        @test constructor(1,2,3,4,5,6)           == expected_rect(constructor, Point(1,2,3), Vec(4,5,6))
                        @test constructor(1,2,3,4,5,6.0)         == expected_rect(constructor, Point(1,2,3), Vec(4,5,6.0))
                        @test constructor(1,2.0,3,Vec3f(4,5,6))  == expected_rect(constructor, Point(1,2,3), Vec3f(4,5,6))
                        @test constructor(Vec3(1,2,3),4,5,6)     == expected_rect(constructor, Point3(1,2,3), Vec(4,5,6))
                        @test constructor((1,2,3),Point3(4,5,6)) == expected_rect(constructor, Point(1,2,3), Vec(4,5,6))
                        @test constructor(Vec3(1,2,3),4,5,6)     == expected_rect(constructor, Point(1,2,3), Vec(4,5,6))
                        @test_throws ArgumentError constructor(1,2,3)
                    end
                end
            end
        end

        @testset "Copy Constructors" begin
            r = Rect2i(0,0,1,1)
            for constructor in [Rect, Rect2f, Rect3f, RectT{Float64}]
                @test constructor(r) == constructor(Point2(0), Vec2(1))
            end
        end

        @testset "Special Constructors" begin
            @test Rect3f((1, 2, 3, Vec(1,2,3))) == Rect3f(1,2,3, Vec(1,2,3))
            @test Rect2(((1, 2), 3, 4)) == Rect2f((1,2), 3, 4)
            @test Rect((1, 2, 3, 4)) == Rect2f(1, 2, 3, 4)
            @test Rect2((x = 1, y = 2), (width = 3, height = 4)) == Rect2f(1, 2, 3, 4)

            for constructor in [Rect, RectT,   Rect2, Rect{2}, RectT{Float32},
                                Rect2f, Rect{2, Float16}, Rect2{Float16}, RectT{Float64, 2}]
                @test centered(constructor) == constructor(Point2d(-0.5), Vec2d(1))
            end
            for constructor in [Rect3, Rect{3}, Rect3d, Rect{3, Float16}, Rect3{Float64}, RectT{Float32, 3}]
                @test centered(constructor) == constructor(Point3d(-0.5), Vec3d(1))
            end
        end

        @testset "Boundingbox-like" begin
            for constructor in [Rect, Rect{2}, Rect{2, Float32}, Rect3f]
                @test constructor(Circle(Point2f(0), 1f0))              == constructor(Point2f(-1, -1), Vec2f(2, 2))
                @test constructor(Rect2f(0, 0, 1, 1))                   == constructor(Point2f( 0,  0), Vec2f(1, 1))
                m = GeometryBasics.mesh(Tessellation(Circle(Point2f(0), 1f0), 5))
                @test constructor(m)                                     ≈ constructor(Point2f(-1, -1), Vec2f(2, 2))
            end
            for constructor in [Rect, Rect{3}, Rect{3, Float32}]
                @test constructor(Sphere(Point3f(0), 1f0))                          == Rect3f(-1, -1, -1, 2, 2, 2)
                @test constructor(Rect3f(0, 0, 0, 1, 1, 1))                         == Rect3f(0, 0, 0, 1, 1, 1)
                @test constructor(Cylinder(Point3f(0, 0, -1), Point3f(0,0,1), 1f0))  ≈ Rect3f(-1, -1, -1, 2, 2, 2) atol = 0.05
                @test constructor(Pyramid(Point3f(0, 0, -1), 2f0, 2f0))             == Rect3f(-1, -1, -1, 2, 2, 2)
                m = GeometryBasics.mesh(Tessellation(Sphere(Point3f(0), 1f0), 5))
                @test constructor(m)                                                 ≈ Rect3f(-1, -1, -1, 2, 2, 2)
            end
        end

        @testset "From intervals" begin
            # 1D interval
            @test HyperRectangle(1..3) == Rect{1, Float64}(Point(1.0), Vec(2.0))
            # 2D intervals
            @test HyperRectangle(0..2, -1..1) == Rect{2, Float64}(Point(0.0, -1.0), Vec(2.0, 2.0))
            # different interval eltypes
            @test HyperRectangle(0.0..2.0, -1..1) == Rect{2, Float64}(Point(0.0, -1.0), Vec(2.0, 2.0))
            # N-typed constructor
            @test HyperRectangle{2}(0..2, -1..1) == HyperRectangle(0..2, -1..1)
            # Rect constructor:
            @test Rect(1..3, 4..5) == Rect{2, Float64}(Point(1.0, 4.0), Vec(2.0, 1.0))
            @test Rect{2, Float64}(1..3, 4..5) == Rect{2, Float64}(Point(1.0, 4.0), Vec(2.0, 1.0))
        end
    end

    # TODO: consider deprecating this
    @testset "Integer rounding" begin
        @test Rect2i(0.3, 0.4, 0.6, 0.5) == Rect2i(0,0,1,0)
        @test Rect2{UInt32}(0.8, 0.1, 1.3, 1.9) == Rect2i(1,0,1,2)
        @test Rect3i(0.3, 0.6, 0.9, 1.2, 1.5, 1.8) == Rect3i(0,1,1,1,2,2)
    end
    @testset "Vector inputs" begin
        @test Rect([1,2], [2,3]) == Rect2i(1,2,2,3)
        @test Rect2f([0,1], [2,3]) == Rect2f(0,1,2,3)
        @test RectT{Float64}([0,1,0], [2,2,2]) == Rect3d(0,1,0, 2,2,2)
        @test Rect3([0,1,0], [2,2,2]) == Rect3i(0,1,0, 2,2,2)
    end

    # TODO: These don't really make sense...
    r = Rect2f()
    @test origin(r) == Vec(Inf, Inf)
    @test minimum(r) == Vec(Inf, Inf)
    @test isnan(maximum(r))
    @test width(r) == -Inf
    @test height(r) == -Inf
    @test widths(r) == Vec(-Inf, -Inf)
    @test area(r) == Inf
    @test volume(r) == Inf
    # TODO: broken? returns NaN widths
    # @test union(r, Rect2f(1,1,2,2)) == Rect2f(1,1,2,2)
    # @test union(Rect2f(1,1,2,2), r) == Rect2f(1,1,2,2)
    @test update(r, Vec2f(1,1)) == Rect2f(1,1,0,0)

    a = Rect(Vec(0, 1), Vec(2, 3))
    pt_expa = Point{2,Int}[(0, 1), (2, 1), (2, 4), (0, 4)]
    @test decompose(Point{2,Int}, a) == pt_expa
    mesh = normal_mesh(a)
    @test decompose(Point2f, mesh) == pt_expa

    @test origin(a) == Vec(0,1)
    @test minimum(a) == Vec(0,1)
    @test maximum(a) == Vec(2,4)
    @test width(a) == 2
    @test height(a) == 3
    @test widths(a) == Vec(2,3)
    @test area(a) == 2*3
    @test volume(a) == 2*3
    @test union(a, Rect2f(1,1,2,2)) == Rect2f(0,1,3,3)
    @test union(Rect2f(1,1,2,2), a) == Rect2f(0,1,3,3)
    @test update(a, Vec2f(0,0)) == Rect2f(0,0,2,4)

    b = Rect(Vec(1, 2, 3), Vec(4, 5, 6))
    pt_expb = Point{3, Int64}[[1, 2, 3], [1, 2, 9], [1, 7, 3], [1, 7, 9],
                              [5, 2, 3], [5, 2, 9], [5, 7, 3], [5, 7, 9]]
    @test decompose(Point{3,Int}, b) == pt_expb

    @test origin(b) == Vec(1,2,3)
    @test minimum(b) == Vec(1,2,3)
    @test maximum(b) == Vec(5,7,9)
    @test width(b) == 4
    @test height(b) == 5
    @test widths(b) == Vec(4,5,6)
    @test_throws MethodError area(b)
    @test volume(b) == 4*5*6
    @test union(b, Rect3f(1,1,1,2,2,2)) == Rect3f(1,1,1, 4,6,8)
    @test union(Rect3f(1,1,1,2,2,2), b) == Rect3f(1,1,1, 4,6,8)
    @test update(b, Vec3f(0)) == Rect3f(0,0,0,5,7,9)


    mesh = normal_mesh(b)
    @test faces(mesh) == GLTriangleFace[
        (1, 2, 4), (1, 4, 3), (7, 8, 6), (7, 6, 5), (5, 6, 2), (5, 2, 1),
        (3, 4, 8), (3, 8, 7), (1, 3, 7), (1, 7, 5), (6, 8, 4), (6, 4, 2)]
    @test normals(mesh) == GeometryBasics.FaceView(
        Vec{3, Float32}[[-1.0, 0.0, 0.0], [1.0, 0.0, 0.0], [0.0, -1.0, 0.0], [0.0, 1.0, 0.0], [0.0, 0.0, -1.0], [0.0, 0.0, 1.0]],
        GLTriangleFace[(1, 1, 1), (1, 1, 1), (2, 2, 2), (2, 2, 2), (3, 3, 3), (3, 3, 3), (4, 4, 4), (4, 4, 4), (5, 5, 5), (5, 5, 5), (6, 6, 6), (6, 6, 6)]
    )
    @test coordinates(mesh) == Point{3, Float32}[
        [1, 2, 3], [1, 2, 9], [1, 7, 3], [1, 7, 9],
        [5, 2, 3], [5, 2, 9], [5, 7, 3], [5, 7, 9]]

    @test isempty(Rect{3,Float32}())
end

@testset "Pyramids" begin
    p = Pyramid(Point3f(0), 1f0, 0.2f0)
    @test coordinates(p) == Point3f[[0.0, 0.0, 1.0], [0.1, -0.1, 0.0], [0.1, 0.1, 0.0], [-0.1, 0.1, 0.0], [-0.1, -0.1, 0.0]]
    @test faces(p) == [GLTriangleFace(1, 2, 3), GLTriangleFace(1, 3, 4), GLTriangleFace(1, 4, 5), GLTriangleFace(1, 5, 2), QuadFace{Int64}(2, 3, 4, 5)]
    ns = normals(p)
    @test faces(ns) == [GLTriangleFace(1), GLTriangleFace(2), GLTriangleFace(3), GLTriangleFace(4), QuadFace{Int64}(5)]
    @test values(ns) ≈ Vec3f[[0.9805807, 0.0, 0.19611615], [0.0, 0.9805807, 0.19611615], [-0.9805807, 0.0, 0.19611615], [0.0, -0.9805807, 0.19611615], [0.0, 0.0, -1.0]]
end

@testset "Type Utils" begin
    @test GeometryBasics.Face(TriangleFace, Int32) == TriangleFace{Int32}
    @test GeometryBasics.Face(GLTriangleFace, Int32) == TriangleFace{GLIndex}
end

@testset "Faces" begin
    @test convert_simplex(GLTriangleFace, QuadFace{Int}(1, 2, 3, 4)) ==
          (GLTriangleFace(1, 2, 3), GLTriangleFace(1, 3, 4))
    @test convert_simplex(NgonFace{3,ZeroIndex{Int}}, QuadFace{ZeroIndex{Int}}(1, 2, 3, 4)) ==
          (NgonFace{3,ZeroIndex{Int}}(1, 2, 3), NgonFace{3,ZeroIndex{Int}}(1, 3, 4))
    @test convert_simplex(NgonFace{3,OffsetInteger{3,Int}},
                          NgonFace{4,OffsetInteger{2,Int}}(1, 2, 3, 4)) ==
          (NgonFace{3,OffsetInteger{3,Int}}(1, 2, 3), NgonFace{3,OffsetInteger{3,Int}}(1, 3, 4))
    @test convert_simplex(LineFace{Int}, QuadFace{Int}(1, 2, 3, 4)) ==
          (LineFace{Int}(1, 2), LineFace{Int}(2, 3), LineFace{Int}(3, 4),
           LineFace{Int}(4, 1))

    @testset "NgonFace ambiguity" begin
        face = NgonFace((1, 2))
        @test convert_simplex(NgonFace{2,UInt32}, face) === (NgonFace{2,UInt32}((1, 2)),)
        @test convert_simplex(typeof(face), face) === (face,)
        face = NgonFace((1,))
        @test convert_simplex(NgonFace{1,UInt32}, face) === (NgonFace{1,UInt32}((1,)),)
        @test convert_simplex(typeof(face), face) === (face,)
    end

    ps = rand(Point2f, 10)
    f = GLTriangleFace(1, 2, 3)
    @test ps[f] == GeometryBasics.@SVector [ps[1], ps[2], ps[3]]

    data = [string(i) for i in 1:10]
    f = QuadFace(3, 4, 7, 8)
    @test data[f] == ["3", "4", "7", "8"]

    @test (f .== 4) == QuadFace(false, true, false, false)
    @test f[f .== 4] isa Vector{Int}
    @test f[f .== 4] == [4]

    @test GeometryBasics.cyclic_hash(f) != GeometryBasics.cyclic_hash(QuadFace(1,2,3,4))
    @test GeometryBasics.cyclic_hash(f) == GeometryBasics.cyclic_hash(QuadFace(3,4,7,8))
    # cyclic permutation does not change the face
    @test GeometryBasics.cyclic_hash(f) == GeometryBasics.cyclic_hash(QuadFace(7,8,3,4))
    @test GeometryBasics.cyclic_hash(GLTriangleFace(1,2,3)) == GeometryBasics.cyclic_hash(GLTriangleFace(1,2,3))
    @test GeometryBasics.cyclic_hash(GLTriangleFace(1,2,3)) == GeometryBasics.cyclic_hash(GLTriangleFace(2,3,1))
    @test GeometryBasics.cyclic_hash(GLTriangleFace(1,2,3)) == GeometryBasics.cyclic_hash(GLTriangleFace(3,1,2))

    # repeat with cyclic_equal
    @test !GeometryBasics.cyclic_equal(f, QuadFace(1,2,3,4))
    @test GeometryBasics.cyclic_equal(f, QuadFace(3,4,7,8))
    @test GeometryBasics.cyclic_equal(f, QuadFace(7,8,3,4))
    @test GeometryBasics.cyclic_equal(GLTriangleFace(1,2,3), GLTriangleFace(1,2,3))
    @test GeometryBasics.cyclic_equal(GLTriangleFace(1,2,3), GLTriangleFace(2,3,1))
    @test GeometryBasics.cyclic_equal(GLTriangleFace(1,2,3), GLTriangleFace(3,1,2))
end

@testset "FaceView" begin
    ps = rand(Point2f, 5)
    fs = GLTriangleFace[(1,2,3), (2,3,4), (5,5,5)]
    fv = FaceView(ps, fs)
    @test faces(fv) == fs
    @test values(fv) == ps
    @test fv[fs[1]] == ps[fs[1]]
    @test !isempty(fv)
    @test fv == FaceView(ps, fs)
    @test length(fv) == 5
end

@testset "orthogonal_vector" begin
    tri = Triangle(Point3d(0,0,0), Point3d(1,0,0), Point3d(0,1,0))
    @test GeometryBasics.orthogonal_vector(tri) === Vec3d(0,0,1)
    @test GeometryBasics.orthogonal_vector(collect(coordinates(tri))) === Vec3d(0,0,1)
    @test GeometryBasics.orthogonal_vector(Vec3f, tri) === Vec3f(0,0,1)
    @test GeometryBasics.orthogonal_vector(Vec3f, collect(coordinates(tri))) === Vec3f(0,0,1)

    quad = GeometryBasics.Quadrilateral(Point2i(0,0), Point2i(1,0), Point2i(1,1), Point2i(0,1))
    @test GeometryBasics.orthogonal_vector(quad) === Vec3i(0,0,2)
    @test GeometryBasics.orthogonal_vector(collect(coordinates(quad))) === Vec3i(0,0,2)
    @test GeometryBasics.orthogonal_vector(Vec3d, quad) === Vec3d(0,0,2)
    @test GeometryBasics.orthogonal_vector(Vec3d, collect(coordinates(quad))) === Vec3d(0,0,2)

    t = (Point3f(0), Point3f(1,0,1), Point3f(0,1,0))
    @test GeometryBasics.orthogonal_vector(t) == Vec3f(-1,0,1)
    @test GeometryBasics.orthogonal_vector(Vec3i, t) == Vec3i(-1,0,1)

    t = Point2f[(0,0), (1,0), (2,1), (1,2), (0,2), (-1, 1)]
    @test GeometryBasics.orthogonal_vector(Vec3f, t) == Vec3f(0,0,8)

    # Makie uses this syntax
    @test GeometryBasics.orthogonal_vector(Point3f(0), Point3f(1,0,1), Point3f(0,1,0)) == Vec3f(-1,0,1)
    @test GeometryBasics.orthogonal_vector((1,2,3), (2,3,1), (3,1,2)) == Vec3f(-3.0)

    # Maybe the ::Any fallback is too generic...?
    struct TestType
        data::Vector{Vec3f}
    end
    GeometryBasics.coordinates(x::TestType) = x.data
    x = TestType([Point3f(1,1,1), Point3f(0,0,0), Point3f(0.5,0,0)])
    @test GeometryBasics.orthogonal_vector(x) == Vec3f(0, -0.5, 0.5)

    @testset "Float Precision" begin
        # Collection of risky triangles
        tris = [
            # with 0s that remove terms from cross(a-b, c-b)
            (Point3f(-10.180012, 9.928894, 63.42825), Point3f(-10.180012, 9.92804, 63.424137), Point3f(-10.181978, 9.92804, 63.42825)),
            (Point3f(-11.75692, 6.245064, 86.05223), Point3f(-11.758429, 6.245064, 86.048584), Point3f(-11.758429, 6.2428894, 86.05223)),
            (Point3f(52.430557, 13.611008, 7.657501), Point3f(52.43055, 13.611008, 7.6574783), Point3f(52.43055, 13.611008, 7.657501)),
            (Point3f(52.430557, 13.611008, 7.657501), Point3f(52.43055, 13.611008, 7.657501), Point3f(52.45581, 13.61525, 8.18364)),
            # tiny shift
            (Point3f(1, 1 + 1e-4, 1), Point3f(1 + 1e-4, 1 + 1e-4, 1 - 1e-4), Point3f(1 - 1e-4, 1, 1 + 1e-4))
        ]

        for tri in tris
            a, b, c = tri
            n64 = Vec3f(cross(Point3d(b) - Point3d(a), Point3d(c) - Point3d(a)))
            # fast paths
            n_fast = GeometryBasics.orthogonal_vector(Vec3f, Triangle(a, b, c))
            @test n64 ≈ n_fast
            @test n_fast == GeometryBasics.orthogonal_vector(Vec3f, (a, b, c))
            @test n_fast == GeometryBasics.orthogonal_vector(Vec3f, GeometryBasics.SVector(a, b, c)) # hit by points[face]
            n_slow = GeometryBasics.orthogonal_vector(Vec3f, TestType([a, b, c]))
            @test n_slow ≈ n64
            @test n_slow == GeometryBasics.orthogonal_vector(Vec3f, [a, b, c])
        end
    end
end

@testset "Normals" begin
    # per face normals
    r = Rect3f(Point3f(0), Vec3f(1))
    ns = face_normals(coordinates(r), faces(r))
    ux = unit(Vec3f, 1); uy = unit(Vec3f, 2); uz = unit(Vec3f, 3)
    @test ns == normals(r)
    @test values(ns) == [-ux, ux, -uy, uy, -uz, uz]

    # typing
    ux = unit(Vec3d, 1); uy = unit(Vec3d, 2); uz = unit(Vec3d, 3)
    ns = face_normals(decompose(Point3d, r), faces(r))
    @test ns isa FaceView{Vec3d}
    @test values(ns) == [-ux, ux, -uy, uy, -uz, uz]

    # Mixed
    c = Cylinder(Point3f(0), Point3f(0,0,1), 0.5f0)
    ns = normals(c)
    # caps without mantle
    f_ns = face_normals(coordinates(c), filter!(f -> f isa TriangleFace, faces(c)))
    @test all(n -> n ≈ values(ns)[end-1], values(f_ns)[1:15])
    @test all(n -> n ≈ values(ns)[end], values(f_ns)[16:end])
    # Mantle without caps
    v_ns = normals(coordinates(c), filter!(f -> f isa QuadFace, faces(c)))[1:end-2]
    @test values(ns)[1:15] ≈ v_ns[1:15]
    @test values(ns)[1:15] ≈ v_ns[16:30] # repeated via FaceView in ns

    # Planar QuadFace with colinear edge
    v = [Point3d(0,0,0),Point3d(1,0,0),Point3d(2,0,0),Point3d(2,1,0)]
    f = [QuadFace{Int}(1,2,3,4)]
    n = normals(v,f)
    @test all(n_i -> n_i ≈ [0.0,0.0,1.0], n)

    # Planar NgonFace (5-sided) with colinear edge
    v = [Point3d(0,0,0),Point3d(1,0,0),Point3d(2,0,0),Point3d(2,1,0),Point3d(2,0.5,0)]
    f = [NgonFace{5,Int}(1,2,3,4,5)]
    n = normals(v,f)
    @test all(n_i -> n_i ≈ [0.0,0.0,1.0], n)

    # Non-planar NgonFace (6 sided), features equal up and down variations resulting in z-dir average face_normal
    t = range(0.0, 2*pi-(2*pi)/6, length = 6)
    v = [Point{3,Float64}(cos(t[i]),sin(t[i]),iseven(i)) for i in eachindex(t)]
    f = [NgonFace{6,Int}(1,2,3,4,5,6)]
    n = normals(v,f)
    @test all(n_i -> n_i ≈ [0.0,0.0,1.0], n)
end

@testset "HyperSphere" begin
    sphere = Sphere{Float32}(Point3f(0), 1.0f0)

    points = decompose(Point, Tessellation(sphere, 3))
    point_target = Point{3,Float32}[[0.0, 0.0, 1.0], [1.0, 0.0, 6.12323e-17],
                                    [1.22465e-16, 0.0, -1.0], [-0.0, 0.0, 1.0],
                                    [-1.0, 1.22465e-16, 6.12323e-17],
                                    [-1.22465e-16, 1.49976e-32, -1.0], [0.0, -0.0, 1.0],
                                    [1.0, -2.44929e-16, 6.12323e-17],
                                    [1.22465e-16, -2.99952e-32, -1.0]]
    @test points ≈ point_target

    f = decompose(TriangleFace{Int}, Tessellation(sphere, 3))
    face_target = TriangleFace{Int}[[1, 2, 5], [1, 5, 4], [2, 3, 6], [2, 6, 5], [4, 5, 8],
                                    [4, 8, 7], [5, 6, 9], [5, 9, 8]]
    @test f == face_target

    uv = decompose_uv(Tesselation(sphere, 3))
    uv_target = Vec{2, Float32}[[0.0, 1.0], [0.0, 0.5], [0.0, 0.0], [0.5, 1.0], [0.5, 0.5],
                                [0.5, 0.0], [1.0, 1.0], [1.0, 0.5], [1.0, 0.0]]
    @test uv == uv_target

    @test minimum(sphere) == Point3f(-1)
    @test maximum(sphere) == Point3f(1)
    @test origin(sphere) == Point3f(0)
    @test widths(sphere) == Vec3f(2)
    @test radius(sphere) == 1f0
    @test !(Point3f(1) in sphere)
    @test Point3f(0.5) in sphere
    @test centered(HyperSphere) == Sphere(Point3f(0), 0.5f0)
    @test centered(Sphere) == Sphere(Point3f(0), 0.5f0)
    @test centered(Sphere{Float64}) == Sphere(Point3(0.0), 0.5)

    circle = Circle(Point2f(0), 1.0f0)
    points = decompose(Point2f, Tessellation(circle, 20))
    @test length(points) == 20
    tess_circle = Tessellation(circle, 32)
    mesh = triangle_mesh(tess_circle)
    @test decompose(Point2f, mesh) ≈ decompose(Point2f, tess_circle)

    @test minimum(circle) == Point2f(-1)
    @test maximum(circle) == Point2f(1)
    @test origin(circle) == Point2f(0)
    @test widths(circle) == Vec2f(2)
    @test radius(circle) == 1f0
    @test !(Point2f(-1) in circle)
    @test Point2f(-0.5) in circle
    @test centered(Circle) == Circle(Point2f(0), 0.5f0)
    @test centered(Circle{Float64}) == Circle(Point2(0.0), 0.5)

    @testset "bit-exact seam and pole vertices" begin
        for T in (Float32, Float64)
            n = 24
            sphere_points = coordinates(Sphere(Point{3,T}(0.2, -0.3, 0.4), T(1.3)), n)
            first_meridian = sphere_points[1:n]
            last_meridian = sphere_points[(end - n + 1):end]
            @test all(map(===, first_meridian, last_meridian))

            top_pole = sphere_points[1:n:end]
            bottom_pole = sphere_points[n:n:end]
            @test all(p === top_pole[1] for p in top_pole)
            @test all(p === bottom_pole[1] for p in bottom_pole)

            circle_points = coordinates(Circle(Point{2,T}(0.2, -0.3), T(1.3)), n)
            @test circle_points[1] === circle_points[end]
        end
    end
end

@testset "LineStrings" begin
    ps1 = rand(Point2f, 10)
    ls1 = LineString(ps1)
    _ls1 = LineString(ps1)
    @test coordinates(ls1) == ps1
    @test length(ls1) == 10
    @test ls1 == _ls1

    ls2 = LineString(rand(Point2f, 6))
    ls3 = LineString(rand(Point2f, 4))
    mls = MultiLineString([ls1, ls2, ls3])
    @test mls.linestrings == [ls1, ls2, ls3]
    @test mls[1] == ls1
    @test mls[2] == ls2
    @test mls[3] == ls3
    @test size(mls) == (3, ) # TODO: Does this make sense?
    @test length(mls) == 3
    @test MultiLineString(OffsetArray([ls1, ls2, ls3], 0)) == mls
end

@testset "MultiPoint" begin
    ps1 = rand(Point2f, 10)
    mp = MultiPoint(ps1)
    @test all(getindex.(Ref(mp), 1:10) .== ps1)
    @test size(mp) == (10, ) # TODO: Does this make sense?
    @test length(mp) == 10
end

@testset "Cone" begin
    @testset "constructors" begin
        v1 = rand(Point{3,Float64})
        v2 = rand(Point{3,Float64})
        R = rand()
        s = Cone(v1, v2, R)
        @test typeof(s) == Cone{Float64}
        @test origin(s) == v1
        @test extremity(s) == v2
        @test radius(s) == R
        @test height(s) == norm(v2 - v1)
        @test isapprox(direction(s), (v2 - v1) ./ norm(v2 .- v1))
    end

    @testset "decompose" begin
        v1 = Point{3,Float64}(1, 2, 3)
        v2 = Point{3,Float64}(4, 5, 6)
        R = 5.0
        s = Cone(v1, v2, R)
        positions = Point{3,Float64}[
            (4.535533905932738, -1.5355339059327373, 3.0),
            (3.0412414523193148, 4.041241452319315, -1.0824829046386295),
            (-2.535533905932737, 5.535533905932738, 2.9999999999999996),
            (-1.0412414523193152, -0.04124145231931431, 7.0824829046386295),
            (4, 5, 6),
            (1, 2, 3)
        ]

        @test decompose(Point3{Float64}, Tessellation(s, 8)) ≈ positions

        _faces = TriangleFace[
            (1,2,5), (2,3,5), (3,4,5), (4,1,5),
            (1,2,6), (2,3,6), (3,4,6), (4,1,6)]

        @test _faces == decompose(TriangleFace{Int}, Tessellation(s, 8))

        m = triangle_mesh(Tessellation(s, 8))
        @test m === triangle_mesh(m)
        @test GeometryBasics.faces(m) == decompose(GLTriangleFace, _faces)
        @test GeometryBasics.coordinates(m) ≈ positions

        m = normal_mesh(s) # just test that it works without explicit resolution parameter
        @test hasproperty(m, :position)
        @test hasproperty(m, :normal)
        @test faces(m) isa AbstractVector{GLTriangleFace}

        ns = Vec{3, Float32}[
            (0.90984505, -0.10920427, 0.40032038),
            (0.6944946, 0.6944946, -0.18802801),
            (-0.10920427, 0.90984505, 0.40032038),
            (0.106146194, 0.106146194, 0.9886688),
            (0.0, 0.0, 0.0),
            (-0.57735026, -0.57735026, -0.57735026),
        ]
        fs = [
            GLTriangleFace(1, 2, 5), GLTriangleFace(2, 3, 5), GLTriangleFace(3, 4, 5), GLTriangleFace(4, 1, 5),
            GLTriangleFace(6, 6, 6), GLTriangleFace(6, 6, 6), GLTriangleFace(6, 6, 6), GLTriangleFace(6, 6, 6)
        ]

        @test FaceView(ns, fs) == decompose_normals(Tessellation(s, 8))

        muv = uv_mesh(s)
        @test !hasproperty(muv, :uv) # not defined yet
    end
end

module GeometryBasicsGeoInterfaceExt

using GeoInterface, GeometryBasics

import GeometryBasics: geointerface_geomtype
using GeometryBasics: Ngon

# Implementation of trait based interface from https://github.com/JuliaGeo/GeoInterface.jl/

GeoInterface.isgeometry(::Type{<:AbstractGeometry}) = true
GeoInterface.isgeometry(::Type{<:AbstractFace}) = true

GeoInterface.isgeometry(::Type{<:Point}) = true
GeoInterface.isgeometry(::Type{<:AbstractMesh}) = true
GeoInterface.isgeometry(::Type{<:AbstractPolygon}) = true
GeoInterface.isgeometry(::Type{<:LineString}) = true
GeoInterface.isgeometry(::Type{<:MultiPoint}) = true
GeoInterface.isgeometry(::Type{<:MultiLineString}) = true
GeoInterface.isgeometry(::Type{<:MultiPolygon}) = true
GeoInterface.isgeometry(::Type{<:Mesh}) = true

GeoInterface.geomtrait(::Point) = PointTrait()
GeoInterface.geomtrait(::Line) = LineTrait()
GeoInterface.geomtrait(::LineString) = LineStringTrait()
GeoInterface.geomtrait(::Polygon) = PolygonTrait()
GeoInterface.geomtrait(::MultiPoint) = MultiPointTrait()
GeoInterface.geomtrait(::MultiLineString) = MultiLineStringTrait()
GeoInterface.geomtrait(::MultiPolygon) = MultiPolygonTrait()
GeoInterface.geomtrait(::Ngon) = PolygonTrait()
GeoInterface.geomtrait(::AbstractMesh) = PolyhedralSurfaceTrait()

# GeoInterface calls this method in `GeoInterface.convert(GeometryBasics, ...)`
geointerface_geomtype(::GeoInterface.PointTrait) = Point
geointerface_geomtype(::GeoInterface.MultiPointTrait) = MultiPoint
geointerface_geomtype(::GeoInterface.LineTrait) = Line
geointerface_geomtype(::GeoInterface.LineStringTrait) = LineString
geointerface_geomtype(::GeoInterface.LinearRingTrait) = LineString
geointerface_geomtype(::GeoInterface.MultiLineStringTrait) = MultiLineString
geointerface_geomtype(::GeoInterface.PolygonTrait) = Polygon
geointerface_geomtype(::GeoInterface.MultiPolygonTrait) = MultiPolygon
geointerface_geomtype(::GeoInterface.PolyhedralSurfaceTrait) = Mesh

GeoInterface.geomtrait(::Simplex{Dim,T,1}) where {Dim,T} = PointTrait()
GeoInterface.geomtrait(::Simplex{Dim,T,2}) where {Dim,T} = LineStringTrait()
GeoInterface.geomtrait(::Simplex{Dim,T,3}) where {Dim,T} = PolygonTrait()

GeoInterface.ncoord(::PointTrait, g::Point) = length(g)
GeoInterface.getcoord(::PointTrait, g::Point, i::Int) = g[i]

GeoInterface.ngeom(::LineTrait, g::Line) = length(g)
GeoInterface.getgeom(::LineTrait, g::Line, i::Int) = g[i]


GeoInterface.ngeom(::LineStringTrait, g::LineString) = length(g)  # n connected points
GeoInterface.ncoord(::LineStringTrait, g::LineString{Dim}) where {Dim} = Dim
function GeoInterface.getgeom(::LineStringTrait, g::LineString, i::Int)
    return GeometryBasics.coordinates(g)[i]
end

GeoInterface.ngeom(::PolygonTrait, g::Polygon) = length(g.interiors) + 1  # +1 for exterior
function GeoInterface.getgeom(::PolygonTrait,
                              g::Polygon,
                              i::Int)
    return i > 1 ? LineString(g.interiors[i - 1]) : LineString(g.exterior)
end

GeoInterface.ngeom(::MultiPointTrait, g::MultiPoint) = length(g)
GeoInterface.getgeom(::MultiPointTrait, g::MultiPoint, i::Int) = g[i]

function GeoInterface.ngeom(::MultiLineStringTrait, g::MultiLineString)
    return length(g)
end
function GeoInterface.getgeom(::MultiLineStringTrait, g::MultiLineString, i::Int)
    return g[i]
end
GeoInterface.ncoord(::MultiLineStringTrait, g::MultiLineString{Dim}) where {Dim} = Dim

GeoInterface.ngeom(::MultiPolygonTrait, g::MultiPolygon) = length(g)
GeoInterface.getgeom(::MultiPolygonTrait, g::MultiPolygon, i::Int) = g[i]

function GeoInterface.ncoord(::AbstractGeometryTrait,
                             ::Simplex{Dim,T,N}) where {Dim,T,N}
    return Dim
end
function GeoInterface.ncoord(::AbstractGeometryTrait,
                             ::AbstractGeometry{Dim,T}) where {Dim,T}
    return Dim
end
function GeoInterface.ngeom(::AbstractGeometryTrait,
                            ::Simplex{Dim,T,N}) where {Dim,T,N}
    return N
end
GeoInterface.ngeom(::PolygonTrait, ::Ngon) = 1  # can't have any holes
GeoInterface.getgeom(::PolygonTrait, g::Ngon, _) = LineString([g.points...])

function GeoInterface.ncoord(::PolyhedralSurfaceTrait,
                             ::Mesh{Dim,T,E,V} where {Dim,T,E,V})
    return Dim
end
GeoInterface.ngeom(::PolyhedralSurfaceTrait, g::AbstractMesh) = length(g)
GeoInterface.getgeom(::PolyhedralSurfaceTrait, g::AbstractMesh, i) = g[i]

function GeoInterface.convert(::Type{Point}, type::PointTrait, geom)
    x, y = GeoInterface.x(geom), GeoInterface.y(geom)
    if GeoInterface.is3d(geom)
        z = GeoInterface.z(geom)
        T = promote_type(typeof(x), typeof(y), typeof(z))
        return Point{3,T}(x, y, z)
    else
        GeoInterface.x(geom), GeoInterface.y(geom)
        T = promote_type(typeof(x), typeof(y))
        return Point{2,T}(x, y)
    end
end
function GeoInterface.convert(::Type{Line}, type::LineTrait, geom)
    g1, g2 = GeoInterface.getgeom(geom)
    x, y = GeoInterface.x(g1), GeoInterface.y(g1)
    if GeoInterface.is3d(geom)
        z = GeoInterface.z(g1)
        T = promote_type(typeof(x), typeof(y), typeof(z))
        return Line{3,T}(Point{3,T}(x, y, z), Point{3,T}(GeoInterface.x(g2), GeoInterface.y(g2), GeoInterface.z(g2)))
    else
        T = promote_type(typeof(x), typeof(y))
        return Line{2,T}(Point{2,T}(x, y), Point{2,T}(GeoInterface.x(g2), GeoInterface.y(g2)))
    end
end
function GeoInterface.convert(::Type{LineString}, type::Union{LineStringTrait, LinearRingTrait}, geom)
    g1 = getgeom(geom, 1)
    x, y = GeoInterface.x(g1), GeoInterface.y(g1)
    if GeoInterface.is3d(geom)
        z = GeoInterface.z(g1)
        T = promote_type(typeof(x), typeof(y), typeof(z))
        return LineString([Point{3,T}(GeoInterface.x(p), GeoInterface.y(p), GeoInterface.z(p)) for p in getgeom(geom)])
    else
        T = promote_type(typeof(x), typeof(y))
        return LineString(_collect_with_type(Point{2, T}, geom))
    end
end
function GeoInterface.convert(::Type{Polygon}, type::PolygonTrait, geom)
    t = LineStringTrait()
    exterior = GeoInterface.convert(LineString, t, GeoInterface.getexterior(geom))
    if GeoInterface.nhole(geom) == 0
        return Polygon(exterior)
    else
        interiors = map(h -> GeoInterface.convert(LineString, t, h), GeoInterface.gethole(geom))
        return Polygon(exterior, interiors)
    end
end
function GeoInterface.convert(::Type{MultiPoint}, type::MultiPointTrait, geom)
    g1 = getgeom(geom, 1)
    x, y = GeoInterface.x(g1), GeoInterface.y(g1)
    if GeoInterface.is3d(geom)
        z = GeoInterface.z(g1)
        T = promote_type(typeof(x), typeof(y), typeof(z))
        return MultiPoint([Point{3,T}(GeoInterface.x(p), GeoInterface.y(p), GeoInterface.z(p)) for p in getgeom(geom)])
    else
        T = promote_type(typeof(x), typeof(y))
        return MultiPoint([Point{2,T}(GeoInterface.x(p), GeoInterface.y(p)) for p in getgeom(geom)])
    end
end
function GeoInterface.convert(::Type{MultiLineString}, type::MultiLineStringTrait, geom)
    t = LineStringTrait()
    return MultiLineString(map(l -> GeoInterface.convert(LineString, t, l), getgeom(geom)))
end
function GeoInterface.convert(::Type{MultiPolygon}, type::MultiPolygonTrait, geom)
    t = PolygonTrait()
    return MultiPolygon(map(poly -> GeoInterface.convert(Polygon, t, poly), getgeom(geom)))
end

# without a function barrier you get a lot of allocations from runtime types
function _collect_with_type(::Type{PT}, geom) where {PT <: Point{2}}
    return [PT(GeoInterface.x(p), GeoInterface.y(p)) for p in getgeom(geom)]
end

# coordtype implementation - GeometryBasics encodes coordinate type in eltype
# Use specific traits to avoid method ambiguity with GeoInterface fallbacks
if isdefined(GeoInterface, :coordtype)
    # Point
    GeoInterface.coordtype(::GeoInterface.PointTrait, geom::Point{Dim,T}) where {Dim,T} = T
    # Line
    GeoInterface.coordtype(::GeoInterface.LineTrait, geom::Line{Dim,T}) where {Dim,T} = T
    # LineString
    GeoInterface.coordtype(::GeoInterface.LineStringTrait, geom::LineString{Dim,T}) where {Dim,T} = T
    # Polygon
    GeoInterface.coordtype(::GeoInterface.PolygonTrait, geom::Polygon{Dim,T}) where {Dim,T} = T
    # MultiPoint
    GeoInterface.coordtype(::GeoInterface.MultiPointTrait, geom::MultiPoint{Dim,T}) where {Dim,T} = T
    # MultiLineString
    GeoInterface.coordtype(::GeoInterface.MultiLineStringTrait, geom::MultiLineString{Dim,T}) where {Dim,T} = T
    # MultiPolygon
    GeoInterface.coordtype(::GeoInterface.MultiPolygonTrait, geom::MultiPolygon{Dim,T}) where {Dim,T} = T
    # Ngon (uses PolygonTrait)
    GeoInterface.coordtype(::GeoInterface.PolygonTrait, geom::Ngon{Dim,T,N}) where {Dim,T,N} = T
    # Simplex (can have PointTrait, LineStringTrait, or PolygonTrait depending on N)
    GeoInterface.coordtype(::GeoInterface.PointTrait, geom::Simplex{Dim,T,1}) where {Dim,T} = T
    GeoInterface.coordtype(::GeoInterface.LineStringTrait, geom::Simplex{Dim,T,2}) where {Dim,T} = T
    GeoInterface.coordtype(::GeoInterface.PolygonTrait, geom::Simplex{Dim,T,3}) where {Dim,T} = T
    # Mesh
    GeoInterface.coordtype(::GeoInterface.PolyhedralSurfaceTrait, geom::Mesh{Dim,T,E,V}) where {Dim,T,E,V} = T
end

end

@testset "Basic types" begin
    point = Point(2, 3)
    @test geomtrait(point) isa PointTrait
    @test testgeometry(point)
    @test ncoord(point) == 2
    @test getcoord(point, 2) == 3
    @test GeoInterface.coordinates(point) == [2, 3]

    line = Line(Point(2, 3), Point(4, 5))
    @test geomtrait(line) isa LineTrait
    @test testgeometry(line)
    @test ngeom(line) == 2
    @test getgeom(line, 2) == Point(4, 5)
    @test GeoInterface.coordinates(line) == [[2, 3], [4, 5]]

    mp = MultiPoint([point, point])
    @test geomtrait(mp) isa MultiPointTrait
    @test testgeometry(mp)
    @test ngeom(mp) == 2
    @test getgeom(mp, 2) == point
    @test GeoInterface.coordinates(mp) == [[2, 3], [2, 3]]

    linestring = LineString(Point{2,Int}[(10, 10), (20, 20), (10, 40)])
    @test geomtrait(linestring) isa LineStringTrait
    @test testgeometry(linestring)
    @test ngeom(linestring) == 3
    @test ncoord(linestring) == 2
    @test getgeom(linestring, 1) == Point(10, 10)
    @test getgeom(linestring, 2) == Point(20, 20)
    @test getgeom(linestring, 3) == Point(10, 40)
    @test GeoInterface.coordinates(linestring) == [[10, 10], [20, 20], [10, 40]]

    multilinestring = MultiLineString([linestring, linestring])
    @test geomtrait(multilinestring) isa MultiLineStringTrait
    @test testgeometry(multilinestring)
    @test GeoInterface.coordinates(multilinestring) ==
          [[[10, 10], [20, 20], [10, 40]], [[10, 10], [20, 20], [10, 40]]]
    @test ncoord(multilinestring) == 2

    poly = Polygon(rand(Point{2,Float32}, 5), [rand(Point{2,Float32}, 5)])
    @test geomtrait(poly) isa PolygonTrait
    @test testgeometry(poly)
    @test length(GeoInterface.coordinates(poly)) == 2
    @test length(GeoInterface.coordinates(poly)[1]) == 5

    triangle = Triangle(point, point, point)
    @test geomtrait(triangle) isa PolygonTrait # ?? should it be a Triangle trait
    @test testgeometry(triangle)
    @test length(GeoInterface.coordinates(triangle)) == 1
    @test length(GeoInterface.coordinates(triangle)[1]) == 3

    polys = MultiPolygon([poly, poly])
    @test geomtrait(polys) isa MultiPolygonTrait
    @test testgeometry(polys)
    @test length(GeoInterface.coordinates(polys)) == 2
    @test length(GeoInterface.coordinates(polys)[1]) == 2
    @test length(GeoInterface.coordinates(polys)[1][1]) == 5
end

@testset "Mesh" begin
    mesh = triangle_mesh(Sphere(Point3f(0), 1))
    @test testgeometry(mesh)
end

@testset "Convert" begin
    # convert GeoJSON geometry types to GeometryBasics via the GeoInterface
    point_str = """{"type":"Point","coordinates":[30.1,10.1]}"""
    point_3d_str = """{"type":"Point","coordinates":[30.1,10.1,5.1]}"""
    linestring_str = """{"type":"LineString","coordinates":[[30.1,10.1],[10.1,30.1],[40.1,40.1]]}"""
    polygon_str = """{"type":"Polygon","coordinates":[[[30.1,10.1],[40.1,40.1],[20.1,40.1],[10.1,20.1],[30.1,10.1]]]}"""
    polygon_hole_str = """{"type":"Polygon","coordinates":[[[35.1,10.1],[45.1,45.1],[15.1,40.1],[10.1,20.1],[35.1,10.1]],[[20.1,30.1],[35.1,35.1],[30.1,20.1],[20.1,30.1]]]}"""
    multipoint_str = """{"type":"MultiPoint","coordinates":[[10.1,40.1],[40.1,30.1],[20.1,20.1],[30.1,10.1]]}"""
    multilinestring_str = """{"type":"MultiLineString","coordinates":[[[10.1,10.1],[20.1,20.1],[10.1,40.1]],[[40.1,40.1],[30.1,30.1],[40.1,20.1],[30.1,10.1]]]}"""
    multipolygon_str = """{"type":"MultiPolygon","coordinates":[[[[30.1,20.1],[45.1,40.1],[10.1,40.1],[30.1,20.1]]],[[[15.1,5.1],[40.1,10.1],[10.1,20.1],[5.1,10.1],[15.1,5.1]]]]}"""
    multipolygon_hole_str = """{"type":"MultiPolygon","coordinates":[[[[40.1,40.1],[20.1,45.1],[45.1,30.1],[40.1,40.1]]],[[[20.1,35.1],[10.1,30.1],[10.1,10.1],[30.1,5.1],[45.1,20.1],[20.1,35.1]],[[30.1,20.1],[20.1,15.1],[20.1,25.1],[30.1,20.1]]]]}"""

    point_json = GeoJSON.read(point_str)
    point_3d_json = GeoJSON.read(point_3d_str)
    linestring_json = GeoJSON.read(linestring_str)
    polygon_json = GeoJSON.read(polygon_str)
    polygon_hole_json = GeoJSON.read(polygon_hole_str)
    multipoint_json = GeoJSON.read(multipoint_str)
    multilinestring_json = GeoJSON.read(multilinestring_str)
    multipolygon_json = GeoJSON.read(multipolygon_str)
    multipolygon_hole_json = GeoJSON.read(multipolygon_hole_str)

    point_gb = GeoInterface.convert(GeometryBasics, point_json)
    point_3d_gb = GeoInterface.convert(GeometryBasics, point_3d_json)
    linestring_gb = GeoInterface.convert(GeometryBasics, linestring_json)
    polygon_gb = GeoInterface.convert(GeometryBasics, polygon_json)
    polygon_hole_gb = GeoInterface.convert(GeometryBasics, polygon_hole_json)
    multipoint_gb = GeoInterface.convert(GeometryBasics, multipoint_json)
    multilinestring_gb = GeoInterface.convert(GeometryBasics, multilinestring_json)
    multipolygon_gb = GeoInterface.convert(GeometryBasics, multipolygon_json)
    multipolygon_hole_gb = GeoInterface.convert(GeometryBasics, multipolygon_hole_json)
    
    @test point_gb === Point{2,Float32}(30.1, 10.1)
    @test point_3d_gb === Point{3,Float32}(30.1, 10.1, 5.1)
    @test linestring_gb isa LineString
    # TODO, what should we do exactly with linestrings?
    # @test length(linestring_gb) == 2
    # @test eltype(linestring_gb) == Line{2, Float64}

    @test polygon_gb isa Polygon
    @test isempty(polygon_gb.interiors)
    @test polygon_hole_gb isa Polygon
    @test length(polygon_hole_gb.interiors) == 1
    @test multipoint_gb isa MultiPoint
    @test length(multipoint_gb) == 4
    @test multipoint_gb[4] === Point{2,Float32}(30.1, 10.1)
    @test multilinestring_gb isa MultiLineString
    @test length(multilinestring_gb) == 2
    @test multipolygon_gb isa MultiPolygon
    @test length(multipolygon_gb) == 2
    @test multipolygon_hole_gb isa MultiPolygon
    @test length(multipolygon_hole_gb) == 2
    @test length(multipolygon_hole_gb[1].interiors) == 0
    @test length(multipolygon_hole_gb[2].interiors) == 1
end

@testset "Extent" begin
    rect = Rect2f(Vec2f(0), Vec2f(1.0))
    ext = extent(rect)
    @test ext.X == (0.0f0, 1.0f0)
    @test ext.Y == (0.0f0, 1.0f0)
    rect = Rect3f(Vec3f(0), Vec3f(1.0))
    ext = extent(rect)
    @test ext.X == (0.0f0, 1.0f0)
    @test ext.Y == (0.0f0, 1.0f0)
    @test ext.Z == (0.0f0, 1.0f0)
    rect = Rect4f(Vec{4,Float32}(0), Vec{4,Float32}(1.0))
    ext = extent(rect)
    @test ext.X == (0.0f0, 1.0f0)
    @test ext.Y == (0.0f0, 1.0f0)
    @test ext.Z == (0.0f0, 1.0f0)
    @test ext.M == (0.0f0, 1.0f0)
end

@testset "coordtype" begin
    if isdefined(GeoInterface, :coordtype)
        # Point
        point_int = Point(2, 3)
        point_float = Point(2.0, 3.0)
        point_float32 = Point{2,Float32}(2.0, 3.0)
        point_3d = Point{3,Float64}(1.0, 2.0, 3.0)
        @test GeoInterface.coordtype(point_int) == Int
        @test GeoInterface.coordtype(point_float) == Float64
        @test GeoInterface.coordtype(point_float32) == Float32
        @test GeoInterface.coordtype(point_3d) == Float64

        # Line (AbstractGeometry)
        line = Line(Point(2, 3), Point(4, 5))
        line_float = Line(Point(2.0, 3.0), Point(4.0, 5.0))
        @test GeoInterface.coordtype(line) == Int
        @test GeoInterface.coordtype(line_float) == Float64

        # LineString
        linestring = LineString(Point{2,Int}[(10, 10), (20, 20), (10, 40)])
        linestring_float = LineString(Point{2,Float64}[(10.0, 10.0), (20.0, 20.0)])
        @test GeoInterface.coordtype(linestring) == Int
        @test GeoInterface.coordtype(linestring_float) == Float64

        # MultiPoint
        mp = MultiPoint([Point(2, 3), Point(4, 5)])
        mp_float = MultiPoint([Point(2.0, 3.0), Point(4.0, 5.0)])
        @test GeoInterface.coordtype(mp) == Int
        @test GeoInterface.coordtype(mp_float) == Float64

        # MultiLineString
        mls = MultiLineString([linestring, linestring])
        mls_float = MultiLineString([linestring_float, linestring_float])
        @test GeoInterface.coordtype(mls) == Int
        @test GeoInterface.coordtype(mls_float) == Float64

        # Polygon
        poly_float32 = Polygon(rand(Point{2,Float32}, 5))
        poly_float64 = Polygon(rand(Point{2,Float64}, 5))
        @test GeoInterface.coordtype(poly_float32) == Float32
        @test GeoInterface.coordtype(poly_float64) == Float64

        # MultiPolygon
        mpoly = MultiPolygon([poly_float32, poly_float32])
        @test GeoInterface.coordtype(mpoly) == Float32

        # Simplex (Triangle is Ngon which is a Simplex)
        triangle = Triangle(Point(1, 2), Point(3, 4), Point(5, 6))
        triangle_float = Triangle(Point(1.0, 2.0), Point(3.0, 4.0), Point(5.0, 6.0))
        @test GeoInterface.coordtype(triangle) == Int
        @test GeoInterface.coordtype(triangle_float) == Float64

        # Mesh
        mesh = triangle_mesh(Sphere(Point3f(0), 1))
        @test GeoInterface.coordtype(mesh) == Float32
    end
end

@testset "Convert from StaticArrays" begin
    using GeometryBasics.StaticArrays

    # LineString from StaticVector
    ls = GeoInterface.convert(GeometryBasics, GeoInterface.LineString(SA[(1.0, 2.0), (3.0, 4.0)]))
    @test ls isa LineString{2, Float64}
    @test length(ls) == 2
    @test ls.points[1] == Point(1.0, 2.0)
    @test ls.points[2] == Point(3.0, 4.0)

    # Polygon from StaticVector of StaticVector rings
    ring = GeoInterface.LinearRing(SA[(0.0, 0.0), (1.0, 0.0), (1.0, 1.0), (0.0, 1.0), (0.0, 0.0)])
    poly = GeoInterface.convert(GeometryBasics, GeoInterface.Polygon(SA[ring]))
    @test poly isa Polygon{2, Float64}

    # MultiLineString from StaticVector
    line1 = GeoInterface.LineString(SA[(1.0, 2.0), (3.0, 4.0)])
    line2 = GeoInterface.LineString(SA[(5.0, 6.0), (7.0, 8.0)])
    mls = GeoInterface.convert(GeometryBasics, GeoInterface.MultiLineString([line1, line2]))
    @test mls isa MultiLineString{2, Float64}
    @test length(mls) == 2
end

@testset "Convert Line and LinearRing" begin
    # Line (2D)
    gi_line_2d = GeoInterface.Line([(1.0, 2.0), (3.0, 4.0)])
    line_2d = GeoInterface.convert(GeometryBasics, gi_line_2d)
    @test line_2d isa Line{2, Float64}
    @test line_2d[1] == Point(1.0, 2.0)
    @test line_2d[2] == Point(3.0, 4.0)

    # Line (3D)
    gi_line_3d = GeoInterface.Line([(1.0, 2.0, 3.0), (4.0, 5.0, 6.0)])
    line_3d = GeoInterface.convert(GeometryBasics, gi_line_3d)
    @test line_3d isa Line{3, Float64}
    @test line_3d[1] == Point(1.0, 2.0, 3.0)
    @test line_3d[2] == Point(4.0, 5.0, 6.0)

    # LinearRing → LineString (2D)
    gi_ring = GeoInterface.LinearRing([(0.0, 0.0), (1.0, 0.0), (1.0, 1.0), (0.0, 0.0)])
    ls_from_ring = GeoInterface.convert(GeometryBasics, gi_ring)
    @test ls_from_ring isa LineString{2, Float64}
    @test length(ls_from_ring) == 4

    # LinearRing → LineString (3D)
    gi_ring_3d = GeoInterface.LinearRing([(0.0, 0.0, 0.0), (1.0, 0.0, 0.0), (1.0, 1.0, 0.0), (0.0, 0.0, 0.0)])
    ls_from_ring_3d = GeoInterface.convert(GeometryBasics, gi_ring_3d)
    @test ls_from_ring_3d isa LineString{3, Float64}
    @test length(ls_from_ring_3d) == 4
end

module ExtentsExt

import GeometryBasics
import Extents

function Extents.extent(rect::GeometryBasics.Rect2)
    (xmin, ymin), (xmax, ymax) = extrema(rect)
    return Extents.Extent(X=(xmin, xmax), Y=(ymin, ymax))
end

function Extents.extent(rect::GeometryBasics.Rect3)
    (xmin, ymin, zmin), (xmax, ymax, zmax) = extrema(rect)
    return Extents.Extent(X=(xmin, xmax), Y=(ymin, ymax), Z=(zmin, zmax))
end

function Extents.extent(rect::GeometryBasics.Rect4)
    (xmin, ymin, zmin, mmin), (xmax, ymax, zmax, mmax) = extrema(rect)
    return Extents.Extent(X=(xmin, xmax), Y=(ymin, ymax), Z=(zmin, zmax), M=(mmin, mmax))
end

end

using Test
using GeometryBasics: to_ndim

@testset "Construction and Conversion" begin
    for VT in [Point, Vec]
        for T in [Int32, Float32, Float64, UInt16, BigFloat]
            p = VT{3, T}(1,2,3)
            @test p[1] == T(1)
            @test p[2] == T(2)
            @test p[3] == T(3)
        end

        for VT2 in [Point, Vec]
            @test VT{2, Float32}(VT2{3, Float32}(1,2,3)) == VT{2, Float32}(1,2)
            @test VT{2, Float32}(VT2{3, Float64}(1,2,3)) == VT{2, Float32}(1,2)
        end
        @test VT{2, Float32}(Float32[1,2,3]) == VT{2, Float32}(1,2)
        @test VT{2, Float32}([1,2,3]) == VT{2, Float32}(1,2)
    end

    @test convert(Point, (2, 3)) === Point(2, 3)
    @test convert(Point, (2.0, 3)) === Point(2.0, 3.0)

    @test to_ndim(Point3f, Vec2i(1,2), 0) == Point3f(1,2,0)
    @test to_ndim(Vec4i, (1f0, 2), 0) == Vec4i(1,2,0,0)
    @test to_ndim(NTuple{2, Float64}, Point3f(1,2,3), 0) == (1.0, 2.0)
end

@testset "broadcast" begin
    foo(a, b) = (a + b) * (a - b)
    M1 = Mat{2, 2}(1,2,3,4)
    M2 = Mat{2, 2}(2,2,1,1)

    @testset "with similar" begin
        for T1 in (Vec, Point, tuple)
            for T2 in (Vec, Point, tuple)
                T1 == tuple && T2 == tuple && continue
                T = ifelse(T1 == Point, Point, ifelse(T2 == Point, Point, Vec))
                @test T(2, 2, 4) == T1(1,2,3) .+ T2(1, 0, 1)
                @test T(foo.((1,2,3), (1, 0, 1))) == foo.(T1(1,2,3), T2(1, 0, 1))
                @test T1(1,2,3) .* T2(1,2,3) == T(1, 4, 9)
                # TODO: repair this:
                # @test foo.(T1(1,2,3), [T2(1,1,1), T2(2,2,2)]) == [T(1,2,3), T(2,4,6)]
                # @test foo.([T2(1,1,1), T2(2,2,2)], T1(1,2,3)) == [T(0, -3, -8), T(3, 0, -5)]
            end
        end

        @test Mat{2, 2}(3,4,4,5) == M1 .+ M2
        @test Mat{2, 2}(foo.(values(M1), values(M2))) == foo.(M1, M2)
    end

    @testset "with const" begin
        for T in (Vec, Point)
            @test T(-4, -3) == T(1,2) .- 5
            @test T(foo.((1,2), 5)) == foo.(T(1,2), 5)
        end

        @test Mat{2, 2}(2,3,4,5) == M1 .+ 1
        @test Mat{2, 2}(foo.(values(M1), 1)) == foo.(M1, 1)
    end

    @testset "chained/nested" begin
        for T1 in (Vec, Point, tuple)
            for T2 in (Vec, Point, tuple)
                T1 == tuple && T2 == tuple && continue
                T = ifelse(T1 == Point, Point, ifelse(T2 == Point, Point, Vec))
                @test T(-6, -4, 4) == T1(1,2,3) .+ T2(1, 0, 1) .- T2(3, 2, 1) .* T1(2,2,0) .- T2(2,2,0)
                @test T(-15, -5) == foo.(T1(1,2), T1(-1, 0) .+ foo.(T1(1,1), T2(2,2)))
            end
        end
    end

    @testset "Longer functions" begin
        foo2(a, b, c, d) = (a + b) * (c + d)
        for T1 in (Vec, Point, tuple)
            for T2 in (Vec, Point, tuple)
                T1 == tuple && T2 == tuple && continue
                T = ifelse(T1 == Point, Point, ifelse(T2 == Point, Point, Vec))
                @test T(foo2.((1,2,3), (1, 0, 1), (3, 2, 1), (2,2,0))) ==
                    foo2.(T1(1,2,3), T2(1, 0, 1), T2(3, 2, 1), T2(2,2,0))
            end
        end

        @test Mat{2, 2}(foo2.(values.((M1, M1, M2, M2))...)) == foo2.(M1, M1, M2, M2)
    end
end

@testset "finite, nan, inf tests" begin
    for T in (Vec, Point)
        @testset "$T" begin
            nan_point = T(Float64.((1.0, 2.0, 3.0, NaN)))
            inf_point = T(Float64.((1.0, 2.0, Inf, 4.0)))
            @test isinf(inf_point)
            @test !isinf(nan_point)
            @test isnan(nan_point)
            @test !isnan(inf_point)
            @test !isfinite(nan_point)
            @test !isfinite(inf_point)
            @test !isfinite(nan_point + inf_point)
            @test isfinite(T(1, 2, 3))
        end
    end
end

@testset "Mat" begin
    M3 = Mat3(1,2,3, 4,5,6, 7,8,9)
    @test M3 isa Mat{3,3,Int,9}

    @testset "indexing" begin
        for i in 1:9
            @test getindex(M3, i) == i
        end
        @test_throws BoundsError getindex(M3, 0)
        @test_throws BoundsError getindex(M3, 10)

        # Sanity check for loop
        # @test M3[2, Vec(1,2)] == Mat{1, 2}(M3[2,1], M3[2,2])
        @test M3[2, Vec(1,2)] == Vec2(M3[2,1], M3[2,2])

        for x in (2, Vec(1,2), Vec(1,1,2,2))
            for y in (2, Vec(1,2), Vec(1,1,2,2))
                x isa Real && y isa Real && continue
                if length(x) == 1
                    @test M3[x, y] == Vec{length(y)}((M3[i, j] for j in y for i in x)...)
                elseif length(y) == 1
                    @test M3[x, y] == Vec{length(x)}((M3[i, j] for j in y for i in x)...)
                else
                    @test M3[x, y] == Mat{length(x), length(y)}((M3[i, j] for j in y for i in x)...)
                end
                @test_throws BoundsError M3[x .- 2, y]
                @test_throws BoundsError M3[x, y .+ 2]
                @test_throws BoundsError M3[x .+ 2, y .- 2]
            end
        end

    end

    for N in 1:4
        @testset "math $N x $N" begin
            bm = rand(N, N) + I
            sm = Mat{N, N}(bm)
            bv = rand(N)
            sv = Vec{N, Float64}(bv)
            @test bm == Matrix(sm)
            @test det(bm) ≈ det(sm)
            @test inv(bm) ≈ Matrix(inv(sm))
            @test collect(transpose(bm)) ≈ Matrix(transpose(sm))
            @test bm * bv ≈ collect(sm * sv)
        end
    end
end

# Boundingbox-like Rect constructors

Rect(p::AbstractGeometry{N, T}) where {N, T} = Rect{N, T}(p)
RectT{T}(p::AbstractGeometry{N}) where {N, T} = Rect{N, T}(p)
Rect{N}(p::AbstractGeometry{_N, T}) where {N, _N, T} = Rect{N, T}(p)

Rect(p::AbstractArray{<: VecTypes{N, T}}) where {N, T} = Rect{N, T}(p)
RectT{T}(p::AbstractArray{<: VecTypes{N}}) where {N, T} = Rect{N, T}(p)
Rect{N}(p::AbstractArray{<: VecTypes{_N, T}}) where {N, _N, T} = Rect{N, T}(p)

# Implementations
# Specialize fully typed Rect constructors
Rect{N, T}(p::AbstractGeometry) where {N, T} = Rect{N, T}(coordinates(p))

function bbox_dim_check(trg, src::Integer)
    @assert trg isa Integer "Rect{$trg, $T1} is invalid. This may have happened due to calling Rect{$N1}(obj) to get a bounding box."
    if trg < src
        throw(ArgumentError("Cannot construct a $trg dimensional bounding box from $src dimensional Points. ($trg must be ≥ $src)"))
    end
end

"""
    Rect(points::AbstractArray{<: VecTypes})

Construct a bounding box containing all the given points.
"""
function Rect{N1, T1}(points::AbstractArray{<: VecTypes{N2, T2}}) where {N1, T1, N2, T2}
    bbox_dim_check(N1, N2)
    vmin = Point{N2,T2}(typemax(T2))
    vmax = Point{N2,T2}(typemin(T2))
    for p in points
        vmin, vmax = _minmax(p, vmin, vmax)
    end
    o = vmin
    w = vmax - vmin
    return if N1 > N2
        z = zero(Vec{N1 - N2,T1})
        Rect{N1,T1}(vcat(o, z), vcat(w, z))
    else
        Rect{N1,T1}(o, w)
    end
end


"""
    Rect(primitive::GeometryPrimitive)

Construct a bounding box for the given primitive.
"""
function Rect{N, T}(a::Pyramid) where {N, T}
    bbox_dim_check(N, 3)
    w, h = a.width, a.length
    m = Vec{3,T}(a.middle)
    return Rect{N, T}(m .- Vec{3,T}(w / T(2), w / T(2), 0), Vec{3,T}(w, w, h))
end

function Rect{N, T}(a::HyperSphere{N2}) where {N, N2, T}
    bbox_dim_check(N, N2)
    return Rect{N, T}(minimum(a), widths(a))
end

# TODO: exact implementation that doesn't rely on coordinates
# function Rect{N, T}(a::Cylinder) where {N, T}
#     return Rect{N, T}(...)
# end

"""
    HyperSphere{N, T}

A `HyperSphere` is a generalization of a sphere into N-dimensions.
A `center` and radius, `r`, must be specified.
"""
struct HyperSphere{N,T} <: GeometryPrimitive{N,T}
    center::Point{N,T}
    r::T
end

"""
    Circle{T}

An alias for a HyperSphere of dimension 2. (i.e. `HyperSphere{2, T}`)
"""
const Circle{T} = HyperSphere{2,T}

"""
    Sphere{T}

An alias for a HyperSphere of dimension 3. (i.e. `HyperSphere{3, T}`)
"""
const Sphere{T} = HyperSphere{3,T}

HyperSphere{N}(p::Point{N,T}, number) where {N,T} = HyperSphere{N,T}(p, convert(T, number))

widths(c::HyperSphere{N,T}) where {N,T} = Vec{N,T}(radius(c) * 2)
radius(c::HyperSphere) = c.r
origin(c::HyperSphere) = c.center

Base.minimum(c::HyperSphere{N,T}) where {N,T} = Vec{N,T}(origin(c)) - Vec{N,T}(radius(c))
Base.maximum(c::HyperSphere{N,T}) where {N,T} = Vec{N,T}(origin(c)) + Vec{N,T}(radius(c))

function Base.in(x::Point, c::HyperSphere)
    return norm(origin(c) - x) ≤ radius(c)
end

centered(S::Type{HyperSphere{N,T}}) where {N,T} = S(Point{N,T}(0), T(0.5))
centered(S::Type{<: HyperSphere{N}}) where {N} = S(Point{N,Float32}(0), 0.5f0)
centered(S::Type{<: HyperSphere}) = S(Point3f(0), 0.5f0)

function coordinates(s::Circle, nvertices=64)
    r = radius(s); o = origin(s)
    ps = [r * Point(cos(phi), sin(phi)) + o for phi in LinRange(0, 2pi, nvertices)]
    # ps[end] = o
    return ps
end

function texturecoordinates(::Circle, nvertices=64)
    return coordinates(Circle(Point2f(0.5), 0.5f0), nvertices)
end

# TODO: Consider generating meshes for circles with a point in the center so
#       that the triangles are more regular
# function faces(::Circle, nvertices=64)
#     return [GLTriangleFace(nvertices+1, i, mod1(i+1, nvertices)) for i in 1:nvertices]
# end


function coordinates(s::Sphere, nvertices=24)
    θ = LinRange(0, pi, nvertices)
    φ = LinRange(0, 2pi, nvertices)
    inner(θ, φ) = Point(cos(φ) * sin(θ), sin(φ) * sin(θ), cos(θ)) .* s.r .+ s.center
    return [inner(θ, φ) for φ in φ for θ in θ]
end

function texturecoordinates(::Sphere, nvertices=24)
    ux = LinRange(0, 1, nvertices)
    return ((φ, θ) for φ in ux for θ in reverse(ux))
end

function faces(::Sphere, nvertices=24)
    return faces(Rect(0, 0, 1, 1), (nvertices, nvertices))
end

function normals(::Sphere{T}, nvertices=24) where {T}
    return coordinates(Sphere(Point{3,T}(0), 1), nvertices)
end

##
# Generic base overloads
Base.extrema(primitive::GeometryPrimitive) = (minimum(primitive), maximum(primitive))
function widths(x::AbstractRange)
    mini, maxi = Float32.(extrema(x))
    return maxi - mini
end

##
# conversion & decompose
"""
    convert_simplex(::Type{TargetType}, x)

Used to convert one object into another in `decompose(::Type{TargetType}, xs)`.
"""
convert_simplex(::Type{T}, x::T) where {T} = (x,)
convert_simplex(::Type{Vec{N, T}}, x::Vec{N, T}) where {N, T} = x

function convert_simplex(NFT::Type{NgonFace{N,T1}},
                         f::Union{NgonFace{N,T2}}) where {T1,T2,N}
    return (convert(NFT, f),)
end

function convert_simplex(NFT::Type{NgonFace{3,T}}, f::NgonFace{3,T2}) where {T,T2}
    return (convert(NFT, f),)
end
function convert_simplex(NFT::Type{NgonFace{2,T}}, f::NgonFace{2,T2}) where {T,T2}
    return (convert(NFT, f),)
end

"""
    convert_simplex(::Type{Face{3}}, f::Face{N})

Triangulate an N-Face into a tuple of triangular faces.
"""
@generated function convert_simplex(::Type{TriangleFace{T}},
                                    f::Union{SimplexFace{N},NgonFace{N}}) where {T,N}
    3 <= N || error("decompose not implemented for N <= 3 yet. N: $N")# other wise degenerate
    v = Expr(:tuple)
    for i in 3:N
        push!(v.args, :(TriangleFace{T}(f[1], f[$(i - 1)], f[$i])))
    end
    return v
end

# TODO: generic?
function convert_simplex(::Type{TriangleFace{T}}, f::SimplexFace{4}) where {T}
    TF = TriangleFace{T}
    return (TF(f[2],f[3],f[4]), TF(f[1],f[3],f[4]), TF(f[1],f[2],f[4]), TF(f[1],f[2],f[3]))
end

"""
    convert_simplex(::Type{Face{2}}, f::Face{N})

Extract all line segments in a Face.
"""
@generated function convert_simplex(::Type{LineFace{T}}, f::NgonFace{N}) where {T,N}
    2 <= N || error("decompose not implemented for N <= 2 yet. N: $N")# other wise degenerate

    v = Expr(:tuple)
    for i in 1:(N - 1)
        push!(v.args, :(LineFace{$T}(f[$i], f[$(i + 1)])))
    end
    # connect vertices N and 1
    push!(v.args, :(LineFace{$T}(f[$N], f[1])))
    return v
end

@generated function convert_simplex(::Type{LineFace{T}}, f::SimplexFace{N}) where {T,N}
    2 <= N || error("decompose not implemented for N <= 2 yet. N: $N")# other wise degenerate

    v = Expr(:tuple)
    for i in 1:(N - 1)
        for j in i+1:N
            push!(v.args, :(LineFace{$T}(f[$i], f[$j])))
        end
    end
    return v
end

to_pointn(::Type{T}, x) where {T<:Point} = convert_simplex(T, x)[1]

# disambiguation method overlords
convert_simplex(::Type{Point}, x::Point) = (x,)
convert_simplex(::Type{Point{N,T}}, p::Point{N,T}) where {N,T} = (p,)
function convert_simplex(::Type{Point{N,T}}, x) where {N,T}
    N2 = length(x)
    return (Point{N,T}(ntuple(i -> i <= N2 ? T(x[i]) : T(0), N)),)
end

function convert_simplex(::Type{Vec{N,T}}, x) where {N,T}
    N2 = length(x)
    return (Vec{N,T}(ntuple(i -> i <= N2 ? T(x[i]) : T(0), N)),)
end

collect_with_eltype(::Type{T}, vec::Vector{T}) where {T} = vec
collect_with_eltype(::Type{T}, vec::AbstractVector{T}) where {T} = collect(vec)
collect_with_eltype(::Type{T}, vec::FaceView{T}) where {T} = vec

function collect_with_eltype(::Type{T}, iter) where {T}
    return collect_with_eltype!(Vector{T}(undef, 0), iter)
end
function collect_with_eltype(::Type{T}, iter::FaceView) where {T}
    return FaceView(collect_with_eltype!(Vector{T}(undef, 0), iter.data), iter.faces)
end

function collect_with_eltype!(target::AbstractVector{T}, vec::AbstractVector{T}) where {T}
    return append!(target, vec)
end

function collect_with_eltype!(result::AbstractVector{T}, iter) where {T}
    isempty(iter) && return result

    # We need to get `eltype` information from `iter`, it seems to be `Any`
    # most of the time so the eltype checks here don't actually work
    l = if Base.IteratorSize(iter) isa Union{Base.HasShape,Base.HasLength}
        if Base.IteratorEltype(iter) isa Base.HasEltype && isconcretetype(eltype(iter))
            # Work out the exact length
            length(convert_simplex(T, first(iter))) * length(iter)
        else
            # We know it is at least the length of iter,
            # after that we will `push!` if we have to
            length(iter)
        end
    else
        0
    end

    # Allow result to be pre-filled for handling faces with mesh.views
    sizehint!(result, length(result) + l)

    for element in iter
        # convert_simplex always returns a tuple,
        # so that e.g. convert(Triangle, quad) can return 2 elements
        for telement in convert_simplex(T, element)
            push!(result, telement)
        end
    end
    return result
end

"""
    orthogonal_vector([target_type = Vec3f], points)

Calculates an orthogonal vector to a polygon defined by a vector of ordered
`points`. Note that the orthogonal vector to a collection of 2D points needs to
expand to 3D space.

Note that this vector is not normalized.
"""
orthogonal_vector(::Type{VT}, vertices) where {VT <: VecTypes{3}} = _orthogonal_vector(VT, coordinates(vertices))
orthogonal_vector(::Type{VT}, vertices::Tuple) where {VT <: VecTypes{3}} = _orthogonal_vector(VT, vertices)

function _orthogonal_vector(::Type{VT}, vertices) where {VT <: VecTypes{3}}
    # Using shoelace approach (with N+1 = 1) (see #245)
    # \sum_i p_i × p_{i+1}
    # with distance vectors to avoid float precision issues
    # \sum_i (p_i - p_1) × (p_{i+1} - p_1)
    # These terms are equal when expanded (extra terms cancel over full sum)
    c = zero(VT)
    p0 = first(vertices)
    prev = zero(VT)
    for i in eachindex(vertices)
        # i = 1 and N don't contribute as then produce (q_1 - q_1) terms
        # we need i = 1 to set up prev though
        i == lastindex(vertices) && break
        v = to_ndim(VT, vertices[i+1] - p0, 0)
        c += cross(prev, v)
        prev = v
    end
    return c
end

# Not sure how useful this fast path is, but it's simple to keep
orthogonal_vector(p1::VT, p2::VT, p3::VT) where {VT <: VecTypes{3}} = _orthogonal_vector(Vec3f, to_ndim.(Vec3f, (p1, p2, p3), 0))
function orthogonal_vector(::Type{VT}, triangle::Union{Triangle, NTuple{3, <:VecTypes}, StaticVector{3, <:VecTypes}}) where {VT <: VecTypes{3}}
    a, b, c = triangle
    return cross(to_ndim(VT, b-a, 0), to_ndim(VT, c-a, 0))
end

# derive target type
orthogonal_vector(vertices::Ngon{D, T}) where {D, T} = orthogonal_vector(Vec3{T}, vertices)
function orthogonal_vector(vertices::NTuple{N, VT}) where {N, D, T, VT <: VecTypes{D, T}}
    return orthogonal_vector(Vec3{T}, vertices)
end
function orthogonal_vector(vertices::AbstractArray{VT}) where {D, T, VT <: VecTypes{D, T}}
    return orthogonal_vector(Vec3{T}, vertices)
end
# fallback to Vec3f if vertices is something else
orthogonal_vector(vertices) = orthogonal_vector(Vec3f, vertices)

"""
    normals(positions::Vector{Point3{T}}, faces::Vector{<: NgonFace}[; normaltype = Vec3{T}])

Compute vertex normals from the given `positions` and `faces`.

This runs through all faces, computing a face normal each and adding it to every
involved vertex. The direction of the face normal is based on winding direction
and assumed counter-clockwise faces. At the end the summed face normals are
normalized again to produce a vertex normal.
"""
function normals(vertices::AbstractVector{Point{3,T}}, faces::AbstractVector{F};
                 normaltype=Vec{3,T}) where {T,F<:NgonFace}
    return normals(vertices, faces, normaltype)
end

function normals(vertices::AbstractVector{<:Point{3}}, faces::AbstractVector{<: NgonFace},
                 ::Type{NormalType}) where {NormalType}

    normals_result = zeros(NormalType, length(vertices))
    for face in faces
        v = vertices[face]
        # we can get away with two edges since faces are planar.
        n = orthogonal_vector(NormalType, v)
        for i in 1:length(face)
            fi = face[i]
            normals_result[fi] = normals_result[fi] .+ n
        end
    end
    normals_result .= normalize.(normals_result)
    return normals_result
end


"""
    face_normals(positions::Vector{Point3{T}}, faces::Vector{<: NgonFace}[, target_type = Vec3{T}])

Compute face normals from the given `positions` and `faces` and returns an
appropriate `FaceView`.
"""
function face_normals(
        positions::AbstractVector{<:Point3{T}}, fs::AbstractVector{<: AbstractFace};
        normaltype = Vec3{T}) where {T}
    return face_normals(positions, fs, normaltype)
end

@generated function face_normals(positions::AbstractVector{<:Point3}, fs::AbstractVector{F},
        ::Type{NormalType}) where {F<:NgonFace,NormalType}

    # If the facetype is not concrete it likely varies and we need to query it
    # doing the iteration
    FT = ifelse(isconcretetype(F), :($F), :(typeof(f)))

    quote
        normals = resize!(NormalType[], length(fs))
        faces   = resize!(F[], length(fs))

        for (i, f) in enumerate(fs)
            ps = positions[f]
            n = orthogonal_vector(NormalType, ps)
            normals[i] = normalize(n)
            faces[i] = $(FT)(i)
        end

        return FaceView(normals, faces)
    end
end

"""
    intersects(a::Line, b::Line) -> Bool, Point

Intersection of 2 line segments `a` and `b`.
Returns `(intersection_found::Bool, intersection_point::Point)`
"""
# 2D Line-segment intersection algorithm by Paul Bourke and many others.
# http://paulbourke.net/geometry/pointlineplane/
function intersects(a::Line{2,T1}, b::Line{2,T2}; eps = 0) where {T1,T2}
    T = promote_type(T1, T2)
    p0 = zero(Point2{T})

    x1, y1 = a[1]
    x2, y2 = a[2]
    x3, y3 = b[1]
    x4, y4 = b[2]

    denominator = ((y4 - y3) * (x2 - x1)) - ((x4 - x3) * (y2 - y1))
    numerator_a = ((x4 - x3) * (y1 - y3)) - ((y4 - y3) * (x1 - x3))
    numerator_b = ((x2 - x1) * (y1 - y3)) - ((y2 - y1) * (x1 - x3))

    if denominator == 0
        # no intersection: lines are parallel
        return false, p0
    end

    # If we ever need to know if the lines are coincident, we can get that too:
    # denominator == numerator_a == numerator_b == 0 && return :coincident_lines

    # unknown_a and b tell us how far along the line segment the intersection is.
    unknown_a = numerator_a / denominator
    unknown_b = numerator_b / denominator

    # Values between [0, 1] mean the intersection point of the lines rests on
    # both of the line segments.
    if eps <= unknown_a <= 1-eps && eps <= unknown_b <= 1-eps
        # Substituting an unknown back lets us find the intersection point.
        x = x1 + (unknown_a * (x2 - x1))
        y = y1 + (unknown_a * (y2 - y1))
        return true, Point2{T}(x, y)
    end

    # lines intersect, but outside of at least one of these line segments.
    return false, p0
end

function simple_concat(vec::AbstractVector, range, endpoint::P) where {P}
    result = Vector{P}(undef, length(range) + 1)
    for (i, j) in enumerate(range)
        result[i] = vec[mod1(j, length(vec))]
    end
    result[end] = endpoint
    return result
end

function consecutive_pairs(arr)
    n = length(arr)
    return zip(view(arr, 1:(n - 1)), view(arr, 2:n))
end

"""
    self_intersections(points::AbstractVector{<:Point})

Finds all self intersections of in a continuous line described by `points`.
Returns a Vector of indices where each pair `v[2i], v[2i+1]` refers two
intersecting line segments by their first point, and a Vector of intersection
points.

Note that if two points are the same, they will generate a self intersection
unless they are consecutive segments. (The first and last point are assumed to
be shared between the first and last segment.)
"""
function self_intersections(points::AbstractVector{<:VecTypes{D, T}}) where {D, T}
    ti, sections = _self_intersections(points)
    # convert array of tuples to flat array
    return [x for t in ti for x in t], sections
end

function _self_intersections(points::AbstractVector{<:VecTypes{D, T}}) where {D, T}
    sections = similar(points, 0)
    intersections = Tuple{Int, Int}[]

    N = length(points)

    for i in 1:N-3
        a = points[i]; b = points[i+1]
        # i+1 == j describes consecutive segments which are always "intersecting"
        # at point i+1/j. Skip those (start at i+2)
        # Special case: We assume points[1] == points[end] so 1 -> 2 and N-1 -> N
        # always "intersect" at 1/N. Skip this too (end at N-2 in this case)
        for j in i+2 : N-1 - (i == 1)
            a2 = points[j]; b2 = points[j+1]
            intersected, p = intersects(Line(a, b), Line(a2, b2))
            if intersected
                push!(intersections, (i, j))
                push!(sections, p)
            end
        end
    end
    return intersections, sections
end

"""
    split_intersections(points::AbstractVector{<: Point})

Splits polygon `points` into it's self intersecting parts. Only 1 intersection
is handled right now.
"""
function split_intersections(points::AbstractVector{<:VecTypes{N, T}}) where {N, T}
    intersections, sections = _self_intersections(points)
    return if isempty(intersections)
        return [points]
    elseif length(intersections) == 1 && length(sections) == 1
        a, b = intersections[1]
        p = sections[1]
        poly1 = simple_concat(points, (a + 1):b, p)
        poly2 = simple_concat(points, (b + 1):(length(points) + a), p)
        return [poly1, poly2]
    else
        error("More than 1 intersections can't be handled currently. Found: $intersections, $sections")
    end
end

module GeometryBasics

using LinearAlgebra, StaticArrays
using EarCut_jll
import Base: *

using Base: @propagate_inbounds

include("fixed_arrays.jl")
include("offsetintegers.jl")
include("basic_types.jl")

include("primitives/rectangles.jl")
include("primitives/spheres.jl")
include("primitives/cylinders.jl")
include("primitives/pyramids.jl")
include("primitives/particles.jl")
include("primitives/Cone.jl")

include("interfaces.jl")
include("viewtypes.jl")
include("geometry_primitives.jl")
include("meshes.jl")
include("triangulation.jl")
include("lines.jl")
include("boundingboxes.jl")

export AbstractGeometry, GeometryPrimitive
export Mat, Point, Vec
export LineFace, Polytope, Line, NgonFace, convert_simplex
export LineString, MultiLineString, MultiPoint
export AbstractPolygon, Polygon, MultiPolygon
export Simplex, connect, Triangle, NSimplex, Tetrahedron
export QuadFace, coordinates, TetrahedronFace
export TupleView, SimplexFace
export Triangle
export AbstractFace, TriangleFace, QuadFace, GLTriangleFace
export OffsetInteger, ZeroIndex, OneIndex, GLIndex
export decompose, coordinates, faces, normals, decompose_uv, decompose_normals,
       texturecoordinates, vertex_attributes
export expand_faceviews, split_mesh, remove_duplicates
export face_normals
export Tessellation, Normal, UV, UVW
export AbstractMesh, Mesh, MetaMesh, FaceView
export per_face


# all the different predefined mesh types
# Note: meshes can contain arbitrary meta information,
export AbstractMesh

# mesh creation functions
export triangle_mesh, triangle_mesh, uv_mesh
export uv_mesh, normal_mesh, uv_normal_mesh

export height, origin, radius, width, widths
export HyperSphere, Circle, Sphere, Cone
export Cylinder, Pyramid, extremity
export HyperRectangle, Rect, Rect2, Rect3, Rect4, Recti, Rect2i, Rect3i, Rect4i, Rectf, Rect2f, Rect3f, Rect4f, Rectd, Rect2d, Rect3d, Rect4d, RectT
export before, during, meets, overlaps, intersects, finishes, bbox_diff
export centered, direction, area, volume, update
export max_dist_dim, max_euclidean, max_euclideansq, min_dist_dim, min_euclidean
export min_euclideansq, minmax_dist_dim, minmax_euclidean, minmax_euclideansq
export self_intersections, split_intersections

if Base.VERSION >= v"1.8"
    include("precompiles.jl")
end

# Needed for GeometryBasicsGeoInterfaceExt.
# In future this can go away as can use Module dispatch.
function geointerface_geomtype end

end # module

function unit(::Type{T}, i::Integer) where {T <: StaticVector}
    tup = ntuple(Val(length(T))) do j
        return ifelse(i == j, 1, 0)
    end
    return T(tup)
end

macro fixed_vector(name_parent)
    @assert name_parent.head == :(=)
    name, parent = name_parent.args
    expr = quote
        struct $(name){S,T} <: $(parent){S,T}
            data::NTuple{S,T}

            function $(name){S,T}(x::NTuple{S,T}) where {S,T}
                return new{S,T}(x)
            end

            function $(name){S,T}(x::NTuple{S,Any}) where {S,T}
                return new{S,T}(StaticArrays.convert_ntuple(T, x))
            end
        end

        size_or(::Type{$(name)}, or) = or
        eltype_or(::Type{$(name)}, or) = or
        eltype_or(::Type{$(name){S,T} where S}, or) where {T} = T
        eltype_or(::Type{$(name){S,T} where T}, or) where {S} = or
        eltype_or(::Type{$(name){S,T}}, or) where {S,T} = T

        size_or(::Type{$(name){S,T} where S}, or) where {T} = or
        size_or(::Type{$(name){S,T} where T}, or) where {S} = Size{(S,)}()
        size_or(::Type{$(name){S,T}}, or) where {S,T} = (S,)

        # Array constructor
        function $(name){S}(x::AbstractVector{T}) where {S,T}
            @assert S <= length(x)
            return $(name){S,T}(ntuple(i -> x[i], Val(S)))
        end

        function $(name){S,T1}(x::AbstractVector{T2}) where {S,T1,T2}
            @assert S <= length(x)
            return $(name){S,T1}(ntuple(i -> convert(T1, x[i]), Val(S)))
        end

        function $(name){S,T}(x) where {S,T}
            return $(name){S,T}(ntuple(i -> convert(T, x), Val(S)))
        end

        $(name){S}(x::T) where {S,T} = $(name){S,T}(ntuple(i -> x, Val(S)))
        $(name){1,T}(x::T) where {T} = $(name){1,T}((x,))
        $(name)(x::NTuple{S}) where {S} = $(name){S}(x)
        function $(name)(x::T) where {S,T <: Tuple{Vararg{Any,S}}}
            return $(name){S,StaticArrays.promote_tuple_eltype(T)}(x)
        end

        function $(name){S}(x::T) where {S,T <: Tuple}
            return $(name){S,StaticArrays.promote_tuple_eltype(T)}(x)
        end
        $(name){S,T}(x::StaticVector{S}) where {S,T} = $(name){S,T}(Tuple(x))
        $(name){S,T}(x::StaticVector) where {S,T} = $(name){S,T}(ntuple(i -> x[i], S))

        @generated function (::Type{$(name){S,T}})(x::$(name)) where {S,T}
            idx = [:(x[$i]) for i in 1:S]
            return quote
                $($(name)){S,T}($(idx...))
            end
        end

        @generated function Base.convert(::Type{$(name){S,T}}, x::$(name)) where {S,T}
            idx = [:(x[$i]) for i in 1:S]
            return quote
                $($(name)){S,T}($(idx...))
            end
        end

        @generated function (::Type{SV})(x::StaticVector) where {SV <: $(name)}
            len = size_or(SV, size(x))[1]
            return if length(x) == len
                :(SV(Tuple(x)))
            elseif length(x) > len
                elems = [:(x[$i]) for i in 1:len]
                :(SV($(Expr(:tuple, elems...))))
            else
                error("Static Vector too short: $x, target type: $SV")
            end
        end

        @generated function $(name){S}(x::StaticVector{N, T}) where {S, N, T}
            SV = $(name){S, T}
            len = size_or(SV, size(x))[1]
            return if length(x) == len
                :($(SV)(Tuple(x)))
            elseif length(x) > len
                elems = [:(x[$i]) for i in 1:len]
                :($(SV)($(Expr(:tuple, elems...))))
            else
                error("Static Vector too short: $x, target type: $SV")
            end
        end

        Base.@propagate_inbounds function Base.getindex(v::$(name){S,T}, i::Int) where {S,T}
            return v.data[i]
        end

        Base.Tuple(v::$(name)) = v.data
        function Base.convert(::Type{$(name){S,T}}, x::NTuple{S,T}) where {S,T}
            return $(name){S,T}(x)
        end
        function Base.convert(::Type{$(name){S,T}}, x::Tuple) where {S,T}
            return $(name){S,T}(convert(NTuple{S,T}, x))
        end

        @generated function StaticArrays.similar_type(::Type{SV}, ::Type{T},
                                                      s::Size{S}) where {SV <: $(name),T,S}
            return if length(S) === 1
                $(name){S[1],T}
            else
                StaticArrays.default_similar_type(T, s(), Val{length(S)})
            end
        end

        Base.:(*)(a::$name, b::$name) = a .* b
        function Base.broadcasted(f, a::AbstractArray{T}, b::$name) where {T <: $name}
            return Base.broadcasted(f, a, (b,))
        end
    end
    return esc(expr)
end

abstract type AbstractPoint{Dim,T} <: StaticVector{Dim,T} end

@fixed_vector Point = AbstractPoint
@fixed_vector Vec = StaticVector



const Mat = SMatrix
const VecTypes{N,T} = Union{StaticVector{N,T},NTuple{N,T}}
const Vecf{N} = Vec{N,Float32}
const PointT{T} = Point{N,T} where N
const Pointf{N} = Point{N,Float32}

Base.isnan(p::Union{AbstractPoint,Vec}) = any(isnan, p)
Base.isinf(p::Union{AbstractPoint,Vec}) = any(isinf, p)
Base.isfinite(p::Union{AbstractPoint,Vec}) = all(isfinite, p)

function to_ndim(T::Type{<: VecTypes{N, ET}}, vec::VecTypes{N2}, fillval) where {N,ET,N2}
    T(ntuple(Val(N)) do i
        i > N2 && return ET(fillval)
        @inbounds return vec[i]
    end)
end

## Generate aliases
## As a text file instead of eval/macro, to not confuse code linter

#=
open(joinpath(@__DIR__, "generated-aliases.jl"), "w") do io
    for i in 1:4
        for T in [:Point, :Vec, :Mat]
            namei = "$T$i"
            res = T == :Mat ? "Mat{$i,$i,T,$(i * i)}" : "$T{$i,T}"
            println(io, "const $(namei){T} = $res")
            println(io, "export $namei")
            for (postfix, t) in ["d" => Float64, "f" => Float32, "i" => Int, "ui" => UInt]
                namep = "$T$i$postfix"
                println(io, "const $(namep) = $(namei){$t}")
                println(io, "export $namep")
                # mnamep = "$(mname)$postfix"
                # println(io, "const $mnamep = $mname{$t}")
                # println(io, "export $mnamep")
            end
        end
    end
end
=#

include("generated-aliases.jl")

export Mat, Vec, Point, unit
export Vecf, Pointf

"""
    Vec{N, T}(args...)
    Vec{N, T}(args::Union{AbstractVector, Tuple, NTuple, StaticVector})

Constructs a Vec of length `N` from the given arguments.

Note that Point and Vec don't follow strict mathematical definitions. Instead
we allow them to be used interchangeably.

## Aliases

|        |`T`         |`Float64` |`Float32` |`Int`     |`UInt`    |
|--------|------------|----------|----------|----------|----------|
|`N`     |`Vec{N,T}`  |`Vecd{N}` |`Vecf{N}` |`Veci{N}` |`Vecui{N}`|
|`2`     |`Vec2{T}`   |`Vec2d`   |`Vec2f`   |`Vec2i`   |`Vec2ui`  |
|`3`     |`Vec3{T}`   |`Vec3d`   |`Vec3f`   |`Vec3i`   |`Vec3ui`  |
"""
Vec


"""
    Point{N, T}(args...)
    Point{N, T}(args::Union{AbstractVector, Tuple, NTuple, StaticVector})

Constructs a Point of length `N` from the given arguments.

Note that Point and Vec don't follow strict mathematical definitions. Instead
we allow them to be used interchangeably.

## Aliases

|        |`T`         |`Float64` |`Float32` |`Int`     |`UInt`    |
|--------|------------|----------|----------|----------|----------|
|`N`     |`Point{N,T}`|`Pointd{N}`|`Pointf{N}`|`Pointi{N}`|`Pointui{N}`|
|`2`     |`Point2{T}` |`Point2d` |`Point2f` |`Point2i` |`Point2ui`|
|`3`     |`Point3{T}` |`Point3d` |`Point3f` |`Point3i` |`Point3ui`|
"""
Point

"""
    Mat{R, C, T[, L]}(args::Union{UniformScaling, Tuple, AbstractMatrix})
    Mat{R, C}(args::Union{Tuple, AbstractMatrix})
    Mat{C}(args::Tuple)

Constructs a static Matrix from the given inputs. Can also take multiple numeric
args. If only one size is given the matrix is assumed to be square.

### Aliases

|        |`T`         |`Float64` |`Float32` |`Int`     |`UInt`    |
|--------|------------|----------|----------|----------|----------|
|`N`     |`Mat{N,T}`  |`Matd{N}` |`Matf{N}` |`Mati{N}` |`Matui{N}`|
|`2`     |`Mat2{T}`   |`Mat2d`   |`Mat2f`   |`Mat2i`   |`Mat2ui`  |
|`3`     |`Mat3{T}`   |`Mat3d`   |`Mat3f`   |`Mat3i`   |`Mat3ui`  |
"""
Mat

"""
    Cone{T}(origin::Point3, tip::Point3, radius)

A Cone is a cylinder where one end has a radius of 0. It is defined by an
`origin` with a finite `radius` which linearly decreases to 0 at the `tip`.
"""
struct Cone{T} <: GeometryPrimitive{3, T}
    origin::Point3{T}
    tip::Point3{T}
    radius::T
end

function Cone(origin::Point3{T1}, tip::Point3{T2}, radius::T3) where {T1, T2, T3}
    T = promote_type(T1, T2, T3)
    return Cone{T}(origin, tip, radius)
end

origin(c::Cone) = c.origin
extremity(c::Cone) = c.tip
radius(c::Cone) = c.radius
height(c::Cone) = norm(c.tip - c.origin)
direction(c::Cone) = (c.tip .- c.origin) ./ height(c)

# Note:
# nvertices is matched with Cylinder, where each end has half the vertices. That
# results in less than nvertices for Cone, but allows a Cylinder and a Cone to
# be seamless matched with the same `nvertices`

function coordinates(c::Cone{T}, nvertices=30) where {T}
    nvertices += isodd(nvertices)
    nhalf = div(nvertices, 2)

    R = rotation(c)
    step = 2pi / nhalf

    ps = Vector{Point3{T}}(undef, nhalf + 2)
    for i in 1:nhalf
        phi = (i-1) * step
        ps[i] = R * Point3{T}(c.radius * cos(phi), c.radius * sin(phi), 0) + c.origin
    end
    ps[end-1] = c.tip
    ps[end] = c.origin

    return ps
end

function normals(c::Cone, nvertices = 30)
    nvertices += isodd(nvertices)
    nhalf = div(nvertices, 2)

    R = rotation(c)
    step = 2pi / nhalf

    ns = Vector{Vec3f}(undef, nhalf + 2)
    # shell at origin
    # normals are angled in z direction due to change in radius (from radius to 0)
    # This can be calculated from triangles
    z = radius(c) / height(c)
    norm = 1.0 / sqrt(1 + z*z)
    for i in 1:nhalf
        phi = (i-1) * step
        ns[i] = R * (norm * Vec3f(cos(phi), sin(phi), z))
    end

    # tip - this is undefined / should be all ring angles at once
    # for rendering it is useful to define this as Vec3f(0), because tip normal
    # has no useful value to contribute to the interpolated fragment normal
    ns[end-1] = Vec3f(0)

    # cap
    ns[end] = Vec3f(normalize(c.origin - c.tip))

    faces = Vector{GLTriangleFace}(undef, nvertices)

    # shell
    for i in 1:nhalf
        faces[i] = GLTriangleFace(i, mod1(i+1, nhalf), nhalf+1)
    end

    # cap
    for i in 1:nhalf
        faces[i+nhalf] = GLTriangleFace(nhalf + 2)
    end

    return FaceView(ns, faces)
end

function faces(::Cone, facets=30)
    nvertices = facets + isodd(facets)
    nhalf = div(nvertices, 2)

    faces = Vector{GLTriangleFace}(undef, nvertices)

    # shell
    for i in 1:nhalf
        faces[i] = GLTriangleFace(i, mod1(i+1, nhalf), nhalf+1)
    end

    # cap
    for i in 1:nhalf
        faces[i+nhalf] = GLTriangleFace(i, mod1(i+1, nhalf), nhalf+2)
    end

    return faces
end

@testset "Arithmetics" begin
    rect = Rect2f(0, 7, 20, 3)
    @test (rect + 4) == Rect2f(4, 11, 20, 3)
    @test (rect + Vec(2, -2)) == Rect2f(2, 5, 20, 3)

    @test (rect - 4) == Rect2f(-4, 3, 20, 3)
    @test (rect - Vec(2, -2)) == Rect2f(-2, 9, 20, 3)

    base = Vec3f(1, 2, 3)
    wxyz = Vec3f(-2, 4, 2)
    rect = Rect3f(base, wxyz)
    @test (rect + 4) == Rect3f(base .+ 4, wxyz)
    @test (rect + Vec(2, -2, 3)) == Rect3f(base .+ Vec(2, -2, 3), wxyz)

    @test (rect - 4) == Rect3f(base .- 4, wxyz)
    @test (rect - Vec(2, -2, 7)) == Rect3f(base .- Vec(2, -2, 7), wxyz)

    rect = Rect2f(0, 7, 20, 3)
    @test (rect * 4) == Rect2f(0, 7 * 4, 20 * 4, 3 * 4)
    @test (rect * Vec(2, -2)) == Rect2f(0, -7 * 2, 20 * 2, -3 * 2)

    base = Vec3f(1, 2, 3)
    wxyz = Vec3f(-2, 4, 2)
    rect = Rect3f(base, wxyz)
    @test (rect * 4) == Rect3f(base .* 4, wxyz .* 4)
    @test (rect * Vec(2, -2, 3)) == Rect3f(base .* Vec(2, -2, 3), wxyz .* Vec(2, -2, 3))
end

@testset "Matrix Multiplications" begin
    r = Rect2f(-1, -2, 4, 3)

    # TODO: this seems quite dangerous: We pad points with ones which makes
    #       sense for translations if we go to D+1, but is nonsense if we
    #       go higher dimensions than that.
    M = rand(Mat4f)
    ps = Point2f[M * Point(p..., 1, 1) for p in coordinates(r)]
    @test Rect2f(ps) ≈ M * r

    M = Mat2f(0.5, -0.3, 0.7, 1.5)
    ps = Point2f[M * p for p in coordinates(r)]
    @test Rect2f(ps) ≈ M * r

    r = Rect3f(-1, -2, -3, 2, 4, 1)
    M = rand(Mat4f)
    ps = Point3f[M * Point(p..., 1) for p in coordinates(r)]
    @test Rect3f(ps) ≈ M * r
end

@testset "Constructors & Getters" begin
    rect1 = Rect(Vec(0.0, 0.0), Vec(1.0, 2.0))
    rect2 = Rect(0.0, 0.0, 1.0, 2.0)
    @test rect1 isa GeometryBasics.HyperRectangle{2,Float64}
    @test rect1 == rect2

    prim = Rect(0.0, 0.0, 1.0, 1.0)
    @test length(prim) == 2

    @test width(prim) == 1.0
    @test height(prim) == 1.0

    rect = Rect(0.0, 0.0, 1.0, 1.0)
    @test GeometryBasics.positive_widths(rect) == rect
    @test GeometryBasics.positive_widths(Rect2f(0, 0, -1, -2)) == Rect2f(-1, -2, 1, 2)

    rect1 = @inferred Rect(1, 2, 3, 4, 5, 6, 7, 8)
    rect2 = Rect(Vec(1, 2, 3, 4), Vec(5, 6, 7, 8))
    @test rect1 == rect2

    # Rect1 coordinates
    r = Rect{1,Float32}(0.2, 0.5)
    @test eltype(coordinates(r)) == Point{1,Float32}
    @test coordinates(r) == [Point{1,Float32}(0.2), Point{1,Float32}(0.7)]

    r64 = Rect{1,Float64}(-0.2, 1.3)
    @test eltype(coordinates(r64)) == Point{1,Float64}
    @test coordinates(r64) == [Point{1,Float64}(-0.2), Point{1,Float64}(1.1)]
end

@testset "checks" begin
    @testset "isempty" begin
        @test isempty(Rect2f())
        @test isempty(Rect3f())
        @test isempty(Rect2i())
        @test isempty(Rect(0, 0, 0, 0))
        @test isempty(Rect(0, 0, 0, 0, 0, 0))
        @test isempty(Rect(0, 0, 0, 0, 0, 0))
    end

    @testset "equality" begin
        b1 = Rect2(0.0, 0.0, 2.0, 2.0)
        b2 = Rect2(0, 0, 2, 2)
        @test isequal(b1, b2)
        @test !isequal(b1, Rect2f(0.1, 0, 2, 2))
    end

    @testset "in" begin
        pt = Point(1.0, 1.0)
        b1 = Rect(0.0, 0.0, 1.0, 1.0)
        @test in(pt, b1)
        @test in(Rect2f(0, 0, 1, 1), Rect2f(-1, -1, 3, 3))
        @test in(Rect2f(0, 0, 1, 1), Rect2f(0, 0, 3, 3))
        @test !in(Rect2f(0, 0, 1, 1), Rect2f(0.1, 0, 3, 3))
    end

    @testset "overlaps" begin
        @test !overlaps(Rect2f(-1, -1, 2, 2), Rect2f(-2, -2, 1, 1))
        @test !overlaps(Rect2f(-1, -1, 2, 2), Rect2f(-2, -2, 1, 1.2))
        @test overlaps(Rect2f(-1, -1, 2, 2), Rect2f(-2, -2, 1.2, 1.2))
        @test overlaps(Rect2f(-1, -1, 2, 2), Rect2f(-2, -2, 4, 4))
        @test overlaps(Rect2f(-1, -1, 2, 2), Rect2f(-0.5, -0.5, 1, 1))
        @test overlaps(Rect2f(-1, -1, 2, 2), Rect2f(0.5, 0.5, 1, 1))
        @test !overlaps(Rect2f(-1, -1, 2, 2), Rect2f(1, 1, 1, 1))
        @test !overlaps(Rect2f(-1, -1, 2, 2), Rect2f(2, 2, 1, 1))

        @test !overlaps(Rect2f(-2, -0.1, 0.5, 0.2), Rect2f(-1, -1, 2, 2))
        @test !overlaps(Rect2f(-2, -0.1, 1, 0.2), Rect2f(-1, -1, 2, 2))
        @test overlaps(Rect2f(-2, -0.1, 1.1, 0.2), Rect2f(-1, -1, 2, 2))
        @test overlaps(Rect2f(-2, -0.1, 3, 0.2), Rect2f(-1, -1, 2, 2))
        @test overlaps(Rect2f(-1, -0.1, 3, 0.2), Rect2f(-1, -1, 2, 2))
        @test overlaps(Rect2f(0, -0.1, 3, 0.2), Rect2f(-1, -1, 2, 2))
        @test !overlaps(Rect2f(1, -0.1, 3, 0.2), Rect2f(-1, -1, 2, 2))
        @test !overlaps(Rect2f(2, -0.1, 3, 0.2), Rect2f(-1, -1, 2, 2))

        @test overlaps(Rect3f(-0.3, -0.3, -0.5, 0.6, 0.6, 1.0), Rect3f(-0.2, -0.2, -0.6, 0.4, 0.4, 1.2))
    end
end

@testset "Set Operations" begin
    @testset "split" begin
        rect1 = Rect(Vec(0.0, 0.0), Vec(1.0, 2.0))
        split1, split2 = GeometryBasics.split(rect1, 2, 1)
        @test widths(split1) == widths(split2)
        @test origin(split1) == Vec(0, 0)
        @test origin(split2) == Vec(0, 1)
        @test in(split1, rect1) && in(split2, rect1)
        @test !(in(rect1, split1) || in(rect1, split2))

        rect1 = Rect(Vec(0.0, 0.0, -1.0), Vec(1.0, 2.0, 1.0))
        split1, split2 = GeometryBasics.split(rect1, 1, 0.75)
        @test widths(split1) == Vec(0.75, 2, 1)
        @test widths(split2) == Vec(0.25, 2, 1)
        @test origin(split1) == Vec(0, 0, -1)
        @test origin(split2) == Vec(0.75, 0, -1)
        @test in(split1, rect1) && in(split2, rect1)
        @test !(in(rect1, split1) || in(rect1, split2))
    end

    @testset "union" begin
        h1 = Rect(0.0, 0.0, 1.0, 1.0)
        h2 = Rect(1.0, 1.0, 2.0, 2.0)
        @test union(h1, h2) == Rect2d(0, 0, 3, 3)
        @test union(Rect2f(), Rect2f(0, 0, 1, 1)) == Rect2f(0, 0, 1, 1)
        @test union(Rect2f(0, 0, 1, 1), Rect2f()) == Rect2f(0, 0, 1, 1)
        @test union(Rect3f(0,0,0,1,1,1), Rect3f(-2,-2,-2,1,1,1)) == Rect3f(-2,-2,-2,3,3,3)
    end

    @testset "intersection" begin
        h1 = Rect(0.0, 0.0, 1.0, 1.0)
        h2 = Rect(1.0, 1.0, 2.0, 2.0)
        @test intersect(h1, h2) == Rect()
        @test intersect(Rect2f(0,0,2,1), Rect2f(1,0,1,2)) == Rect2f(1, 0, 1, 1)
        @test intersect(Rect2f(0,0,2,2), Rect2f(1,1,2,2)) == Rect2f(1, 1, 1, 1)
        @test intersect(Rect2f(0,0,2,3), Rect2f(1,1,2,1)) == Rect2f(1, 1, 1, 1)
        @test intersect(Rect2f(0,0,3,3), Rect2f(1,1,1,1)) == Rect2f(1, 1, 1, 1)
    end

    @testset "diff" begin
        a = Rectf(-1, -1, -1, 2, 2, 2)
        # no intersection -> return a
        @test bbox_diff(a, Rectf(2, -1, -1, 2, 2, 2)) == a
        @test bbox_diff(a, Rectf(2, 2, 2, 3, 3, 3)) == a
        @test bbox_diff(a, Rectf(-3, -3, -3, 1, 1, 1)) == a
        @test bbox_diff(a, Rectf(-8, -4, -4, 4, 10, 8)) == a

        # intersection is a chunk < a in every dimension -> return a
        @test bbox_diff(a, Rectf(0, 0, 0, 2, 2, 2)) == a
        @test bbox_diff(a, Rectf(-2, -4, -1, 2, 3.8, 1)) == a
        @test bbox_diff(a, Rectf(-0.5, -0.5, -1, 1, 1, 2)) == a

        # intersection is matching the size of a in just one dimension -> return a
        @test bbox_diff(a, Rectf(-2, 0, 0, 4, 2, 2)) == a
        @test bbox_diff(a, Rectf(-0.5, -0.5, -2, 1, 1, 10)) == a

        # intersection is a slab matching the size of a in two dimension -> reduced
        @test bbox_diff(a, Rectf(-2, -2, 0, 4, 4, 2)) == Rectf(-1, -1, -1, 2, 2, 1)
        @test bbox_diff(a, Rectf(-5, -2, -2, 5.2, 4, 4)) ≈ Rectf(0.2, -1, -1, 0.8, 2, 2)
        # edge case: bisection
        @test bbox_diff(a, Rectf(-0.5, -2, -2, 1, 4, 4)) == a

        # intersection is a -> empty Rect
        @test bbox_diff(a, Rectf(-2, -2, -2, 4, 4, 4)) == Rect3f()
        @test bbox_diff(a, Rectf(-1, -1, -1, 2, 2, 2)) == Rect3f()
    end
end

@testset "update" begin
    b = Rect(0.0, 0.0, 1.0, 1.0)
    @test update(b, Vec(1, 2)) == Rect2d(0, 0, 1, 2)
    @test update(b, Vec(2.0, 2.0)) == Rect2d(0, 0, 2, 2)
    @test update(b, Vec(-1, 2)) == Rect2d(-1, 0, 2, 2)
end

@testset "euclidean distances" begin
    p = Vec(5.0, 4.0)
    rect = Rect(0.0, 0.0, 1.0, 1.0)
    @test min_dist_dim(rect, p, 1) == 4.0
    @test min_dist_dim(rect, p, 2) == 3.0
    @test max_dist_dim(rect, p, 1) == 5.0
    @test max_dist_dim(rect, p, 2) == 4.0
    @test minmax_dist_dim(rect, p, 1) == (4.0, 5.0)

    rect1 = Rect(0.0, 0.0, 1.0, 1.0)
    rect2 = Rect(3.0, 1.0, 4.0, 2.0)
    @test min_dist_dim(rect1, rect2, 1) == 2.0
    @test min_dist_dim(rect1, rect2, 2) == 0.0
    @test max_dist_dim(rect1, rect2, 1) == 7.0
    @test max_dist_dim(rect1, rect2, 2) == 3.0
    @test minmax_dist_dim(rect1, rect2, 1) == (2.0, 7.0)

    r = Rect2f(-1, -1, 2, 3)
    p = Point2f(1, 2) + Point2f(3, 4)
    @test min_euclidean(r, p) == 5f0
    @test max_euclidean(r, p) ≈ sqrt(5*5 + 7*7)

    r2 = Rect2f(0, 0, 2, 3)
    @test min_euclidean(r, r2) == 0f0
    @test max_euclidean(r, r2) == 5f0
    @test minmax_euclidean(r, r2) == (0f0, 5f0)
end

# Does this make sense to extend to Rects?
@testset "Allen's interval algebra" begin
    rect1 = Rect(0.0, 0.0, 1.0, 1.0)
    rect2 = Rect(3.0, 1.0, 4.0, 2.0)
    @test !before(rect1, rect2)
    rect1 = Rect(0.0, 0.0, 1.0, 1.0)
    rect2 = Rect(3.0, 2.0, 4.0, 2.0)
    @test before(rect1, rect2)

    @test !meets(rect1, rect2)
    rect2 = Rect(1.0, 1.0, 4.0, 2.0)
    @test meets(rect1, rect2)

    rect1 = Rect(1.0, 1.0, 2.0, 2.0)
    rect2 = Rect(0.0, 0.0, 2.0, 1.0)
    @test !overlaps(rect1, rect2)
    rect1 = Rect(1.0, 1.0, 2.0, 2.0)
    rect2 = Rect(1.5, 1.5, 2.0, 2.0)
    @test overlaps(rect1, rect2)

    rect1 = Rect(1.0, 1.0, 2.0, 2.0)
    rect2 = Rect(0.0, 0.0, 2.0, 1.0)
    @test !GeometryBasics.starts(rect1, rect2)
    rect2 = Rect(1.0, 1.0, 1.5, 1.5)
    @test !GeometryBasics.starts(rect1, rect2)
    rect2 = Rect(1.0, 1.0, 3.0, 3.0)
    @test GeometryBasics.starts(rect1, rect2)

    rect1 = Rect(1.0, 1.0, 2.0, 2.0)
    rect2 = Rect(0.0, 0.0, 4.0, 4.0)
    @test during(rect1, rect2)
    rect1 = Rect(0.0, 0.0, 2.0, 3.0)
    rect2 = Rect(1.0, 1.0, 4.0, 2.0)
    @test !during(rect1, rect2)

    rect1 = Rect(1.0, 1.0, 2.0, 2.0)
    rect2 = Rect(0.0, 0.0, 4.0, 4.0)
    @test !finishes(rect1, rect2)
    rect1 = Rect(1.0, 0.0, 1.0, 1.0)
    rect2 = Rect(0.0, 0.0, 2.0, 1.0)
    @test !finishes(rect1, rect2)
    rect1 = Rect(1.0, 1.0, 1.0, 2.0)
    rect2 = Rect(0.0, 0.0, 2.0, 3.0)
    @test finishes(rect1, rect2)
end

@testset "Utilities" begin
    # TODO: this is effectively 0-indexed... should it be?
    M = reshape(collect(11:100), 10, 9)[1:9, :]
    r = Rect2i(2, 4, 2, 4)
    @test M[r] == [53 63 73 83; 54 64 74 84]
end

"""
    Cylinder{T}(origin::Point3, extremity::Point3, radius)

A `Cylinder` is a 3D primitive defined by an `origin`, an `extremity` (end point)
and a `radius`.
"""
struct Cylinder{T} <: GeometryPrimitive{3, T}
    origin::Point3{T}
    extremity::Point3{T}
    r::T
end

function Cylinder(origin::Point3{T1}, extremity::Point3{T2}, radius::T3) where {T1, T2, T3}
    T = promote_type(T1, T2, T3)
    Cylinder{T}(origin, extremity, radius)
end

origin(c::Cylinder) = c.origin
extremity(c::Cylinder) = c.extremity
radius(c::Cylinder) = c.r
height(c::Cylinder) = norm(c.extremity - c.origin)
direction(c::Cylinder) = (c.extremity .- c.origin) ./ height(c)

"""
    rotation(prim::GeometryPrimitive)
    rotation(direction::VecTypes{3})

Creates a rotation matrix `R` that rotates the z direction to `direction`. The
x and y directions remain orthogonal to `direction`, i.e act as radial directions.
"""
rotation(prim::GeometryPrimitive) = rotation(direction(prim))
function rotation(d3::VecTypes{3, T}) where {T}
    u = Vec{3, T}(d3[1], d3[2], d3[3])
    if abs(u[1]) > 0 || abs(u[2]) > 0
        v = Vec{3, T}(u[2], -u[1], T(0))
    else
        v = Vec{3, T}(T(0), -u[3], u[2])
    end
    v = normalize(v)
    w = Vec{3, T}(u[2] * v[3] - u[3] * v[2], -u[1] * v[3] + u[3] * v[1],
                  u[1] * v[2] - u[2] * v[1])
    return Mat{3, 3, T}(v..., w..., u...)
end

function coordinates(c::Cylinder{T}, nvertices=30) where {T}
    nvertices += isodd(nvertices)
    nhalf = div(nvertices, 2)

    R = rotation(c)
    step = 2pi / nhalf

    ps = Vector{Point3{T}}(undef, nvertices + 2)
    for i in 1:nhalf
        phi = (i-1) * step
        ps[i] = R * Point3{T}(c.r * cos(phi), c.r * sin(phi), 0) + c.origin
    end
    for i in 1:nhalf
        phi = (i-1) * step
        ps[i + nhalf] = R * Point3{T}(c.r * cos(phi), c.r * sin(phi), 0) + c.extremity
    end
    ps[end-1] = c.origin
    ps[end] = c.extremity

    return ps
end

function normals(c::Cylinder, nvertices = 30)
    nvertices += isodd(nvertices)
    nhalf = div(nvertices, 2)

    R = rotation(c)
    step = 2pi / nhalf

    ns = Vector{Vec3f}(undef, nhalf + 2)
    for i in 1:nhalf
        phi = (i-1) * step
        ns[i] = R * Vec3f(cos(phi), sin(phi), 0)
    end
    ns[end-1] = R * Vec3f(0, 0, -1)
    ns[end] = R * Vec3f(0, 0, 1)

    disk1 = map(i -> GLTriangleFace(nhalf+1), 1:nhalf)
    mantle = map(i -> QuadFace(i, mod1(i+1, nhalf), mod1(i+1, nhalf), i), 1:nhalf)
    disk2 = map(i -> GLTriangleFace(nhalf+2), 1:nhalf)
    fs = vcat(disk1, mantle, disk2)

    return FaceView(ns, fs)
end

function faces(::Cylinder, facets=30)
    nvertices = facets + isodd(facets)
    nhalf = div(nvertices, 2)

    disk1 = map(i -> GLTriangleFace(nvertices+1, mod1(i+1, nhalf), i), 1:nhalf)
    mantle = map(1:nhalf) do i
        i1 = mod1(i+1, nhalf)
        QuadFace(i, i1, i1 + nhalf, i+nhalf)
    end
    disk2 = map(i -> GLTriangleFace(nvertices+2, i+nhalf, mod1(i+1, nhalf)+nhalf), 1:nhalf)

    return vcat(disk1, mantle, disk2)
end

"""
    HyperRectangle{N, T}

A `HyperRectangle` is a generalization of a rectangle into N-dimensions.
Formally it is the Cartesian product of intervals, which is represented by the
`origin` and `widths` fields, whose indices correspond to each of the `N` axes.
"""
struct HyperRectangle{N,T} <: GeometryPrimitive{N,T}
    origin::Vec{N,T}
    widths::Vec{N,T}

    function HyperRectangle{N, T}(o::VecTypes, w::VecTypes) where {N, T}
        return new{N, T}(convert(Vec{N, T}, o), convert(Vec{N, T}, w))
    end
    function HyperRectangle{N, T}(o::VecTypes, w::VecTypes) where {N, T <: Integer}
        return new{N, T}(convert(Vec{N, T}, round.(T, o)), convert(Vec{N, T}, round.(T, w)))
    end
end

##
# Constructors & typealiases

"""
    const Rect{N,T} = HyperRectangle{N,T}

A rectangle in N dimensions, formally the Cartesian product of intervals. See also [`HyperRectangle`](@ref). Its aliases are

|        |`T`(eltype)|`Float64` |`Float32` |`Int`     |
|--------|-----------|----------|----------|----------|
|`N`(dim)|`Rect{N,T}`|`Rectd{N}`|`Rectf{N}`|`Recti{N}`|
|`2`     |`Rect2{T}` |`Rect2d`  |`Rect2f`  |`Rect2i`  |
|`3`     |`Rect3{T}` |`Rect3d`  |`Rect3f`  |`Rect3i`  |
|`4`     |`Rect4{T}` |`Rect4d`  |`Rect4f`  |`Rect4i`  |

There is an additional unexported alias `RectT` that simply reverses the order of type parameters: `RectT{T,N} == Rect{N,T}`.

"""
Rect, Rect2, Rect3, Rect4, RectT, Rectd, Rect2d, Rect3d, Rect4d, Rectf, Rect2f, Rect3f, Rect4f, Recti, Rect2i, Rect3i, Rect4i

const Rect{N,T} = HyperRectangle{N,T}
const Rect2{T} = Rect{2,T}
const Rect3{T} = Rect{3,T}
const Rect4{T} = Rect{4,T}

const RectT{T,N} = Rect{N,T}

const Rectd{N} = Rect{N,Float64}
const Rect2d = Rect2{Float64}
const Rect3d = Rect3{Float64}
const Rect4d = Rect4{Float64}

const Rectf{N} = Rect{N,Float32}
const Rect2f = Rect2{Float32}
const Rect3f = Rect3{Float32}
const Rect4f = Rect4{Float32}

const Recti{N} = Rect{N,Int}
const Rect2i = Rect2{Int}
const Rect3i = Rect3{Int}
const Rect4i = Rect4{Int}


# Constructors


Rect() = Rect{2,Float32}()
RectT{T}() where {T} = Rect{2,T}()
Rect{N}() where {N} = Rect{N,Float32}()

function Rect{N,T}() where {T,N}
    # empty constructor such that update will always include the first point
    return Rect{N,T}(Vec{N,T}(typemax(T)), Vec{N,T}(typemin(T)))
end

# Rect(numbers...)
Rect(args::Vararg{Number, N}) where {N} = Rect{div(N, 2), promote_type(typeof.(args)...)}(args...)
RectT{T}(args::Vararg{Number, N}) where {N, T} = Rect{div(N, 2), T}(args...)
Rect{N}(args::Vararg{Number}) where {N} = Rect{N, promote_type(typeof.(args)...)}(args...)

"""
    Rect(vals::Number...)

Rect constructor for individually specified intervals.
e.g. Rect(0,0,1,2) has origin == Vec(0,0) and
width == Vec(1,2)
"""
function Rect{N, T}(vals::Vararg{Number, M}) where {N, M, T}
    n, r = fldmod(M, 2)
    if r != 0 || n != N
        throw(ArgumentError("Number of arguments must be compatible with given or derived Rect size. Got $M arguments for a Rect{$N} expecting $(2 * N)."))
    end
    origin, widths = ntuple(i -> vals[i], N), ntuple(i -> vals[i+N], N)
    return Rect{N, T}(Vec(origin), Vec(widths))
end

# VecTypes

     Rect(o::VecTypes{N, T1}, w::VecTypes{N, T2}) where {N, T1, T2} = Rect{N, promote_type(T1, T2)}(o, w)
RectT{ T}(o::VecTypes{N},     w::VecTypes{N})     where {N, T}      = Rect{N, T}(o, w)
Rect{N  }(o::VecTypes{N, T1}, w::VecTypes{N, T2}) where {N, T1, T2} = Rect{N, promote_type(T1, T2)}(o, w)

# Arrays

      Rect(o::AbstractVector{T1}, w::AbstractVector{T2}) where {T1, T2}    = RectT{promote_type(T1, T2)}(Vec(o...), Vec(w...))
RectT{  T}(o::AbstractVector,     w::AbstractVector)     where {T}         = RectT{T}(Vec(o...), Vec(w...))
Rect{N   }(o::AbstractVector{T1}, w::AbstractVector{T2}) where {N, T1, T2} = Rect{N, promote_type(T1, T2)}(Vec(o...), Vec(w...))
Rect{N, T}(o::AbstractVector, w::AbstractVector) where {N, T}              = Rect{N, T}(Vec(o...), Vec(w...))

# mixed number - vectype

      Rect(o::VecTypes{N, <:Number}, args::Vararg{Number, N}) where {N}    = Rect{N   }(o, promote(args...))
RectT{  T}(o::VecTypes{N, <:Number}, args::Vararg{Number, N}) where {N, T} = Rect{N, T}(o, promote(args...))
Rect{N   }(o::VecTypes{N, <:Number}, args::Vararg{Number, N}) where {N}    = Rect{N   }(o, promote(args...))
Rect{N, T}(o::VecTypes{N, <:Number}, args::Vararg{Number, N}) where {N, T} = Rect{N, T}(o, promote(args...))

      Rect(x::Number, y::Number, w::VecTypes{2, <:Number})           = Rect{2   }(Vec(x, y), w)
RectT{  T}(x::Number, y::Number, w::VecTypes{2, <:Number}) where {T} = Rect{2, T}(Vec(x, y), w)
Rect{2   }(x::Number, y::Number, w::VecTypes{2, <:Number})           = Rect{2   }(Vec(x, y), w)
Rect{2, T}(x::Number, y::Number, w::VecTypes{2, <:Number}) where {T} = Rect{2, T}(Vec(x, y), w)

      Rect(x::Number, y::Number, z::Number, w::VecTypes{3, <:Number})           = Rect{3   }(Vec(x, y, z), w)
RectT{  T}(x::Number, y::Number, z::Number, w::VecTypes{3, <:Number}) where {T} = Rect{3, T}(Vec(x, y, z), w)
Rect{3   }(x::Number, y::Number, z::Number, w::VecTypes{3, <:Number})           = Rect{3   }(Vec(x, y, z), w)
Rect{3, T}(x::Number, y::Number, z::Number, w::VecTypes{3, <:Number}) where {T} = Rect{3, T}(Vec(x, y, z), w)

# copy constructors (allow explicit truncation)

      Rect(r::Rect{N, T}) where {N, T}      = Rect{N, T}(origin(r), widths(r))
RectT{  T}(r::Rect{N})    where {N, T}      = Rect{N, T}(origin(r), widths(r))
Rect{N   }(r::Rect{N2, T}) where {N, N2, T} = Rect{N, T}(Vec{min(N, N2), T}(origin(r)), Vec{min(N, N2), T}(widths(r)))
Rect{N, T}(r::Rect{N2})    where {N, N2, T} = Rect{N, T}(Vec{min(N, N2), T}(origin(r)), Vec{min(N, N2), T}(widths(r)))

# dimensional promotion

Rect{3, T}(o::VecTypes{2}, w::VecTypes{3}) where {T} = Rect{3, T}(Vec(o..., 0), w)
Rect{3, T}(o::VecTypes{3}, w::VecTypes{2}) where {T} = Rect{3, T}(o,            Vec(w..., 0))
Rect{3, T}(o::VecTypes{2}, w::VecTypes{2}) where {T} = Rect{3, T}(Vec(o..., 0), Vec(w..., 0))

# centered Rects

centered(R::Type{Rect{N,T}}) where {N,T} = R(Vec{N,T}(-0.5), Vec{N,T}(1))
centered(R::Type{RectT{T}}) where {T} = R(Vec{2,T}(-0.5), Vec{2,T}(1))
centered(R::Type{Rect{N}}) where {N} = R(Vec{N,Float32}(-0.5), Vec{N,Float32}(1))
centered(R::Type{Rect}) = R(Vec{2,Float32}(-0.5), Vec{2,Float32}(1))

# TODO These are kinda silly
function Rect2(xy::NamedTuple{(:x, :y)}, wh::NamedTuple{(:width, :height)})
    return Rect2(xy.x, xy.y, wh.width, wh.height)
end

Rect(ow::Tuple) = Rect(ow...)
RectT{T}(ow::Tuple) where {T} = RectT{T}(ow...)
Rect{N}(ow::Tuple) where {N} = Rect{N}(ow...)
Rect{N, T}(ow::Tuple) where {N, T} = Rect{N, T}(ow...)


# Utilities


# allow auto-conversion between different eltypes
Base.convert(::Type{Rect{N, T}}, r::Rect{N}) where {N, T} = Rect{N, T}(r)

origin(prim::Rect) = prim.origin
Base.maximum(prim::Rect) = origin(prim) + widths(prim)
Base.minimum(prim::Rect) = origin(prim)
Base.length(prim::Rect{N,T}) where {T,N} = N
widths(prim::Rect) = prim.widths

width(prim::Rect) = prim.widths[1]
height(prim::Rect) = prim.widths[2]

volume(prim::HyperRectangle) = prod(prim.widths)
area(prim::Rect2) = volume(prim)

# function Base.round(::Type{Rect{N, T}}, x::Rect{N}, mode::RoundingMode=RoundNearest) where {N, T}
#     mini = round.(T, minimum(x))
#     maxi = round.(T, maximum(x))
#     return Rect{N, T}(mini, maxi .- mini)
# end

"""
    split(rectangle, axis, value)

Splits an Rect into two along an axis at a given location.
"""
split(b::Rect, axis, value::Integer) = _split(b, axis, value)
split(b::Rect, axis, value::Number) = _split(b, axis, value)
function _split(b::H, axis, value) where {H<:Rect}
    bmin = minimum(b)
    bmax = maximum(b)
    b1max = Base.setindex(bmax, value, axis)
    b2min = Base.setindex(bmin, value, axis)

    return H(bmin, b1max - bmin), H(b2min, bmax - b2min)
end

###
# Algebraic operations

"""
    *(m::Mat, h::Rect)

Transform a `Rect` using a matrix. Maintains axis-align properties
so a significantly larger Rect may be generated.
"""
function Base.:(*)(m::Mat{N1,N1,T1}, h::Rect{N2,T2}) where {N1,N2,T1,T2}

    # TypeVar constants
    T = promote_type(T1, T2)
    D = N1 - N2

    # get all points on the Rect
    d = decompose(Point, h)
    # make sure our points are sized for the transform
    pts = (Vec{N1,T}[vcat(pt, ones(Vec{D,T})) for pt in d]...,)::NTuple{2^N2,Vec{N1,T}}

    vmin = Vec{N1,T}(typemax(T))
    vmax = Vec{N1,T}(typemin(T))
    # transform all points, tracking min and max points
    for pt in pts
        pn = m * pt
        vmin = min.(pn, vmin)
        vmax = max.(pn, vmax)
    end
    return Rect{N2,T}(vmin, vmax - vmin)
end

# equal dimension case
function Base.:(*)(m::Mat{N,N,T1}, h::Rect{N,T2}) where {N,T1,T2}

    # TypeVar constants
    T = promote_type(T1, T2)

    # get all points on the Rect
    pts = decompose(Point, h)

    # make sure our points are sized for the transform
    vmin = Vec{N,T}(typemax(T))
    vmax = Vec{N,T}(typemin(T))

    # transform all points, tracking min and max points
    for pt in pts
        pn = m * Vec(pt)
        vmin = min.(pn, vmin)
        vmax = max.(pn, vmax)
    end
    return Rect{N,T}(vmin, vmax - vmin)
end

# fast path. TODO make other versions fast without code duplications like now
function Base.:(*)(m::Mat{4,4,T}, h::Rect{3,T}) where {T}
    # equal dimension case

    # get all points on the Rect
    pts = (Vec{4,T}(0.0, 0.0, 0.0, 1.0), Vec{4,T}(1.0, 0.0, 0.0, 1.0),
           Vec{4,T}(0.0, 1.0, 0.0, 1.0), Vec{4,T}(1.0, 1.0, 0.0, 1.0),
           Vec{4,T}(0.0, 0.0, 1.0, 1.0), Vec{4,T}(1.0, 0.0, 1.0, 1.0),
           Vec{4,T}(0.0, 1.0, 1.0, 1.0), Vec{4,T}(1.0, 1.0, 1.0, 1.0))

    # make sure our points are sized for the transform
    vmin = Vec{4,T}(typemax(T))
    vmax = Vec{4,T}(typemin(T))
    o, w = origin(h), widths(h)
    _o = Vec{4,T}(o[1], o[2], o[3], T(0))
    _w = Vec{4,T}(w[1], w[2], w[3], T(1))
    # transform all points, tracking min and max points
    for pt in pts
        pn = m * (_o + (pt .* _w))
        vmin = min.(pn, vmin)
        vmax = max.(pn, vmax)
    end
    _vmin = Vec{3,T}(vmin[1], vmin[2], vmin[3])
    _vmax = Vec{3,T}(vmax[1], vmax[2], vmax[3])
    return Rect{3,T}(_vmin, _vmax - _vmin)
end

Base.:(-)(h::Rect{N,T}, move::Number) where {N,T} = h - Vec{N,T}(move)
Base.:(+)(h::Rect{N,T}, move::Number) where {N,T} = h + Vec{N,T}(move)

function Base.:(-)(h::Rect{N,T}, move::StaticVector{N}) where {N,T}
    return Rect{N,T}(minimum(h) .- move, widths(h))
end

function Base.:(+)(h::Rect{N,T}, move::StaticVector{N}) where {N,T}
    return Rect{N,T}(minimum(h) .+ move, widths(h))
end

function Base.:(*)(rect::Rect, scaling::Union{Number,StaticVector})
    return Rect(minimum(rect) .* scaling, widths(rect) .* scaling)
end

# Enables rectangular indexing into a matrix
function Base.to_indices(A::AbstractMatrix{T}, I::Tuple{Rect2{IT}}) where {T,IT<:Integer}
    rect = I[1]
    mini = minimum(rect)
    wh = widths(rect)
    return ((mini[1] + 1):(mini[1] + wh[1]), (mini[2] + 1):(mini[2] + wh[2]))
end

function _minmax(p::StaticVector, vmin, vmax)
    any(isnan, p) && return (vmin, vmax)
    return min.(p, vmin), max.(p, vmax)
end

# TODO: doesn't work regardless
# Annoying special case for view(Vector{Point}, Vector{Face})
# function Base.minmax(tup::Tuple, vmin, vmax)
#     for p in tup
#         any(isnan, p) && continue
#         vmin = min.(p, vmin)
#         vmax = max.(p, vmax)
#     end
#     return vmin, vmax
# end

function positive_widths(rect::Rect{N,T}) where {N,T}
    mini, maxi = minimum(rect), maximum(rect)
    realmin = min.(mini, maxi)
    realmax = max.(mini, maxi)
    return Rect{N,T}(realmin, realmax .- realmin)
end

###
# set operations

"""
    isempty(h::Rect[; volumetric = true])

Return `true` if the rectangle is empty.

By default (`volumetric = true`) a `Rect{D}` is considered empty if its
D-dimensional volume is empty, i.e. if any of the widths are 0. Alternatively
(`volumetric = false`) all of its widths are zero.
"""
function Base.isempty(h::Rect{N,T}; volumetric = true) where {N,T}
    degenerate = any(<=(zero(T)), h.widths)
    empty = all(<=(zero(T)), h.widths)
    return ifelse(volumetric, degenerate, empty)
end

"""
    union(r1::Rect{N}, r2::Rect{N})

Returns a new `Rect{N}` which contains both r1 and r2.
"""
function Base.union(h1::Rect{N}, h2::Rect{N}) where {N}
    isempty(h1, volumetric = false) && return h2
    isempty(h2, volumetric = false) && return h1
    mini = min.(minimum(h1), minimum(h2))
    maxi = max.(maximum(h1), maximum(h2))
    return Rect{N}(mini, maxi - mini)
end

# TODO: Add a diff that returns the slabs created. This could be anywhere between
# 0 (r2 fully covers r1) to 2*D (?) (r2 is fully inside r1)
"""
    bbox_diff(r1::Rect{N}, r2::Rect{N})

Returns the bounding box of the difference "r1 - r2".
"""
function bbox_diff(a::Rect{D, T1}, b::Rect{D, T2}) where {D, T1, T2}
    T = promote_type(T1, T2)
    cut_left = minimum(a) .>= minimum(b)
    cut_right = maximum(a) .<= maximum(b)
    a_fully_inside_b = cut_left .&& cut_right
    fully_outside = any((minimum(a) .> maximum(b)) .|| (maximum(a) .< minimum(b)))
    N = sum(a_fully_inside_b)
    if N == D # intersection is a
        return Rect{D, T}()
    end

    mini = ifelse.(a_fully_inside_b, minimum(a), ifelse.(cut_right, minimum(a), maximum(b)))
    maxi = ifelse.(a_fully_inside_b, maximum(a), ifelse.(cut_left, maximum(a), minimum(b)))
    widths = maxi - mini
    if (N == D - 1) && !fully_outside && all(>=(0), widths)
        # one dimension is not fully cut && shapes instersect &&
        # b does not bisect a (cut_left and cut_right are both false => mini, maxi become maxi, mini of b)
        return Rect{D, T}(mini, maxi .- mini)
    end
    return Rect{D, T}(a)
end


"""
    intersect(h1::Rect, h2::Rect)

Perform a intersection between two Rects.
"""
function Base.intersect(h1::Rect{N, T1}, h2::Rect{N, T2}) where {N, T1, T2}
    T = promote_type(T1, T2)
    overlaps(h1, h2) || return Rect{N, T}()
    m = max.(minimum(h1), minimum(h2))
    mm = min.(maximum(h1), maximum(h2))
    return Rect{N, T}(m, mm - m)
end

function update(b::Rect{N,T}, v::VecTypes{N,T2}) where {N,T,T2}
    return update(b, Vec{N,T}(v))
end

function update(b::Rect{N,T}, v::VecTypes{N,T}) where {N,T}
    m = min.(minimum(b), v)
    maxi = maximum(b)
    ws = if any(isnan, maxi)
        v - m
    else
        max.(v, maxi) - m
    end
    return Rect{N,T}(m, ws)
end

# Min maximum distance functions between hrectangle and point for a given dimension
function min_dist_dim(rect::Rect{N,T}, p::VecTypes{N,T}, dim::Int) where {N,T}
    return max(zero(T), max(minimum(rect)[dim] - p[dim], p[dim] - maximum(rect)[dim]))
end

function max_dist_dim(rect::Rect{N,T}, p::VecTypes{N,T}, dim::Int) where {N,T}
    return max(maximum(rect)[dim] - p[dim], p[dim] - minimum(rect)[dim])
end

function min_dist_dim(rect1::Rect{N,T}, rect2::Rect{N,T}, dim::Int) where {N,T}
    return max(zero(T),
               max(minimum(rect1)[dim] - maximum(rect2)[dim],
                   minimum(rect2)[dim] - maximum(rect1)[dim]))
end

function max_dist_dim(rect1::Rect{N,T}, rect2::Rect{N,T}, dim::Int) where {N,T}
    return max(maximum(rect1)[dim] - minimum(rect2)[dim],
               maximum(rect2)[dim] - minimum(rect1)[dim])
end

# Total minimum maximum distance functions
function min_euclideansq(rect::Rect{N,T}, p::Union{VecTypes{N,T},Rect{N,T}}) where {N,T}
    minimum_dist = T(0.0)
    for dim in 1:length(p)
        d = min_dist_dim(rect, p, dim)
        minimum_dist += d * d
    end
    return minimum_dist
end

function max_euclideansq(rect::Rect{N,T}, p::Union{VecTypes{N,T},Rect{N,T}}) where {N,T}
    maximum_dist = T(0.0)
    for dim in 1:length(p)
        d = max_dist_dim(rect, p, dim)
        maximum_dist += d * d
    end
    return maximum_dist
end

function min_euclidean(rect::Rect{N,T}, p::Union{VecTypes{N,T},Rect{N,T}}) where {N,T}
    return sqrt(min_euclideansq(rect, p))
end

function max_euclidean(rect::Rect{N,T}, p::Union{VecTypes{N,T},Rect{N,T}}) where {N,T}
    return sqrt(max_euclideansq(rect, p))
end

# Functions that return both minimum and maximum for convenience
function minmax_dist_dim(rect::Rect{N,T}, p::Union{VecTypes{N,T},Rect{N,T}},
                         dim::Int) where {N,T}
    minimum_d = min_dist_dim(rect, p, dim)
    maximum_d = max_dist_dim(rect, p, dim)
    return minimum_d, maximum_d
end

function minmax_euclideansq(rect::Rect{N,T}, p::Union{VecTypes{N,T},Rect{N,T}}) where {N,T}
    minimum_dist = min_euclideansq(rect, p)
    maximum_dist = max_euclideansq(rect, p)
    return minimum_dist, maximum_dist
end

function minmax_euclidean(rect::Rect{N,T}, p::Union{VecTypes{N,T},Rect{N,T}}) where {N,T}
    minimumsq, maximumsq = minmax_euclideansq(rect, p)
    return sqrt(minimumsq), sqrt(maximumsq)
end

# http://en.wikipedia.org/wiki/Allen%27s_interval_algebra
# These don't really make sense for rectangles though?

function before(b1::Rect{N}, b2::Rect{N}) where {N}
    for i in 1:N
        maximum(b1)[i] < minimum(b2)[i] || return false
    end
    return true
end

meets(b1::Rect{N}, b2::Rect{N}) where {N} = maximum(b1) == minimum(b2)

"""
    overlaps(a::Rect, b::Rect)

Returns true if the given rectangles overlap, i.e. if their intersection is not
empty.
"""
function overlaps(a::Rect{N}, b::Rect{N}) where {N}
    mini1 = minimum(a)
    maxi1 = maximum(a)
    mini2 = minimum(b)
    maxi2 = maximum(b)

    return all(mini1 .< maxi2) && all(maxi1 .> mini2)
end

function starts(b1::Rect{N}, b2::Rect{N}) where {N}
    if minimum(b1) == minimum(b2)
        for i in 1:N
            maximum(b1)[i] < maximum(b2)[i] || return false
        end
        return true
    else
        return false
    end
end

function during(b1::Rect{N}, b2::Rect{N}) where {N}
    for i in 1:N
        maximum(b1)[i] < maximum(b2)[i] && minimum(b1)[i] > minimum(b2)[i] || return false
    end
    return true
end

function finishes(b1::Rect{N}, b2::Rect{N}) where {N}
    return if maximum(b1) == maximum(b2)
        for i in 1:N
            minimum(b1)[i] > minimum(b2)[i] || return false
        end
        return true
    else
        return false
    end
end

###
# Containment

"""
    in(b1::Rect, b2::Rect)

Check if Rect `b1` is contained in `b2`. This does not use
strict inequality, so Rects may share faces and this will still
return true.
"""
function Base.in(b1::Rect{N}, b2::Rect{N}) where {N}
    for i in 1:N
        maximum(b1)[i] <= maximum(b2)[i] && minimum(b1)[i] >= minimum(b2)[i] || return false
    end
    return true
end

"""
    in(pt::VecTypes, b1::Rect{N, T})

Check if a point is contained in a Rect. This will return true if
the point is on a face of the Rect.
"""
function Base.in(pt::VecTypes, b1::Rect{N,T}) where {T,N}
    for i in 1:N
        pt[i] <= maximum(b1)[i] && pt[i] >= minimum(b1)[i] || return false
    end
    return true
end

#
# Equality
#
Base.:(==)(b1::Rect, b2::Rect) = origin(b1) == origin(b2) && widths(b1) == widths(b2)

function Base.isapprox(r1::Rect, r2::Rect; kwargs...)
    return isapprox(origin(r1), origin(r2); kwargs...) && isapprox(widths(r1), widths(r2); kwargs...)
end

##
# Rect1 decomposition
function coordinates(rect::Rect{1, T}) where {T}
    w = widths(rect)
    o = origin(rect)
    return [Point{1,T}(o[1]), Point{1,T}(o[1]+w[1])]
end

##
# Rect2 decomposition

function faces(rect::Rect2, nvertices=(2, 2))
    if nvertices == (2, 2)
        return [QuadFace(1,2,3,4)]
    else
        w, h = nvertices
        idx = LinearIndices(nvertices)
        quad(i, j) = QuadFace{Int}(idx[i, j], idx[i + 1, j], idx[i + 1, j + 1], idx[i, j + 1])
        return [quad(i, j) for j in 1:(h - 1) for i in 1:(w - 1)]
    end
end

function coordinates(rect::Rect2{T}, nvertices=(2, 2)) where {T}
    mini, maxi = extrema(rect)
    if nvertices == (2, 2)
        return Point2{T}[mini, (maxi[1], mini[2]), maxi, (mini[1], maxi[2])]
    else
        xrange, yrange = LinRange.(mini, maxi, nvertices)
        return [Point(x, y) for y in yrange for x in xrange]
    end
end

function texturecoordinates(rect::Rect2{T}, nvertices=(2, 2)) where {T}
    ps = coordinates(Rect2{T}(0, 0, 1, 1), nvertices)
    ps = [Vec2{T}(0, 1) .+ Vec2{T}(1, -1) .* p for p in ps]
    return ps
end

function normals(rect::Rect2, nvertices=(2, 2))
    return Iterators.repeated((0, 0, 1), prod(nvertices))
end

##
# Rect3 decomposition
function coordinates(rect::Rect3{T}) where T
    # TODO use n
    w = widths(rect)
    o = origin(rect)
    return Point{3, T}[o + (x, y, z) .* w for x in (0, 1) for y in (0, 1) for z in (0, 1)]
end

function normals(::Rect3)
    ns = Vec3f[(-1,0,0), (1,0,0), (0,-1,0), (0,1,0), (0,0,-1), (0,0,1)]
    return FaceView(ns, QuadFace{Int}.(1:6))
end

function texturecoordinates(rect::Rect3)
    return coordinates(Rect3(0, 0, 0, 1, 1, 1))
end

function faces(::Rect3)
    return QuadFace{Int}[
        (1, 2, 4, 3), (7, 8, 6, 5), (5, 6, 2, 1),
        (3, 4, 8, 7), (1, 3, 7, 5), (6, 8, 4, 2)
    ]
end

"""
    mesh(primitive::GeometryPrimitive[; pointtype = Point, facetype = GLTriangleFace, vertex_attributes...])

Creates a mesh from a given `primitive` with the given `pointtype` and `facetype`.

This method only generates positions and faces from the primitive. Additional
vertex attributes like normals and texture coordinates can be given as extra
keyword arguments.

Note that vertex attributes that are `nothing` get removed before creating a mesh.

See also: [`triangle_mesh`](@ref), [`normal_mesh`](@ref), [`uv_mesh`](@ref), [`uv_normal_mesh`](@ref)
"""
function mesh(primitive::AbstractGeometry; pointtype=Point, facetype=GLTriangleFace, vertex_attributes...)
    positions = decompose(pointtype, primitive)

    # TODO: consider not allowing FaceView here?
    if positions isa FaceView
        positions = positions.data
        _fs = positions.faces
        isnothing(faces(primitive)) || @error("A primitive should not define `faces` and use a FaceView for `coordinates()`. Using faces from FaceView.")
    else
        # This tries `faces(prim)` first, then triangulation with the natural
        # position type of the primitive.
        _fs = decompose(facetype, primitive)
    end

    # If faces returns nothing for primitive, we try to triangulate!
    if isnothing(_fs)
        if eltype(positions) <: Point2
            # try triangulation with the converted positions as a last attempt
            fs = decompose(facetype, positions)
        else
            error("No triangulation for $(typeof(primitive))")
        end
    else
        fs = _fs
    end

    return mesh(positions, collect(fs); facetype = facetype, vertex_attributes...)
end

"""
    mesh(positions, faces[, facetype = GLTriangleFace, vertex_attributes...])

Creates a mesh from the given positions and faces. Other vertex attributes like
normals and texture coordinates can be added as keyword arguments.

Note that vertex attributes that are `nothing` get removed before creating a mesh.

See also:[`normal_mesh`](@ref)
"""
function mesh(
        positions::AbstractVector{<:Point},
        faces::AbstractVector{FT};
        facetype=GLTriangleFace, vertex_attributes...
    ) where {FT <: AbstractFace}

    fs = decompose(facetype, faces)

    names = keys(vertex_attributes)
    valid_names = filter(name -> !isnothing(vertex_attributes[name]), names)
    vals = convert_facetype.(Ref(facetype), getindex.(Ref(vertex_attributes), valid_names))
    va = NamedTuple{valid_names}(vals)

    return Mesh(positions, fs; va...)
end

"""
    mesh(mesh::Mesh[; pointtype = Point, facetype = GLTriangleFace, vertex_attributes...]

Recreates the given `mesh` with the given `pointtype`, `facetype` and vertex
attributes. If the new mesh would match the old mesh, the old mesh is returned instead.

Note that vertex attributes that are `nothing` get removed before creating a mesh.
"""
function mesh(
        mesh::Mesh{D, T, FT}; pointtype = Point{D, Float32},
        facetype::Type{<: AbstractFace} = GLTriangleFace,
        attributes...
    ) where {D, T, FT <: AbstractFace}

    names = keys(attributes)
    valid_names = filter(name -> !isnothing(attributes[name]), names)

    if isempty(valid_names) && (GeometryBasics.pointtype(mesh) == pointtype) && (FT == facetype)
        return mesh
    else
        vals = getindex.(Ref(attributes), valid_names)
        va = NamedTuple{valid_names}(vals)

        # add vertex attributes
        va = merge(vertex_attributes(mesh), va)
        # convert position attribute and facetypes in FaceViews
        va = NamedTuple{keys(va)}(map(keys(va)) do name
            val = name == :position ? decompose(pointtype, va[:position]) : va[name]
            return convert_facetype(facetype, val)
        end)

        # update main face type
        f, views = decompose(facetype, faces(mesh), mesh.views)
        return Mesh(va, f, views)
    end
end

"""
    mesh(polygon::AbstractVector{P}; pointtype=P, facetype=GLTriangleFace)

Create a mesh from a polygon given as a vector of points, using triangulation.
"""
function mesh(polygon::AbstractVector{P}; pointtype=P, facetype=GLTriangleFace) where {P<:Point{2}}
    return mesh(Polygon(polygon); pointtype=pointtype, facetype=facetype)
end

"""
    triangle_mesh(primitive::GeometryPrimitive[; pointtype = Point, facetype = GLTriangleFace])

Creates a simple triangle mesh from a given `primitive` with the given `pointtype`
and `facetype`.

See also: [`triangle_mesh`](@ref), [`normal_mesh`](@ref), [`uv_mesh`](@ref), [`uv_normal_mesh`](@ref)
"""
function triangle_mesh(
        primitive::Union{AbstractGeometry{N}, AbstractVector{<: Point{N}}};
        pointtype = Point{N, Float32}, facetype = GLTriangleFace
    ) where {N}
    return mesh(primitive; pointtype = pointtype, facetype = facetype)
end

pointtype(::Mesh{D, T}) where {D, T} = Point{D, T}
facetype(::Mesh{D, T, FT}) where {D, T, FT} = FT

"""
    uv_mesh(primitive::GeometryPrimitive{N}[; pointtype = Point{N, Float32}, facetype = GLTriangleFace, uvtype = Vec2f])

Creates a triangle mesh with texture coordinates from a given `primitive`. The
`pointtype`, `facetype` and `uvtype` are set by the corresponding keyword arguments.

See also: [`triangle_mesh`](@ref), [`normal_mesh`](@ref), [`uv_mesh`](@ref), [`uv_normal_mesh`](@ref)
"""
function uv_mesh(
        primitive::AbstractGeometry{N}; pointtype = Point{N, Float32},
        uvtype = Vec2f, facetype = GLTriangleFace
    ) where {N}

    return mesh(
        primitive, uv = decompose_uv(uvtype, primitive),
        pointtype = pointtype, facetype = facetype
    )
end

"""
    uv_normal_mesh(primitive::GeometryPrimitive{N}[; pointtype = Point{N, Float32}, facetype = GLTriangleFace, uvtype = Vec2f, normaltype = Vec3f])

Creates a triangle mesh with texture coordinates and normals from a given
`primitive`. The `pointtype`, `facetype` and `uvtype` and `normaltype` are set
by the corresponding keyword arguments.

See also: [`triangle_mesh`](@ref), [`normal_mesh`](@ref), [`uv_mesh`](@ref), [`uv_normal_mesh`](@ref)
"""
function uv_normal_mesh(
        primitive::AbstractGeometry{N}; pointtype = Point{N, Float32},
        uvtype = Vec2f, normaltype = Vec3f, facetype = GLTriangleFace
    ) where {N}

    return mesh(
        primitive, uv = decompose_uv(uvtype, primitive),
        normal = decompose_normals(normaltype, primitive),
        pointtype = pointtype, facetype = facetype
    )
end

"""
    uv_normal_mesh(primitive::GeometryPrimitive{N}[; pointtype = Point{N, Float32}, facetype = GLTriangleFace, uvtype = Vec2f, normaltype = Vec3f])

Creates a triangle mesh with texture coordinates and normals from a given
`primitive`. The `pointtype`, `facetype` and `uvtype` and `normaltype` are set
by the corresponding keyword arguments.

See also: [`triangle_mesh`](@ref), [`normal_mesh`](@ref), [`uv_mesh`](@ref), [`uv_normal_mesh`](@ref)
"""
function normal_mesh(
        points::AbstractVector{<:Point}, faces::AbstractVector{<:AbstractFace};
        pointtype = Point3f, normaltype = Vec3f, facetype = GLTriangleFace
    )
    _points = decompose(pointtype, points)
    _faces = decompose(facetype, faces)
    return Mesh(_faces, position = _points, normal = normals(_points, _faces, normaltype))
end

"""
    normal_mesh(primitive::GeometryPrimitive{N}[; pointtype = Point{N, Float32}, facetype = GLTriangleFace, normaltype = Vec3f])

Creates a triangle mesh with normals from a given `primitive`. The `pointtype`, `facetype` and `uvtype` and `normaltype` are set
by the corresponding keyword arguments.

See also: [`triangle_mesh`](@ref), [`normal_mesh`](@ref), [`uv_mesh`](@ref), [`uv_normal_mesh`](@ref)
"""
function normal_mesh(
        primitive::AbstractGeometry{N}; pointtype = Point{N, Float32},
        normaltype = Vec3f, facetype = GLTriangleFace
    ) where {N}

    return mesh(
        primitive, normal = decompose_normals(normaltype, primitive),
        pointtype = pointtype, facetype = facetype)
end


"""
    volume(triangle)

Calculate the signed volume of one tetrahedron. Be sure the orientation of your
surface is right.
"""
function volume(triangle::Triangle{3, T}) where {T}
    v1, v2, v3 = triangle
    sig = sign(orthogonal_vector(Vec3{T}, triangle) ⋅ v1)
    return sig * abs(v1 ⋅ (v2 × v3)) / 6
end

"""
    volume(mesh)

Calculate the signed volume of all tetrahedra. Be sure the orientation of your
surface is right.
"""
function volume(mesh::Mesh)
    return sum(volume, mesh)
end


"""
    merge(meshes::AbstractVector{Mesh})

Generates a new mesh containing all the data of the individual meshes.

If all meshes are consistent in their use of FaceViews they will be preserved.
Otherwise all of them will be converted with `expand_faceviews(mesh)`.

This function will generate `views` in the new mesh which correspond to the
inputs of this function.
"""
function Base.merge(meshes::AbstractVector{<:Mesh})
    return if isempty(meshes)
        return Mesh(Point3f[], GLTriangleFace[])

    elseif length(meshes) == 1
        return meshes[1]

    else
        m1 = meshes[1]

        # Check that all meshes use the same VertexAttributes
        # Could also do this via typing the function, but maybe error is nice?
        names = keys(vertex_attributes(m1))
        if !all(m -> keys(vertex_attributes(m)) == names, meshes)
            idx = findfirst(m -> keys(vertex_attributes(m)) != names, meshes)
            error(
                "Cannot merge meshes with different vertex attributes. " *
                "First missmatch between meshes[1] with $names and " *
                "meshes[$idx] with $(keys(vertex_attributes(meshes[idx])))."
            )
        end

        consistent_face_views = true
        for name in names
            is_face_view = getproperty(m1, name) isa FaceView
            for i in 2:length(meshes)
                if (getproperty(meshes[i], name) isa FaceView) != is_face_view
                    consistent_face_views = false
                    @goto DOUBLE_BREAK
                end
            end
        end
        @label DOUBLE_BREAK

        if consistent_face_views

            # All the same kind of face, can just merge
            new_attribs = NamedTuple{names}(map(names) do name
                if name === :position
                    D = maximum(ndims, meshes)
                    T = mapreduce(m -> eltype(pointtype(m)), promote_type, meshes)
                    PT = Point{D, T}
                    return reduce(vcat, decompose.(PT, meshes))
                else
                    return reduce(vcat, getproperty.(meshes, name))
                end
            end)
            fs = reduce(vcat, faces.(meshes))

            # TODO: is the type difference in offset bad?
            idx = length(faces(m1))
            offset = length(coordinates(m1))
            views = isempty(m1.views) ? UnitRange{UInt32}[1:idx] : copy(m1.views)

            for mesh in Iterators.drop(meshes, 1)
                N = length(faces(mesh))

                # update face indices
                for i = idx .+ (1:N)
                    # TODO: face + Int changes type to Int
                    fs[i] = typeof(fs[i])(fs[i] .+ offset)
                end

                # add views
                if isempty(mesh.views)
                    push!(views, idx+1 : idx+N)
                else
                    for view in mesh.views
                        push!(views, view .+ idx)
                    end
                end

                idx += N
                offset += length(coordinates(mesh))
            end

            return Mesh(new_attribs, fs, views)

        else # mixed FaceViews and Arrays

            # simplify to VertexFace types, then retry merge
            return merge(expand_faceviews.(meshes))

        end

    end
end

"""
    expand_faceviews(mesh::Mesh)

Returns the given `mesh` if it contains no FaceViews. Otherwise, generates a new
mesh that contains no FaceViews, reordering and duplicating vertex attributes
as necessary. If the mesh has `views` they will be adjusted as needed to produce
the same submeshes.
"""
function expand_faceviews(mesh::Mesh)
    main_fs = faces(mesh)
    va = vertex_attributes(mesh)

    names = filter(name -> va[name] isa FaceView, keys(va))
    isempty(names) && return mesh

    other_fs = faces.(getproperty.((mesh,), names))
    names = (:position, names...)
    all_fs = tuple(main_fs, other_fs...)

    if isempty(mesh.views)

        new_fs, maps = merge_vertex_indices(all_fs)

        named_maps = NamedTuple{tuple(names...)}(maps)

        new_va = NamedTuple{keys(va)}(map(keys(va)) do name
            values(va[name])[get(named_maps, name, maps[1])]
        end)

        return Mesh(new_va, new_fs)

    else

        new_fs = sizehint!(eltype(main_fs)[], length(main_fs))
        new_views = sizehint!(UnitRange{UInt32}[], length(mesh.views))
        new_va = NamedTuple{keys(va)}(map(keys(va)) do name
            sizehint!(similar(values(va[name]), 0), length(va[name]))
        end)

        vertex_index_counter = eltype(first(main_fs))(1)

        for idxs in mesh.views
            view_fs, maps = merge_vertex_indices(view.(all_fs, (idxs,)), vertex_index_counter)

            vertex_index_counter += length(maps[1])

            for name in keys(new_va)
                map = maps[something(findfirst(==(name), names), 1)]
                append!(new_va[name], values(va[name])[map])
            end

            # add new faces and new view
            start = length(new_fs) + 1
            append!(new_fs, view_fs)
            push!(new_views, start:length(new_fs))
        end

        return Mesh(new_va, new_fs, new_views)
    end
end

expand_faceviews(m::MetaMesh) = MetaMesh(expand_faceviews(Mesh(m)), meta(m))

function merge_vertex_indices(
        faces::NTuple{N_Attrib, <: AbstractVector{FT}},
        vertex_index_counter::Integer = T(1)
    ) where {N, T, FT <: AbstractFace{N, T}, N_Attrib}

    N_faces = length(faces[1])

    # maps a combination of old indices in MultiFace to a new vertex_index
    vertex_index_map = Dict{NTuple{N_Attrib, T}, T}()

    # Faces after conversion
    new_faces = sizehint!(FT[], N_faces)

    # indices that remap attributes
    attribute_indices = ntuple(n -> sizehint!(UInt32[], N_faces), N_Attrib)

    # keep track of the remapped indices for one vertex so we don't have to
    # query the dict twice
    temp = Vector{T}(undef, N)

    for multi_face in zip(faces...)

        for i in 1:N
            # get the i-th set of vertex indices from multi_face, i.e.
            # (multi_face.position_index[i], multi_face.normal_index[i], ...)
            vertex = ntuple(n -> multi_face[n][i], N_Attrib)

            # if the vertex exists, get it's index
            # otherwise register it with the next available vertex index
            temp[i] = get!(vertex_index_map, vertex) do
                vertex_index_counter += 1
                push!.(attribute_indices, vertex)
                return vertex_index_counter - 1
            end
        end

        # generate new face
        push!(new_faces, FT(temp))
    end

    # in case we are reserving more than needed
    sizehint!(new_faces, length(new_faces))

    return new_faces, attribute_indices
end


"""
    split_mesh(mesh::Mesh, views::Vector{UnitRange{Int}} = mesh.views)

Creates a new mesh containing `faces(mesh)[range]` for each range in `views`.
This also removes unused vertices.
"""
function split_mesh(mesh::Mesh, views::Vector{<: UnitRange{<: Integer}} = mesh.views)
    return map(views) do idxs
        new_fs, maps = merge_vertex_indices((view(faces(mesh), idxs),))

        names = keys(vertex_attributes(mesh))
        new_va = NamedTuple{names}(map(names) do name
            v = getproperty(mesh, name)
            if v isa FaceView
                _fs, _maps = merge_vertex_indices((view(faces(v), idxs),))
                return FaceView(values(v)[_maps[1]], _fs)
            else
                return v[maps[1]]
            end
        end)

        return Mesh(new_va, new_fs)
    end
end



# two faces are the same if they match or they just cycle indices
"""
    cyclic_equal(face1, face2)

Returns true if two faces are equal up to a cyclic permutation of their indices.
E.g. considers `GLTriangleFace(2,3,1)` equal to `GLTriangleFace(1,2,3)` but not
`GLTriangleFace(2,1,3)`.
"""
function cyclic_equal(f1::FT, f2::FT) where {N, FT <: AbstractFace{N}}
    _, min_i1 = findmin(f1.data)
    _, min_i2 = findmin(f2.data)
    @inbounds for i in 1:N
        if f1[mod1(min_i1 + i, end)] !== f2[mod1(min_i2 + i, end)]
            return false
        end
    end
    return true
end

"""
    cyclic_hash(face[, h::UInt = hash(0)])

Creates a hash for the given face that is equal under cyclic permutation of the
faces indices.
For example `GLTriangleFace(1,2,3)` will have the same hash as `(2,3,1)` and
`(3,1,2)`, but be different from `(1,3,2)` and its cyclic permutations.
"""
function cyclic_hash(f::AbstractFace{N}, h::UInt = hash(0)) where {N}
    _, min_i = findmin(f.data)
    @inbounds for i in min_i:N
        h = hash(f[i], h)
    end
    @inbounds for i in 1:min_i-1
        h = hash(f[i], h)
    end
    return h
end

# Fastpaths
cyclic_equal(f1::FT, f2::FT) where {FT <: AbstractFace{2}} = minmax(f1.data...) == minmax(f2.data...)
cyclic_hash(f::AbstractFace{2}, h::UInt = hash(0)) = hash(minmax(f.data...), h)

function cyclic_equal(f1::FT, f2::FT) where {FT <: AbstractFace{3}}
    return (f1.data == f2.data) || (f1.data == (f2[2], f2[3], f2[1])) ||
        (f1.data == (f2[3], f2[1], f2[2]))
end
function cyclic_hash(f::AbstractFace{3}, h::UInt = hash(0))
    if f[1] < f[2]
        if f[1] < f[3]
            return hash(f.data, h)
        else
            return hash((f[3], f[1], f[2]), h)
        end
    else
        if f[2] < f[3]
            return hash((f[2], f[3], f[1]), h)
        else
            return hash((f[3], f[1], f[2]), h)
        end
    end
end


"""
    remove_duplicates(faces)

Uses a Dict to remove duplicates from the given `faces`.
"""
function remove_duplicates(fs::AbstractVector{FT}) where {FT <: AbstractFace}
    hashmap = Dict{UInt64, FT}()
    foreach(f -> hashmap[cyclic_hash(f)] = f, fs)
    return collect(values(hashmap))
end


function map_coordinates(f, mesh::Mesh)
    result = deepcopy(mesh)
    map_coordinates!(f, result)
    return result
end

function map_coordinates(f, mesh::MetaMesh)
    result = deepcopy(Mesh(mesh))
    map_coordinates!(f, result)
    return MetaMesh(result, meta(mesh))
end

function map_coordinates!(f, mesh::AbstractMesh)
    points = coordinates(mesh)
    map!(f, points, points)
    return mesh
end

function Base.show(io::IO, ::MIME"text/plain", mesh::Mesh{N, T, FT}) where {N, T, FT}
    println(io, "Mesh{$N, $T, $FT}")
    println(io, "    faces: ", length(faces(mesh)))
    for (name, attrib) in pairs(vertex_attributes(mesh))
        println(io, "    vertex $(name): ", attrib isa FaceView ? length(attrib.data) : length(attrib))
    end
end

function Base.show(io::IO, ::Mesh{N, T, FT}) where {N, T, FT}
    print(io, "Mesh{$N, $T, $(FT)}(...)")
end

function Base.show(io::IO, ::MIME"text/plain", mesh::MetaMesh{N, T}) where {N, T}
    FT = eltype(faces(mesh))
    println(io, "MetaMesh{$N, $T, $(FT)}")
    println(io, "    faces: ", length(faces(mesh)))
    for (name, attrib) in pairs(vertex_attributes(mesh))
        println(io, "    vertex $(name): ", length(attrib))
    end
    println(io, "    meta: ", keys(mesh.meta))
end

function Base.show(io::IO, mesh::MetaMesh{N, T}) where {N, T}
    FT = eltype(faces(mesh))
    println(io, "MetaMesh{$N, $T, $(FT)}($(join(keys(meta(mesh)), ", ")))")
end

"""
    per_face(data, faces)
    per_face(data, mesh)

Generates a `FaceView` that applies the given data per face, rather than per
vertex. The result can then be used to create a (new) mesh:
```
mesh(..., attribute_name = per_face(data, faces))
mesh(old_mesh, attribute_name = per_face(data, old_mesh))
```
"""
per_face(data, geom::AbstractGeometry) = per_face(data, faces(geom))
function per_face(data, faces::AbstractVector{<: AbstractFace})
    if length(data) != length(faces)
        error("Length of per-face data $(length(data)) must match the number of faces $(length(faces))")
    end

    return FaceView(data, [typeof(f)(i) for (i, f) in enumerate(faces)])
end
function per_face(data, faces::AbstractVector{FT}) where {N, FT <: AbstractFace{N}}
    if length(data) != length(faces)
        error("Length of per-face data $(length(data)) must match the number of faces $(length(faces))")
    end

    return FaceView(data, FT.(eachindex(faces)))
end

@testset "Meshing a single triangle sometimes returns an empty mesh" begin
    ϕ = (sqrt(5)+1)/2
    p,q,r = Point(ϕ,0,+1),Point(1,ϕ,0),Point(ϕ,0,-1)
    m = triangle_mesh(Triangle(p,q,r))
    @test m isa Mesh
    @test faces(m) == [TriangleFace(1, 2, 3)]
end

@testset "Heterogenous faces" begin
    # https://github.com/JuliaGeometry/GeometryBasics.jl/issues/142
    f = [TriangleFace(1, 2, 3), QuadFace(1, 2, 3, 4)]
    p = Point2f[(0, 1), (1, 2), (3, 4), (4, 5)]
    m = Mesh(p, f)
    @test collect(m) == [Triangle(p[1], p[2], p[3]), GeometryBasics.Quadrilateral(p[1], p[2], p[3], p[4])]
end

@testset "Heterogenous faces" begin
    # https://github.com/JuliaGeometry/GeometryBasics.jl/issues/142
    f = [TriangleFace(1, 2, 3), QuadFace(1, 2, 3, 4)]
    p = Point2f[(0, 1), (1, 2), (3, 4), (4, 5)]
    m = Mesh(p, f)
    @test collect(m) == [Triangle(p[1], p[2], p[3]), GeometryBasics.Quadrilateral(p[1], p[2], p[3], p[4])]

    facedata = FaceView([:red, :blue], [TriangleFace(1), QuadFace(2)])
    m2 = GeometryBasics.mesh(m, color = facedata)
    m3 = expand_faceviews(m2)
    @test faces(m3) == GLTriangleFace[(1,2,3), (4,5,6), (4,6,7)]
    @test coordinates(m3) == Point2f[[0.0, 1.0], [1.0, 2.0], [3.0, 4.0], [0.0, 1.0], [1.0, 2.0], [3.0, 4.0], [4.0, 5.0]]
    @test m3.color == [:red, :red, :red, :blue, :blue, :blue, :blue]

    @test per_face([:red, :blue], f) == facedata
    @test per_face([:red, :blue], m) == facedata
    @test per_face([:red, :blue, :blue], m2) == FaceView([:red, :blue, :blue], GLTriangleFace.(1:3))
    @test per_face([:red, :blue, :blue], m3) == FaceView([:red, :blue, :blue], GLTriangleFace.(1:3))
end

@testset "Ambiguous NgonFace constructors" begin
    # https://github.com/JuliaGeometry/GeometryBasics.jl/issues/151
    # Currently no StaticVector support
    # t = TriangleFace(SA[0.4, 0.2, 0.55])
end

@testset "Merge empty vector of meshes" begin
    # https://github.com/JuliaGeometry/GeometryBasics.jl/issues/136
    merge(Mesh[]) == Mesh(Point3f[], GLTriangleFace[])
    merge([Mesh(Point3f[], GLTriangleFace[])]) == Mesh(Point3f[], GLTriangleFace[])
    merge([Mesh(Point3f[], GLTriangleFace[]), Mesh(Point3f[], GLTriangleFace[])]) == Mesh(Point3f[], GLTriangleFace[])
end

@testset "Vertex Index Remapping" begin
    # Sanity Check
    m = Mesh(
        position = GeometryBasics.FaceView(Point2f[(0, 0), (1, 0), (1, 1), (0, 1)], [QuadFace(1,2,3,4)]),
        normal   = GeometryBasics.FaceView([Vec3f(0,0,1)], [QuadFace(1)])
    )

    m2 = GeometryBasics.expand_faceviews(m)

    @test faces(m) == [QuadFace(1,2,3,4)]
    @test coordinates(m) == Point2f[(0, 0), (1, 0), (1, 1), (0, 1)]
    @test normals(m) == GeometryBasics.FaceView([Vec3f(0,0,1)], [QuadFace(1)])
    @test isempty(m.views)

    @test per_face([Vec3f(0,0,1)], m) == m.normal

    @test faces(m2)  == [QuadFace(1,2,3,4)]
    @test coordinates(m2) == coordinates(m)
    @test normals(m2) != normals(m)
    @test normals(m2) == [only(values(normals(m))) for _ in 1:4]
    @test isempty(m2.views)

    mm = MetaMesh(m, Dict(:test => 1, :a => "a"))
    mm2 = GeometryBasics.expand_faceviews(mm)
    @test mm2.meta == mm.meta
    @test Mesh(mm2) == m2
end

@testset "Duplicate face removal" begin
    fs = GLTriangleFace[(1,2,3), (2,3,4), (3,4,5), (1,2,3), (1,4,5)]
    fs = [fs; fs]
    new_fs = remove_duplicates(fs)
    @test all(f -> f in GLTriangleFace[(1,2,3), (2,3,4), (3,4,5), (1,4,5)], new_fs)

    fs = rand(QuadFace{Int32}, 4)
    new_fs = remove_duplicates([fs; fs])
    @test all(in(fs), new_fs)
end

@testset "complex merge + split" begin
    rects = [Rect3f(Point3f(x, y, z), Vec3f(0.5)) for x in -1:1 for y in -1:1 for z in -1:1]
    direct_meshes = map(rects) do r
        GeometryBasics.Mesh(coordinates(r), faces(r), normal = normals(r))
    end
    dm = merge(direct_meshes)

    @test GeometryBasics.facetype(dm) == QuadFace{Int}
    @test length(faces(dm)) == 27 * 6 # 27 rects, 6 quad faces
    @test length(normals(dm)) == 27 * 6
    @test length(coordinates(dm)) == 27 * 8
    @test normals(dm) isa GeometryBasics.FaceView
    @test coordinates(dm) isa Vector
    @test !allunique([idx for f in faces(dm) for idx in f])
    @test !allunique([idx for f in faces(dm.normal) for idx in f])

    split_meshes = split_mesh(dm)
    @test all(GeometryBasics.strictly_equal_face_vertices.(split_meshes, direct_meshes))

    indirect_meshes = map(rects) do r
        m = GeometryBasics.mesh(coordinates(r), faces(r), normal = normals(r), facetype = QuadFace{Int64})
        # Also testing merge of meshes with views
        push!(m.views, 1:length(faces(m)))
        m
    end
    im = merge(indirect_meshes)

    @test im == dm
    @test GeometryBasics.facetype(im) == QuadFace{Int64}

    split_meshes = split_mesh(im)
    @test all(GeometryBasics.strictly_equal_face_vertices.(split_meshes, indirect_meshes))

    converted_meshes = map(rects) do r
        m = GeometryBasics.Mesh(coordinates(r), faces(r), normal = normals(r))
        GeometryBasics.expand_faceviews(m)
    end
    cm = merge(converted_meshes)

    @test GeometryBasics.facetype(cm) == QuadFace{Int}
    @test length(faces(cm)) == 27 * 6 # 27 rects, 6 quad faces
    @test length(normals(cm)) == 27 * 6 * 4 # duplicate 4x across face
    @test length(coordinates(cm)) == 27 * 8 * 3 # duplicate 3x across shared vertex
    @test normals(cm) isa Vector
    @test coordinates(cm) isa Vector
    @test allunique([idx for f in faces(cm) for idx in f])

    split_meshes = split_mesh(cm)
    @test all(GeometryBasics.strictly_equal_face_vertices.(split_meshes, converted_meshes))

    mixed_meshes = map(direct_meshes, indirect_meshes, converted_meshes) do dm, im, cm
        rand((dm, im, cm)) # (with FaceView, with mesh.views & FaceView, w/o FaceView)
    end
    mm = merge(mixed_meshes)

    @test mm == cm
end

@testset "Mesh Constructor" begin
    ps = rand(Point2f, 10)
    ns = rand(Vec3f, 10)
    fs = GLTriangleFace[(1,2,3), (3,4,5), (5,6,7), (8,9,10)]

    @testset "Extracting faces from position FaceView" begin
        # can't extract from array
        @test_throws TypeError Mesh(position = ps, normal = ns)

        m = Mesh(position = FaceView(ps, fs), normal = ns)
        @test coordinates(m) == ps
        @test normals(m) == ns
        @test faces(m) == fs
    end

    @test_throws MethodError Mesh(Point2f[], GLTriangleFace(1,2,3))

    @testset "Verification" begin
        # enough vertices present
        @test_throws ErrorException Mesh(rand(Point2f, 7), fs)
        m = Mesh(rand(Point2f, 12), fs)
        @test length(m.position) == 12
        @test length(m.faces) == 4

        @test_throws ErrorException Mesh(ps, fs, normal = rand(Vec3f, 8))
        m = Mesh(ps, fs, normal = rand(Vec3f, 12))
        @test length(m.position) == 10
        @test length(m.normal) == 12
        @test length(m.faces) == 4

        # valid FaceView (enough faces, vertices, matching dims)
        @test_throws ErrorException Mesh(ps, fs, normal = FaceView(ns, GLTriangleFace[]))
        @test_throws ErrorException Mesh(ps, fs, normal = FaceView(Vec3f[], fs))
        @test_throws ErrorException Mesh(ps, fs, normal = FaceView(ns, QuadFace{Int}.(1:4)))
        m = Mesh(ps, fs, normal = FaceView(rand(Vec3f, 9), TriangleFace{Int64}.(1:2:8)))
        @test length(m.position) == 10
        @test length(values(m.normal)) == 9
        @test length(faces(m.normal)) == 4
        @test length(m.faces) == 4

        msg = "`normals` as a vertex attribute name has been deprecated in favor of `normal` to bring it in line with mesh.position and mesh.uv"
        @test_logs (:warn, msg) Mesh(ps, fs, normals = ns)
    end
end

@testset "Interface" begin
    ps = rand(Point2f, 10)
    ns = rand(Vec3f, 10)
    uvs = FaceView(rand(Vec2f, 4), GLTriangleFace.(1:4))
    fs = GLTriangleFace[(1,2,3), (3,4,5), (5,6,7), (8,9,10)]

    m = Mesh(ps, fs, normal = ns, uv = uvs)

    @test vertex_attributes(m) == getfield(m, :vertex_attributes)
    @test coordinates(m) == vertex_attributes(m)[:position]
    @test normals(m) == vertex_attributes(m)[:normal]
    @test texturecoordinates(m) == vertex_attributes(m)[:uv]
    @test faces(m) == getfield(m, :faces)

    @test m.vertex_attributes == getfield(m, :vertex_attributes)
    @test m.position == vertex_attributes(m)[:position]
    @test m.normal == vertex_attributes(m)[:normal]
    @test m.uv == vertex_attributes(m)[:uv]
    @test m.faces == getfield(m, :faces)

    @test hasproperty(m, :vertex_attributes)
    @test hasproperty(m, :position)
    @test hasproperty(m, :normal)
    @test hasproperty(m, :uv)
    @test hasproperty(m, :faces)

    @test GeometryBasics.meta(m) == NamedTuple()
    @test Mesh(m) === m

    mm = MetaMesh(m, name = "test")

    @test Mesh(mm) == m
    @test haskey(mm, :name)
    @test get(mm, :name, nothing) == "test"
    @test get(() -> nothing, mm, :name) == "test"
    @test get(mm, :foo, nothing) === nothing
    @test get(() -> nothing, mm, :foo) === nothing
    @test mm[:name] == "test"
    @test !haskey(mm, :foo)
    @test get!(mm, :foo, "foo") == "foo"
    @test haskey(mm, :foo)
    @test get!(() -> "bar", mm, :bar) == "bar"
    @test haskey(mm, :bar)
    mm[:foo] = "bar"
    @test mm[:foo] == "bar"
    delete!(mm, :bar)
    @test !haskey(mm, :bar)
    @test keys(mm) == keys(getfield(mm, :meta))

    @test vertex_attributes(mm) == getfield(m, :vertex_attributes)
    @test coordinates(mm) == vertex_attributes(m)[:position]
    @test normals(mm) == vertex_attributes(m)[:normal]
    @test texturecoordinates(mm) == vertex_attributes(m)[:uv]
    @test faces(mm) == getfield(m, :faces)

    @test hasproperty(mm, :vertex_attributes)
    @test hasproperty(mm, :position)
    @test hasproperty(mm, :normal)
    @test hasproperty(mm, :uv)
    @test hasproperty(mm, :faces)
    @test propertynames(mm) == (:mesh, :meta, propertynames(m)...)

    @test mm.vertex_attributes == getfield(m, :vertex_attributes)
    @test mm.position == vertex_attributes(m)[:position]
    @test mm.normal == vertex_attributes(m)[:normal]
    @test mm.uv == vertex_attributes(m)[:uv]
    @test mm.faces == getfield(m, :faces)

    @test GeometryBasics.meta(mm) == mm.meta
    @test Mesh(mm) === mm.mesh
end

@testset "mesh() constructors" begin
    r = Rect3d(Point3d(-1), Vec3d(2))

    @testset "prerequisites" begin
        ps = coordinates(r)
        @test length(ps) == 8
        @test ps isa Vector{Point3d}
        ns = normals(r)
        @test length(ns) == 6
        @test ns isa GeometryBasics.FaceView{Vec3f, Vector{Vec3f}, Vector{QuadFace{Int}}}
        uvs = texturecoordinates(r)
        @test length(uvs) == 8
        @test_broken uvs isa Vector{Vec2f}
        fs = faces(r)
        @test length(fs) == 6
        @test fs isa Vector{QuadFace{Int}}
    end

    @testset "normal_mesh()" begin
        m = normal_mesh(r, pointtype = Point3f, normaltype = Vec3f)
        m = GeometryBasics.expand_faceviews(m)

        @test hasproperty(m, :position)
        @test coordinates(m) isa Vector{Point3f}
        @test length(coordinates(m)) == 24
        @test GeometryBasics.pointtype(m) == Point3f

        @test hasproperty(m, :normal)
        @test normals(m) isa Vector{Vec3f}
        @test length(normals(m)) == 24

        @test !hasproperty(m, :uv)
        @test texturecoordinates(m) === nothing

        @test faces(m) isa Vector{GLTriangleFace}
        @test length(faces(m)) == 12
        @test GeometryBasics.facetype(m) == GLTriangleFace

        @test normal_mesh(coordinates(m), faces(m)) == m
    end

    @testset "normal_uv_mesh()" begin
        m = uv_normal_mesh(
            r, pointtype = Point3d, normaltype = Vec3d,
            uvtype = Vec3d, facetype = QuadFace{Int32}
        )

        @test hasproperty(m, :position)
        @test coordinates(m) isa Vector{Point3d}
        @test length(coordinates(m)) == 8
        @test GeometryBasics.pointtype(m) == Point3d

        @test hasproperty(m, :normal)
        @test normals(m) isa GeometryBasics.FaceView{Vec3d, Vector{Vec3d}, Vector{QuadFace{Int32}}}
        @test length(normals(m)) == 6

        @test hasproperty(m, :uv)
        @test texturecoordinates(m) isa Vector{Vec3d}
        @test length(texturecoordinates(m)) == 8

        @test faces(m) isa Vector{QuadFace{Int32}}
        @test length(faces(m)) == 6
        @test GeometryBasics.facetype(m) == QuadFace{Int32}
    end

    @testset "uv_mesh()" begin
        m = uv_mesh(
            r, pointtype = Point3f, uvtype = Vec3f, facetype = GLTriangleFace
        )

        @test hasproperty(m, :position)
        @test coordinates(m) isa Vector{Point3f}
        @test length(coordinates(m)) == 8
        @test GeometryBasics.pointtype(m) == Point3f

        @test !hasproperty(m, :normal)
        @test normals(m) === nothing

        @test hasproperty(m, :uv)
        @test texturecoordinates(m) isa Vector{Vec3f}
        @test length(texturecoordinates(m)) == 8

        @test faces(m) isa Vector{GLTriangleFace}
        @test length(faces(m)) == 12
        @test GeometryBasics.facetype(m) == GLTriangleFace
    end

    @testset "triangle_mesh()" begin
        m = triangle_mesh(r, pointtype = Point3f)

        @test hasproperty(m, :position)
        @test coordinates(m) isa Vector{Point3f}
        @test length(coordinates(m)) == 8
        @test GeometryBasics.pointtype(m) == Point3f

        @test !hasproperty(m, :normal)
        @test normals(m) === nothing

        @test !hasproperty(m, :uv)
        @test texturecoordinates(m) === nothing

        @test faces(m) isa Vector{GLTriangleFace}
        @test length(faces(m)) == 12
        @test GeometryBasics.facetype(m) == GLTriangleFace
    end

    @testset "mesh(mesh)" begin
        m = GeometryBasics.mesh(r, pointtype = Point3f, normal = normals(r), facetype = QuadFace{Int64})

        # Should be hit by normal_mesh as well...
        @test coordinates(m) isa Vector{Point3f}
        @test length(coordinates(m)) == 8
        @test normals(m) isa GeometryBasics.FaceView{Vec3f, Vector{Vec3f}, Vector{QuadFace{Int64}}}
        @test length(normals(m)) == 6
        @test !hasproperty(m, :uv)
        @test texturecoordinates(m) === nothing
        @test faces(m) isa Vector{QuadFace{Int64}}
        @test length(faces(m)) == 6

        # Shoudl throw because uv's don't match length(position) or have faces
        @test_throws ErrorException GeometryBasics.mesh(m, uv = Vec3f[])

        # remap vertex attributes to merge faceviews into one face array
        m2 = GeometryBasics.expand_faceviews(m)

        @test coordinates(m2) isa Vector{Point3f}
        @test length(coordinates(m2)) == 24
        @test normals(m2) isa Vector{Vec3f}
        @test length(normals(m2)) == 24
        @test !hasproperty(m2, :uv)
        @test texturecoordinates(m2) === nothing
        @test faces(m2) isa Vector{QuadFace{Int64}}
        @test length(faces(m2)) == 6

        # convert face type and add uvs
        m2 = GeometryBasics.mesh(m2, facetype = GLTriangleFace, uv = decompose(Point3f, m2))

        @test coordinates(m2) isa Vector{Point3f}
        @test length(coordinates(m2)) == 24
        @test normals(m2) isa Vector{Vec3f}
        @test length(normals(m2)) == 24
        @test texturecoordinates(m2) isa Vector{Point3f}
        @test length(texturecoordinates(m2)) == 24
        @test faces(m2) isa Vector{GLTriangleFace}
        @test length(faces(m2)) == 12

    end
end

@testset "map_coordinates" begin
    m = GeometryBasics.mesh(Rect3f(0,0,0,1,1,1))
    m2 = GeometryBasics.map_coordinates(p -> 2 * p, m)
    @test m !== m2
    @test 2 * coordinates(m) == coordinates(m2)

    m3 = GeometryBasics.map_coordinates!(p -> 0.5 * p, m2)
    @test m3 === m2
    @test coordinates(m) == coordinates(m3)

    m = MetaMesh(GeometryBasics.mesh(Rect3f(0,0,0,1,1,1)), meta = "test")
    m2 = GeometryBasics.map_coordinates(p -> 2 * p, m)
    @test m !== m2
    @test 2 * coordinates(m) == coordinates(m2)
    @test GeometryBasics.meta(m) == GeometryBasics.meta(m2)
end

"""
    OffsetInteger{O, T}

OffsetInteger type mainly for indexing.
* `O` - The offset relative to Julia arrays. This helps reduce copying when
communicating with 0-indexed systems such as OpenGL.
"""
struct OffsetInteger{O,T<:Integer} <: Integer
    i::T
    OffsetInteger{O,T}(x::Integer) where {O,T<:Integer} = new{O,T}(T(x + O))
end

const ZeroIndex{T<:Integer} = OffsetInteger{-1,T}
const OneIndex{T<:Integer} = OffsetInteger{0,T}
const GLIndex = ZeroIndex{Cuint}

raw(x::OffsetInteger) = x.i
raw(x::Integer) = x
value(x::OffsetInteger{O,T}) where {O,T} = raw(x) - O
value(x::Integer) = x

function Base.show(io::IO, oi::OIT) where {O, T, OIT <: OffsetInteger{O, T}}
    if OIT === GLIndex
        typename = "GLIndex"
    elseif O == 0
        typename = "OneIndex{$T}"
    elseif O == 1
        typename = "ZeroIndex{$T}"
    else
        typename = "OffsetInteger{$O, $T}"
    end

    print(io, typename, "(", value(oi), ")")
    return
end

Base.eltype(::Type{OffsetInteger{O,T}}) where {O,T} = T
Base.eltype(oi::OffsetInteger) = eltype(typeof(oi))

# constructors and conversion
function OffsetInteger{O1,T1}(x::OffsetInteger{O2,T2}) where {O1,O2,T1<:Integer,T2<:Integer}
    return OffsetInteger{O1,T1}(convert(T2, x))
end

OffsetInteger{O}(x::Integer) where {O} = OffsetInteger{O,eltype(x)}(x)
OffsetInteger{O}(x::OffsetInteger) where {O} = OffsetInteger{O,eltype(x)}(x)
# This constructor has a massive method invalidation as a consequence,
# and doesn't seem to be needed, so let's remove it!

# Need to convert to Int here because of: https://github.com/JuliaLang/julia/issues/35038
Base.to_index(idx::OffsetInteger) = convert(Int, raw(OneIndex(idx)))

Base.convert(::Type{IT}, x::OffsetInteger) where {IT<:Integer} = IT(value(x))
Base.convert(::Type{IT}, x::OffsetInteger) where {IT<:OffsetInteger} = IT(value(x))
Base.convert(::Type{O}, x::Integer) where {O<:OffsetInteger} = O(x)

# basic operators
for op in (:(-), :abs)
    @eval Base.$op(x::T) where {T<:OffsetInteger} = T($(op)(value(x)))
end

for op in (:(+), :(-), :(*), :(/), :div)
    @eval begin
        @inline function Base.$op(x::OffsetInteger{O}, y::OffsetInteger{O}) where {O}
            return OffsetInteger{O}($op(value(x), value(y)))
        end
    end
end

for op in (:(==), :(>=), :(<=), :(<), :(>), :sub_with_overflow)
    @eval begin
        function Base.$op(x::OffsetInteger{O}, y::OffsetInteger{O}) where {O}
            return $op(x.i, y.i)
        end
        Base.$op(x::OffsetInteger, y::OffsetInteger) = $op(value(x), value(y))
        Base.$op(x::OffsetInteger, y::Integer) = $op(value(x), y)
        Base.$op(x::Integer, y::OffsetInteger) = $op(x, value(y))
    end
end

Base.promote_rule(::Type{IT}, ::Type{<:OffsetInteger}) where {IT<:Integer} = IT

function Base.promote_rule(::Type{OffsetInteger{O1,T1}},
                           ::Type{OffsetInteger{O2,T2}}) where {O1,O2,T1<:Integer,
                                                                T2<:Integer}
    return OffsetInteger{pure_max(O1, O2),promote_type(T1, T2)}
end

Base.@pure pure_max(x1, x2) = x1 > x2 ? x1 : x2

Base.hash(o::OffsetInteger{O}, h::UInt) where {O} = hash(o.i, hash(O, h))

@testset "Polygon" begin
    @testset "Constructors" begin
        points = connect([1, 2, 3, 4, 5, 6], Point2f)
        @test points isa Vector{Point2f}
        points = connect([1, 2, 3, 4, 5, 6], Point2)
        @test points isa Vector{Point2{Int}}
        polygon = Polygon(points)
        @test polygon == Polygon(points)
        @test polygon == copy(polygon)
        @test coordinates(polygon) == points
        @test Polygon(OffsetArray(points)) == polygon

        interiors = [rand(Point2f, 4), rand(Point2f, 4)]
        exterior = rand(Point2f, 5)
        p1 = Polygon(exterior, interiors)
        @test p1.interiors == interiors
        @test p1.exterior == exterior
        p2 = Polygon(OffsetArray(exterior, 0), interiors)
        @test p2 == p1

        polygon = Polygon(points)
        mp = MultiPolygon([polygon, p1, p2])
        @test mp.polygons == [polygon, p1, p2]
        @test mp[1] == polygon
        @test mp[2] == p1
        @test size(mp) == (3,) # TODO: What does size even mean here?
        @test length(mp) == 3
        @test MultiPolygon(OffsetArray([polygon, p1, p2], 0)) == mp
        @test MultiPolygon([Polygon(Point2f.(points)), p1, p2]) == mp
    end

    rect = Rect2f(0, 0, 1, 1)
    hole = Tessellation(Circle(Point2f(0.5), 0.2), 8)
    poly2 = Polygon(decompose(Point2f, rect), [decompose(Point2f, hole)])
    poly1 = Polygon(rect, [hole])
    @test poly1 == poly2
    @test poly1.exterior == decompose(Point2f, rect)
    @test poly1.interiors == [decompose(Point2f, hole)]

    # triangulation is inconsistent...
    @test length(faces(poly1)) == 11
    ps = vcat(decompose(Point2f, rect), decompose(Point2f, hole))
    @test coordinates(poly1) == ps

    fs = GeometryBasics.earcut_triangulate([poly1.exterior[[1, 2, 3, 4, 1]]])
    @test fs == GLTriangleFace[(4,1,2), (2,3,4)]

    poly1 = [
        [Point2f(100, 0), Point2f(100, 100), Point2f(0, 100), Point2f(0, 0)],
        # Following polylines define holes.
        [Point2f(75, 25), Point2f(75, 75), Point2f(25, 75), Point2f(25, 25)]
    ]
    fs = GLTriangleFace[(4, 8, 7), (5, 8, 4), (3, 4, 7), (5, 4, 1), (2, 3, 7), (6, 5, 1), (2, 7, 6), (6, 1, 2)]
    @test fs == GeometryBasics.earcut_triangulate(poly1)

    # issue #236
    let p = SA[Point(0.0, 0.0), Point(1.0, 0.0), Point(0.0, 1.0)]
        @test Polygon(p) == Polygon(Array(p))
    end
end

@testset "triangulation" begin
    tri = Triangle(Point2f(-0.5, -0.5), Point2f(0.8, 0), Point2f(0, 0.8))
    for phi in rand(0:2pi, 10)
        @test !in(Point2f(cos(phi), sin(phi)), tri)
    end
    for phi in rand(0:2pi, 10)
        @test in(0.2 * Point2f(cos(phi), sin(phi)), tri)
    end
    @test Point2f(0) in tri # sanity check

    # corner cases
    @test Point2f(-0.5) in tri
    @test Point2f(0, 0.8) in tri
    @test Point2f(0.8, 0) in tri

    # TODO: test snip directly?
    ps = Point2f[(0,0), (1,0), (1,1), (0,1)]
    @test decompose(GLTriangleFace, ps) == GLTriangleFace[(4,1,2), (2,3,4)]

    ps = [Point2f(cos(phi), sin(phi)) for phi in range(0, 2pi, length=8)[1:end-1]]
    fs = decompose(GLTriangleFace, ps)
    @test fs == GLTriangleFace[(7,1,2), (2,3,4), (4,5,6), (6,7,2), (2,4,6)]
    lfs = decompose(LineFace{Int32}, fs)
    for i in 1:7
        @test (LineFace(i, mod1(i+1, 7)) in lfs) || (LineFace(mod1(i+1, 7), i) in lfs)
    end

    @testset "earcut" begin
        ps = Point2i[(-1,-1), (1,-1), (1,1), (-1,1)]
        @test GeometryBasics.earcut_triangulate([Point{2, Int32}.(ps)]) == GLTriangleFace[(3,4,1), (1,2,3)]
        @test GeometryBasics.earcut_triangulate([Point{2, Int64}.(ps)]) == GLTriangleFace[(3,4,1), (1,2,3)]
        @test GeometryBasics.earcut_triangulate([Point{2, Float32}.(ps)]) == GLTriangleFace[(3,4,1), (1,2,3)]
        @test GeometryBasics.earcut_triangulate([Point{2, Float64}.(ps)]) == GLTriangleFace[(3,4,1), (1,2,3)]

        ps2 = Point2i[(0,-1), (1,0), (0,1), (-1,0)]
        @test faces(Polygon(Point2{Int32}.(ps), [Point2{Int32}.(ps2)])) == GLTriangleFace[(4,8,7), (5,8,1), (6,5,2), (3,7,6)]
        @test faces(Polygon(Point2{Int64}.(ps), [Point2{Int64}.(ps2)])) == GLTriangleFace[(4,8,7), (5,8,1), (6,5,2), (3,7,6)]
        @test faces(Polygon(Point2{Int8}.(ps),  [Point2{Int8}.(ps2)]))  == GLTriangleFace[(4,8,7), (5,8,1), (6,5,2), (3,7,6)]
        @test faces(Polygon(Point2{Float32}.(ps), [Point2{Float32}.(ps2)])) == GLTriangleFace[(4,8,7), (5,8,1), (6,5,2), (3,7,6)]
        @test faces(Polygon(Point2{Float64}.(ps), [Point2{Float64}.(ps2)])) == GLTriangleFace[(4,8,7), (5,8,1), (6,5,2), (3,7,6)]
        @test faces(Polygon(Point2{Float16}.(ps), [Point2{Float16}.(ps2)])) == GLTriangleFace[(4,8,7), (5,8,1), (6,5,2), (3,7,6)]
    end
end

using PrecompileTools: @setup_workload, @compile_workload

@setup_workload begin
    @compile_workload begin
        # Hits FaceView, QuadFace, all standard decompose's, some type conversions
        r = Rect3d(Point3d(0), Vec3d(1))
        m1 = uv_normal_mesh(r)

        c = Circle(Point2f(0), 1)
        m2 = uv_normal_mesh(c, pointtype = Point3f) # hits normal gen

        m = merge([m1, m2]) # hits mixed path, expand_faceviews, then normal path
        GeometryBasics.split_mesh(m)
        Rect3d(m)

        # Getters
        vertex_attributes(m)
        coordinates(m)
        normals(m)
        texturecoordinates(m)
        faces(m)
        
        face_normals(coordinates(r), faces(r))

        # Triangulation
        triangle_mesh(Polygon(rand(Point2f, 4)))

        # Other primitives
        uv_normal_mesh(Rect2(0,0,1,1))
        uv_normal_mesh(Tessellation(Sphere(Point3f(0), 1f0), 3))
        uv_normal_mesh(Cylinder(Point3f(0), Point3f(0,0,1), 1f0))
        uv_normal_mesh(Pyramid(Point3f(0), 1f0, 1f0))

        # other disconnected compiles
        M = Mat3f(I)
        inv(M)
        M[1, Vec(1, 3)]
        M * Vec(1,2,3)

        Point2f(0.5, 0.1) in Triangle(Point2f(0), Point2f(0.5, 1), Point2f(1, 0))
        decompose(GLTriangleFace, [Point2f(0), Point2f(0.5, 1), Point2f(1, 0)])
        Point3f(0.5, 0, 1f0) in r 
    end
end

"""
    abstract type AbstractGeometry{Dimension, T<:Number}

Base type for geometry types like GeometryPrimites and Polytopes.
"""
abstract type AbstractGeometry{Dim,T<:Number} end
abstract type GeometryPrimitive{Dim,T} <: AbstractGeometry{Dim,T} end
Base.ndims(::AbstractGeometry{Dim}) where {Dim} = Dim

"""
    Polytope{Dim, T} <: AbstractGeometry{Dim, T}

A Polytope is the generalization of a Polygon to higher dimensions, i.e. a
geometric object consisting of flat faces.

A `Polygon` and `Ngon` are both 2D `Polytope`s. A `Simplex` is the simplest
`Polytope` in arbitrary dimensions.
"""
abstract type Polytope{Dim,T} <: AbstractGeometry{Dim,T} end
abstract type AbstractPolygon{Dim,T} <: Polytope{Dim,T} end

"""
    AbstractFace{N_indices, T} <: StaticVector{N_indices, T}

Parent type for all face types. The standard face type is typically a
`GLTriangleFace = NgonFace{3, GLIndex}`.
"""
abstract type AbstractFace{N,T} <: StaticVector{N,T} end
abstract type AbstractSimplexFace{N,T} <: AbstractFace{N,T} end
abstract type AbstractNgonFace{N,T} <: AbstractFace{N,T} end

abstract type AbstractSimplex{Dim,T} <: Polytope{Dim,T} end

@fixed_vector SimplexFace = AbstractSimplexFace

const TetrahedronFace{T} = SimplexFace{4,T}
Face(::Type{<:SimplexFace{N}}, ::Type{T}) where {N,T} = SimplexFace{N,T}


@fixed_vector NgonFace = AbstractNgonFace

"""
    NgonFace{N, T}

A planar face connecting N vertices. Shorthands include:
- `LineFace{T} = NgonFace{2,T}`
- `TriangleFace{T} = NgonFace{3,T}`
- `QuadFace{T} = NgonFace{4,T}`
- `GLTriangleFace = TriangleFace{GLIndex}`
"""
NgonFace

const LineFace{T} = NgonFace{2,T}
const TriangleFace{T} = NgonFace{3,T}
const QuadFace{T} = NgonFace{4,T}
const GLTriangleFace = TriangleFace{GLIndex}

function Base.show(io::IO, x::NgonFace{N, T}) where {N, T}
    if N == 2
        name = "LineFace{$T}"
    elseif N == 3
        if T == GLIndex
            name = "GLTriangleFace"
        else
            name = "TriangleFace{$T}"
        end
    elseif N == 4
        name = "QuadFace{$T}"
    else
        name = "NgonFace{$N, $T}"
    end

    return print(io, name, "(", join(value.(x), ", "), ")")
end

Face(::Type{<:NgonFace{N}}, ::Type{T}) where {N,T} = NgonFace{N,T}
Face(F::Type{NgonFace{N,FT}}, ::Type{T}) where {FT,N,T} = F

@propagate_inbounds Base.getindex(x::Polytope, i::Integer) = coordinates(x)[i]
@propagate_inbounds Base.iterate(x::Polytope) = iterate(coordinates(x))
@propagate_inbounds Base.iterate(x::Polytope, i) = iterate(coordinates(x), i)

"""
    Ngon{D, T, N}(points::NTuple{N, Point{D, T}})

Defines a flat polygon (without holes) in D dimensional space using N points, e.g.:
- N 1-2 : Illegal!
- N = 3 : Triangle
- N = 4 : Quadrilateral (or Quad, Or tetragon)
- N = 5 : Pentagon
- ...

For polygons with holes, see `Polygon`.
"""
struct Ngon{Dim, T<:Real, N} <: AbstractPolygon{Dim,T}
    points::NTuple{N, Point{Dim, T}}
end

const NNgon{N} = Ngon{Dim,T,N} where {Dim,T}

function (::Type{<: NNgon{N}})(points::Vararg{Point{Dim,T}, N}) where {N,Dim,T}
    return Ngon{Dim,T,N}(points)
end
Base.show(io::IO, x::NNgon{N}) where {N} = print(io, "Ngon{$N}(", join(x, ", "), ")")

# Interfaces
coordinates(x::Ngon) = x.points
# Base Array interface
Base.length(::Type{<:NNgon{N}}) where {N} = N
Base.length(::NNgon{N}) where {N} = N

"""
    Polytope(::Type{<: Point}, ::Type{<: AbstractNgonFace})

The Ngon Polytope element type when indexing an array of points with a SimplexFace
"""
function Polytope(::Type{Point{Dim,T}},
                  ::Type{<:AbstractNgonFace{N,IT}}) where {N,Dim,T,IT}
    return Ngon{Dim,T,N}
end

"""
    Polytope(::Type{<: Ngon}, P::Type{<: Point})

The fully concrete Ngon type, when constructed from a point type!
"""
function Polytope(::Type{<:Ngon{_D, _T, N}}, P::Type{Point{NDim,T}}) where {N,NDim,T, _D,_T}
    return Ngon{NDim,T,N}
end
function Polytope(::Type{<:Ngon{_D, _T, N} where {_D,_T}}, P::Type{Point{NDim,T}}) where {N,NDim,T}
    return Ngon{NDim,T,N}
end

const Line{Dim,T} = Ngon{Dim,T,2}

# Simplex{D, T, 3} & Ngon{D, T, 3} are both representing a triangle.
# Since Ngon is supposed to be flat and a triangle is flat, lets prefer Ngon
# for triangle:
const Triangle{Dim,T} = Ngon{Dim,T,3}
const Triangle3d{T} = Triangle{3,T}
const GLTriangleElement = Triangle{3,Float32}

faces(x::Ngon{Dim, T, N}) where {Dim, T, N} = [NgonFace{N, Int}(ntuple(identity, N))]

Base.show(io::IO, x::Triangle) = print(io, "Triangle(", join(x, ", "), ")")

const Quadrilateral{Dim,T} = Ngon{Dim,T,4}

Base.show(io::IO, x::Quadrilateral) = print(io, "Quadrilateral(", join(x, ", "), ")")

function coordinates(lines::AbstractArray{Line{Dim,T}}) where {Dim,T}
    result = Point{Dim, T}[]
    for line in lines
        append!(result, coordinates(line))
    end
    return result
end

"""
    Simplex{D, T<:Real, N}(points::NTuple{N, Point{D, T}})

A `Simplex` is a generalization of an N-dimensional tetrahedra and can be thought
of as a minimal convex set containing the specified points.

* A 0-simplex is a point.
* A 1-simplex is a line segment.
* A 2-simplex is a triangle.
* A 3-simplex is a tetrahedron.

Note that this datatype is offset by one compared to the traditional
mathematical terminology. So a one-simplex is represented as `Simplex{2,T}`.
This is for a simpler implementation.

It applies to infinite dimensions. The structure of this type is designed
to allow embedding in higher-order spaces by parameterizing on `T`.
"""
struct Simplex{Dim,T<:Real,N} <: AbstractSimplex{Dim,T}
    points::NTuple{N,Point{Dim,T}}
end

const NSimplex{N} = Simplex{Dim,T,N} where {Dim,T}
const Tetrahedron{T} = Simplex{3,T,4}

Base.show(io::IO, x::Tetrahedron) = print(io, "Tetrahedron(", join(x, ", "), ")")

coordinates(x::Simplex) = x.points

function (::Type{<:NSimplex{N}})(points::Vararg{Point{Dim,T},N}) where {Dim,T,N}
    return Simplex{Dim,T,N}(points)
end

# Base Array interface
Base.length(::Type{<:NSimplex{N}}) where {N} = N
Base.length(::NSimplex{N}) where {N} = N

"""
    Polytope(::Type{Point{Dim,T}}, ::Type{<:AbstractSimplexFace{N}})

The Simplex Polytope element type when indexing an array of points with a SimplexFace
"""
function Polytope(::Type{Point{Dim,T}}, ::Type{<:AbstractSimplexFace{N}}) where {N,Dim,T}
    return Simplex{Dim,T,N}
end

"""
    Polytope(::Type{<:NSimplex{N}}, P::Type{Point{NDim,T}})

The fully concrete Simplex type, when constructed from a point type!
"""
function Polytope(::Type{<:NSimplex{N}}, P::Type{Point{NDim,T}}) where {N,NDim,T}
    return Simplex{NDim,T,N}
end
Base.show(io::IO, x::Line) = print(io, "Line(", x[1], " => ", x[2], ")")


"""
    Polygon(exterior::AbstractVector{<:Point})
    Polygon(exterior::AbstractVector{<:Point}, interiors::Vector{<:AbstractVector{<:Point}})

Constructs a polygon from a set of exterior points. If interiors are given, each
of them cuts away from the Polygon.
"""
struct Polygon{Dim,T<:Real} <: AbstractPolygon{Dim,T}
    exterior::Vector{Point{Dim, T}}
    interiors::Vector{Vector{Point{Dim, T}}}
end

Base.copy(x::Polygon) = Polygon(copy(x.exterior), deepcopy(x.interiors))

function Base.:(==)(a::Polygon, b::Polygon)
    return (a.exterior == b.exterior) && (a.interiors == b.interiors)
end

function Polygon(
        exterior::AbstractVector{Point{Dim,T}},
        interiors::AbstractVector{<:AbstractVector{Point{Dim,T}}}) where {Dim, T}
    tov(v) = convert(Vector{Point{Dim, T}}, v)
    return Polygon{Dim,T}(tov(exterior), map(tov, interiors))
end

Polygon(exterior::AbstractVector{Point{N, T}}) where {N, T} = Polygon(exterior, Vector{Point{N, T}}[])

function Polygon(exterior::AbstractVector{Point{Dim,T}},
                 faces::AbstractVector{<:LineFace}) where {Dim, T}
    return Polygon(LineString(exterior, faces))
end

function Polygon(exterior::AbstractGeometry{Dim, T}, interior::AbstractVector=[]) where {Dim, T}
    to_p(v) = decompose(Point{Dim, T}, v)
    int = Vector{Point{Dim, T}}[]
    for i in interior
        push!(int, to_p(i))
    end
    return Polygon(to_p(exterior), int)
end

function coordinates(polygon::Polygon{N,T}) where {N,T}
    exterior = coordinates(polygon.exterior)
    if isempty(polygon.interiors)
        return exterior
    else
        result = Point{N, T}[]
        append!(result, exterior)
        foreach(x -> append!(result, coordinates(x)), polygon.interiors)
        return result
    end
end

function Base.promote_rule(::Type{Polygon{N, T1}}, ::Type{Polygon{N, T2}}) where {N, T1, T2}
    return Polygon{N, promote_type(T1, T2)}
end

function Base.convert(::Type{Polygon{N, T}}, poly::Polygon{N}) where {N, T}
    return Polygon(
        convert(Vector{Point{N, T}}, poly.exterior),
        convert(Vector{Vector{Point{N, T}}}, poly.interiors),
    )
end

"""
    MultiPolygon(polygons::AbstractPolygon)

A collection of polygons
"""
struct MultiPolygon{Dim, T<:Real} <: AbstractGeometry{Dim, T}
    polygons::Vector{<:AbstractPolygon{Dim,T}}
end

function MultiPolygon(polygons::AbstractVector{<:AbstractPolygon{Dim,T}}) where {Dim,T}
    return MultiPolygon(convert(Vector{eltype(polygons)}, polygons))
end

Base.getindex(mp::MultiPolygon, i) = mp.polygons[i]
Base.size(mp::MultiPolygon) = size(mp.polygons)
Base.length(mp::MultiPolygon) = length(mp.polygons)
Base.:(==)(a::MultiPolygon, b::MultiPolygon) = a.polygons == b.polygons

"""
    LineString(points::AbstractVector{<:Point})

A LineString is a collection of points connected by line segments.
"""
struct LineString{Dim, T<:Real} <: AbstractGeometry{Dim, T}
    points::Vector{Point{Dim, T}}
end

function LineString(points::AbstractVector{Point{Dim, T}}) where {Dim, T}
    return LineString{Dim,T}(convert(Vector{Point{Dim, T}}, points))
end

Base.length(ls::LineString) = length(coordinates(ls))
Base.:(==)(a::LineString, b::LineString) = a.points == b.points
coordinates(ls::LineString) = ls.points

struct MultiLineString{Dim, T<:Real} <: AbstractGeometry{Dim, T}
    linestrings::Vector{LineString{Dim, T}}
end

function MultiLineString(linestrings::AbstractVector{L}) where {L<:LineString}
    return MultiLineString(convert(Vector{L}, linestrings))
end

Base.getindex(ms::MultiLineString, i) = ms.linestrings[i]
Base.size(ms::MultiLineString) = size(ms.linestrings)
Base.length(mpt::MultiLineString) = length(mpt.linestrings)
Base.:(==)(a::MultiLineString, b::MultiLineString) = a.linestrings == b.linestrings

"""
    MultiPoint(points::AbstractVector{AbstractPoint})

A collection of points
"""
struct MultiPoint{Dim,T<:Real} <: AbstractGeometry{Dim, T}
    points::Vector{Point{Dim, T}}
end

function MultiPoint(points::AbstractVector{Point{Dim, T}}) where {Dim,T}
    return MultiPoint(convert(Vector{Point{Dim, T}}, points))
end

Base.getindex(mpt::MultiPoint, i) = mpt.points[i]
Base.size(mpt::MultiPoint) = size(mpt.points)
Base.length(mpt::MultiPoint) = length(mpt.points)


"""
    FaceView(data, faces)

A FaceView is an alternative to passing a vertex attribute directly to a mesh.
It bundles `data` with a new set of `faces` which may index that data differently
from the faces defined in a mesh. This can be useful to avoid duplication in `data`.

For example, `data` can be defined per face by giving each face just one (repeated)
index:
```julia
per_face_normals = FaceView(
    normals,                 # one per face
    FT.(eachindex(normals))  # with FT = facetype(mesh)
)
```

If you need a mesh with strictly per-vertex data, e.g. for rendering, you can use
`expand_faceviews(mesh)` to convert every vertex attribute to be per-vertex. This
will duplicate data and reorder faces as needed.

You can get the data of a FaceView with `values(faceview)` and the faces with
`faces(faceview)`.
"""
struct FaceView{T, AVT <: AbstractVector{T}, FVT <: AbstractVector{<: AbstractFace}}
    data::AVT
    faces::FVT
end

const VertexAttributeType{T} = Union{FaceView{T}, AbstractVector{T}}

function Base.vcat(a::FaceView, b::FaceView)
    N = length(a.data)
    return FaceView(
        vcat(a.data, b.data),
        vcat(a.faces, map(f -> typeof(f)(f .+ N), b.faces))
    )
end

faces(x::FaceView) = x.faces
Base.values(x::FaceView) = x.data
facetype(x::FaceView) = eltype(x.faces)
Base.getindex(x::FaceView, f::AbstractFace) = getindex(values(x), f)
Base.isempty(x::FaceView) = isempty(values(x))
Base.:(==)(a::FaceView, b::FaceView) = (values(a) == values(b)) && (faces(a) == faces(b))

# TODO: maybe underscore this as it requires care to make sure all FaceViews and
#       mesh faces stay in sync
convert_facetype(::Type{FT}, x::AbstractVector) where {FT <: AbstractFace} = x
function convert_facetype(::Type{FT}, x::FaceView) where {FT <: AbstractFace}
    if eltype(faces(x)) != FT
        return FaceView(values(x), decompose(FT, faces(x)))
    end
    return x
end

function verify(fs::AbstractVector{FT}, fv::FaceView, name = nothing) where {FT <: AbstractFace}
    if length(faces(fv)) != length(fs)
        error("Number of faces given in FaceView $(length(faces(fv))) does not match reference $(length(fs))")
    end

    N = maximum(f -> value(maximum(f)), faces(fv), init = 0)
    if length(values(fv)) < N
        error("FaceView addresses $N vertices with faces, but only has $(length(values(fv))).")
    end

    if isconcretetype(FT) && (FT == facetype(fv))
        return true
    end

    for (i, (f1, f2)) in enumerate(zip(faces(fv), fs))
        if length(f1) != length(f2)
            error("Length of face $i = $(length(f1)) does not match reference with $(length(f2))")
        end
    end

    return true
end

# Dodgy definitions... (since attributes can be FaceView or Array it's often
#                       useful to treat a FaceView like the vertex data it contains)
Base.length(x::FaceView) = length(values(x))
# Base.iterate(x::FaceView) = iterate(values(x))
# Base.getindex(x::FaceView, i::Integer) = getindex(values(x), i)
# Taken from Base/arrayshow.jl
function Base.show(io::IO, ::MIME"text/plain", X::FaceView)
    summary(io, X)
    isempty(X) && return
    print(io, ":")

    if get(io, :limit, false)::Bool && displaysize(io)[1]-4 <= 0
        return print(io, " …")
    else
        println(io)
    end

    io = IOContext(io, :typeinfo => eltype(values(X)))

    recur_io = IOContext(io, :SHOWN_SET => values(X))
    Base.print_array(recur_io, values(X))
end



"""
    AbstractMesh

An abstract mesh is a collection of Polytope elements (Simplices / Ngons). The
connections are defined via faces(mesh) and the coordinates of the elements are
returned by coordinates(mesh).
"""
abstract type AbstractMesh{Dim, T} <: AbstractGeometry{Dim, T} end

"""
    Mesh{PositionDim, PositionType, FaceType, VertexAttributeNames, VertexAttributeTypes, FaceVectorType} <: AbstractMesh{PositionDim, PositionType} <: AbstractGeometry{PositionDim, PositionType}

The type of a concrete mesh. The associated struct contains 3 fields:

```julia
struct Mesh{...}
    vertex_attributes::NamedTuple{VertexAttributeNames, VertexAttributeTypes}
    faces::FaceVectorType
    views::Vector{UnitRange{Int}}
end
```

A vertex typically carries multiple distinct pieces of data, e.g. a position,
a normal, a texture coordinate, etc. We call those pieces of data vertex
attributes. The `vertex_attributes` field contains the name and a collection
`<: AbstractVector` or `<: FaceView` for each attribute. The n-th element of that
collection is the value of the corresponding attribute for the n-th vertex.

```julia
#                   vertex       1        2        3
vertex_attributes[:position] = [pos1,    pos2,    pos3,    ...]
vertex_attributes[:normal]   = [normal1, normal2, normal3, ...]
...
```

A `NamedTuple` is used here to allow different meshes to carry different vertex
attributes while also keeping things type stable. The constructor enforces a
few restrictions:
- The first attribute must be named `position` and must have a `Point{PositionDim, PositionType}` eltype.
- Each vertex attribute must refer to the same number of vertices. (All vertex attributes defined by
AbstractVector must match in length. For FaceViews, the number of faces needs to match.)

See also: [`vertex_attributes`](@ref), [`coordinates`](@ref), [`normals`](@ref),
[`texturecoordinates`](@ref), [`decompose`](@ref), [`FaceView`](@ref),
[`expand_faceviews`](@ref)

The `faces` field is a collection `<: AbstractVector{FaceType}` containing faces
that describe how vertices are connected. Typically these are `(GL)TriangleFace`s
or `QuadFace`s, but they can be any collection of vertex indices `<: AbstractFace`.

See also: [`faces`](@ref), [`decompose`](@ref)

The `views` field can be used to separate the mesh into mutliple submeshes. Each
submesh is described by a "view" into the `faces` vector, i.e. submesh n uses
`mesh.faces[mesh.views[n]]`. A `Mesh` can be constructed without `views`, which
results in an empty `views` vector.

See also: [`merge`](@ref), [`split_mesh`](@ref)
"""
struct Mesh{
        Dim, T <: Real,
        FT <: AbstractFace,
        Names,
        VAT <: Tuple{<:AbstractVector{Point{Dim, T}}, Vararg{VertexAttributeType}},
        FVT <: AbstractVector{FT}
    } <: AbstractMesh{Dim, T}

    vertex_attributes::NamedTuple{Names, VAT}
    faces::FVT
    views::Vector{UnitRange{UInt32}}

    function Mesh(
            vertex_attributes::NamedTuple{Names, VAT},
            fs::FVT,
            views::Vector{<: UnitRange{<: Integer}} = UnitRange{UInt32}[]
        ) where {
            FT <: AbstractFace, FVT <: AbstractVector{FT}, Names, Dim, T,
            VAT <: Tuple{<: AbstractVector{Point{Dim, T}}, Vararg{VertexAttributeType}}
        }

        va = vertex_attributes

        # verify type
        if !haskey(va, :position)
            error("Vertex attributes must have a :position attribute.")
        end

        if haskey(va, :normals)
            @warn "`normals` as a vertex attribute name has been deprecated in favor of `normal` to bring it in line with mesh.position and mesh.uv"
            names = ntuple(i -> ifelse(Names[i] == :normals, :normal, Names[i]), length(Names))
            va = NamedTuple{names}(values(va))
            return new{Dim, T, FT, names, VAT, FVT}(va, fs, views)
        end

        # verify that all vertex attributes refer to the same number of vertices
        # for Vectors this means same length
        # for FaceViews this means same number of faces
        N = maximum(f -> value(maximum(f)), fs, init = 0)
        for (name, attrib) in pairs(va)
            if attrib isa FaceView
                try
                    verify(fs, attrib)
                catch e
                    rethrow(ErrorException("Failed to verify $name attribute:\n$(e.msg)"))
                end
            else
                length(attrib) < N && error("Failed to verify $name attribute:\nFaces address $N vertex attributes but only $(length(attrib)) are present.")
            end
        end

        return new{Dim, T, FT, Names, VAT, FVT}(va, fs, views)
    end
end

@inline function Base.hasproperty(mesh::Mesh, field::Symbol)
    if field === :normals
        @warn "mesh.normals has been deprecated in favor of mesh.normal to bring it in line with mesh.position and mesh.uv"
        return hasproperty(mesh, :normal)
    end
    return hasproperty(getfield(mesh, :vertex_attributes), field) || hasfield(Mesh, field)
end
@inline function Base.getproperty(mesh::Mesh, field::Symbol)
    if hasfield(Mesh, field)
        return getfield(mesh, field)
    elseif field === :normals
        @warn "mesh.normals has been deprecated in favor of mesh.normal to bring it in line with mesh.position and mesh.uv"
        return getproperty(mesh, :normal)
    else
        return getproperty(getfield(mesh, :vertex_attributes), field)
    end
end
@inline function Base.propertynames(mesh::Mesh)
    return (fieldnames(Mesh)..., propertynames(getfield(mesh, :vertex_attributes))...)
end

coordinates(mesh::Mesh) = mesh.position
faces(mesh::Mesh) = mesh.faces
normals(mesh::Mesh) = hasproperty(mesh, :normal) ? mesh.normal : nothing
texturecoordinates(mesh::Mesh) = hasproperty(mesh, :uv) ? mesh.uv : nothing

"""
    vertex_attributes(mesh::Mesh)

Returns a dictionary containing the vertex attributes of the given mesh.
Mutating these will change the mesh.
"""
vertex_attributes(mesh::Mesh) = getfield(mesh, :vertex_attributes)

function Base.getindex(mesh::Mesh, i::Integer)
    f = mesh.faces[i]
    P = Polytope(eltype(mesh.position), typeof(f))
    return P(map(j -> mesh.position[j], f.data))
end

Base.length(mesh::Mesh) = length(mesh.faces)

function Base.:(==)(a::Mesh, b::Mesh)
    return (a.vertex_attributes == b.vertex_attributes) &&
           (faces(a) == faces(b)) && (a.views == b.views)
end

"""
    strictly_equal_face_vertices(a::Mesh, b::Mesh)

Checks whether mesh a and b are equal in terms of vertices used in their faces.
This allows for vertex data and indices to be synchronously permuted. For
example, this will recognize
```
a = Mesh([a, b, c], [GLTriangleFace(1,2,3)])
b = Mesh([a, c, b], [GLTriangleFace(1,3,2)])
```
as equal, because while the positions and faces have different orders the vertices
in the face are the same:
```
[a, c, b][[1, 3, 2]] == [a, b, c] == [a, b, c][[1,2,3]]
```

This still returns false if the order of faces is permuted, e.g.
`Mesh(ps, [f1, f2]) != Mesh(ps, [f2, f1])`. It also returns false if vertices are
cyclically permuted within a face, i.e. `ps[[1,2,3]] != ps[[2,3,1]]`.
"""
function strictly_equal_face_vertices(a::Mesh, b::Mesh)
    # Quick checks
    if propertynames(a) != propertynames(b) || length(faces(a)) != length(faces(b))
        return false
    end

    N = length(faces(a))
    # for views we want to ignore empty ranges (they don't represent geometry)
    # and treat 1:N as no range (as that is used interchangeably)
    views1 = filter(view -> length(view) > 0 && (minimum(view) > 1 || maximum(view) < N), a.views)
    views2 = filter(view -> length(view) > 0 && (minimum(view) > 1 || maximum(view) < N), b.views)
    views1 != views2 && return false

    # TODO: Allow different face orders & cyclic permutation within faces.
    # E.g. use hash.(data[face]), cyclically permute min to front, hash result
    # and add them to heaps (or sets?) so we can compare them at the end
    # That should probably be another function as it's probably a significant
    # step up in overhead?
    for (attrib1, attrib2) in zip(vertex_attributes(a), vertex_attributes(b))
        if attrib1 isa FaceView
            if !(attrib2 isa FaceView) || length(faces(attrib1)) != length(faces(attrib2))
                return false
            end
            for (f1, f2) in zip(faces(attrib1), faces(attrib2))
                values(attrib1)[f1] == values(attrib2)[f2] || return false
            end
        else
            if attrib2 isa FaceView
                return false
            end
            for (f1, f2) in zip(faces(a), faces(b))
                attrib1[f1] == attrib2[f2] || return false
            end
        end
    end

    return true
end

function Base.iterate(mesh::Mesh, i=1)
    return i - 1 < length(mesh) ? (mesh[i], i + 1) : nothing
end

function Base.convert(::Type{<: Mesh{D, T, FT}}, m::Mesh{D}) where {D, T <: Real, FT <: AbstractFace}
    return mesh(m, pointtype = Point{D, T}, facetype = FT)
end

"""
    Mesh(faces[; views, attributes...])
    Mesh(positions, faces[; views])
    Mesh(positions, faces::AbstractVector{<: Integer}[; facetype = TriangleFace, skip = 1])
    Mesh(; attributes...)

Constructs a mesh from the given arguments.

If `positions` are given explicitly, they are merged with other vertex attributes
under the name `position`. Otherwise they must be part of `attributes`. If `faces`
are not given `attributes.position` must be a FaceView.

Any other vertex attribute can be either an `AbstractVector` or a `FaceView`
thereof. Every vertex attribute that is an `AbstractVector` must be sufficiently
large to be indexable by `mesh.faces`. Every vertex attribute that is a `FaceView`
must contain similar faces to `mesh.faces`, i.e. contain the same number of faces
and have faces of matching length.

`views` can be defined optionally to implicitly split the mesh into multi
sub-meshes. This is done by providing ranges for indexing faces which correspond
to the sub-meshes. By default this is left empty.
"""
function Mesh(faces::AbstractVector{<:AbstractFace};
        views::Vector{<: UnitRange{<: Integer}} = UnitRange{UInt32}[], attributes...)
    return Mesh(NamedTuple(attributes), faces, views)
end

function Mesh(points::AbstractVector{Point{Dim, T}},
              faces::AbstractVector{<:AbstractFace};
              views = UnitRange{UInt32}[], kwargs...) where {Dim, T}
    va = (position = points, kwargs...)
    return Mesh(va, faces, views)
end

function Mesh(points::AbstractVector{<:Point}, faces::AbstractVector{<:Integer},
              facetype=TriangleFace, skip=1)
    return Mesh(points, connect(faces, facetype, skip))
end

# the method above allows Mesh(..., Face(...), ...) to work, but produces bad results
# explicitly error here
function Mesh(points::AbstractVector{<:Point}, faces::AbstractFace, args...; kwargs...)
    throw(MethodError(Mesh, (points, faces, args...)))
end

function Mesh(; kwargs...)
    fs = faces(kwargs[:position]::FaceView)
    va = NamedTuple{keys(kwargs)}(map(keys(kwargs)) do k
        return k == :position ? values(kwargs[k]) : kwargs[k]
    end)
    return Mesh(va, fs)
end

# Shorthand types
const SimpleMesh{N, T, FT} = Mesh{N, T, FT, (:position,), Tuple{Vector{Point{N, T}}}, Vector{FT}}
const NormalMesh{N, T, FT} = Mesh{N, T, FT, (:position, :normal), Tuple{Vector{Point{N, T}}, Vector{Vec3f}}, Vector{FT}}
const NormalUVMesh{N, T, FT} = Mesh{N, T, FT, (:position, :normal, :uv), Tuple{Vector{Point{N, T}}, Vector{Vec3f}, Vector{Vec2f}}, Vector{FT}}

const GLSimpleMesh{N} = SimpleMesh{N, Float32, GLTriangleFace}
const GLNormalMesh{N}   = NormalMesh{N, Float32, GLTriangleFace}
const GLNormalUVMesh{N} = NormalUVMesh{N, Float32, GLTriangleFace}



struct MetaMesh{Dim, T, M <: AbstractMesh{Dim, T}} <: AbstractMesh{Dim, T}
    mesh::M
    meta::Dict{Symbol, Any}
end

"""
    MetaMesh(mesh; metadata...)
    MetaMesh(positions, faces; metadata...)

Constructs a MetaMesh either from another `mesh` or by constructing another mesh
with the given `positions` and `faces`. Any keyword arguments given will be
stored in the `meta` field in `MetaMesh`.

This struct is meant to be used for storage of non-vertex data. Any vertex
related data should be stored as a vertex attribute in `Mesh`. One example of such
data is material data, which is defined per view in `mesh.views`, i.e. per submesh.

The metadata added to the MetaMesh can be manipulated with Dict-like operations
(getindex, setindex!, get, delete, keys, etc). Vertex attributes can be accessed
via fields and the same getters as mesh. The mesh itself can be retrieved with
`Mesh(metamesh)`.
"""
function MetaMesh(mesh::AbstractMesh; kwargs...)
    MetaMesh(mesh, Dict{Symbol, Any}(kwargs))
end

function MetaMesh(points::AbstractVector{<:Point}, faces::AbstractVector{<:AbstractFace}; kwargs...)
    MetaMesh(Mesh(points, faces), Dict{Symbol, Any}(kwargs))
end


@inline function Base.hasproperty(mesh::MetaMesh, field::Symbol)
    return hasfield(MetaMesh, field) || hasproperty(getfield(mesh, :mesh), field)
end
@inline function Base.getproperty(mesh::MetaMesh, field::Symbol)
    if hasfield(MetaMesh, field)
        return getfield(mesh, field)
    else
        return getproperty(getfield(mesh, :mesh), field)
    end
end
@inline function Base.propertynames(mesh::MetaMesh)
    return (fieldnames(MetaMesh)..., propertynames(getfield(mesh, :mesh))...)
end

# TODO: or via getindex?
Base.haskey(mesh::MetaMesh, key::Symbol) = haskey(getfield(mesh, :meta), key)
Base.get(f::Base.Callable, mesh::MetaMesh, key::Symbol) = get(f, getfield(mesh, :meta), key)
Base.get!(f::Base.Callable, mesh::MetaMesh, key::Symbol) = get!(f, getfield(mesh, :meta), key)
Base.get(mesh::MetaMesh, key::Symbol, default) = get(getfield(mesh, :meta), key, default)
Base.get!(mesh::MetaMesh, key::Symbol, default) = get!(getfield(mesh, :meta), key, default)
Base.getindex(mesh::MetaMesh, key::Symbol) = getindex(getfield(mesh, :meta), key)
Base.setindex!(mesh::MetaMesh, value, key::Symbol) = setindex!(getfield(mesh, :meta), value, key)
Base.delete!(mesh::MetaMesh, key::Symbol) = delete!(getfield(mesh, :meta), key)
Base.keys(mesh::MetaMesh) = keys(getfield(mesh, :meta))

coordinates(mesh::MetaMesh) = coordinates(Mesh(mesh))
faces(mesh::MetaMesh) = faces(Mesh(mesh))
normals(mesh::MetaMesh) = normals(Mesh(mesh))
texturecoordinates(mesh::MetaMesh) = texturecoordinates(Mesh(mesh))
vertex_attributes(mesh::MetaMesh) = vertex_attributes(Mesh(mesh))

meta(@nospecialize(m)) = NamedTuple()
meta(mesh::MetaMesh) = getfield(mesh, :meta)
Mesh(mesh::MetaMesh) = getfield(mesh, :mesh)
Mesh(mesh::Mesh) = mesh

# Bounding Boxes

You can generate an axis aligned bounding box for any `AbstractGeometry` by calling `Rect(geom)`.
Depending on the object this will either rely on `coordinates(geom)` or a specialized method.
You can also create a bounding box of set dimension or type by adding the related parameters.


```@repl
using GeometryBasics

s = Circle(Point2f(0), 1f0)
Rect(s) # specialized, exact bounding box
Rect3(s)
Rect3d(s)
RectT{Float64}(s)
Rect(GeometryBasics.mesh(s)) # using generated coordinates in mesh
```

## Extending

If you want to add a specialized bounding box method you should implement `Rect{N, T}(geom) = ...`.
All other methods funnel into that one, defaulting to the same `N, T` that the given `AbstractGeometry{N, T}` has.
GeometryBasics allows the user given dimension `N` to be smaller or equal to that of the geometry.
This is checked with `GeometryBasics.bbox_dim_check(user_dim, geom_dim)` which you may reuse.

```julia
function Rect{N, T}(a::HyperSphere{N2}) where {N, N2, T}
    GeometryBasics.bbox_dim_check(N, N2)
    return Rect{N, T}(minimum(a), widths(a))
end
```

# API Reference

## Exports

```@autodocs
Modules = [GeometryBasics]
Order   = [:module, :constant, :type, :function, :macro]
Public  = true
Private = false
```

## Private

```@autodocs
Modules = [GeometryBasics]
Order   = [:module, :constant, :type, :function, :macro]
Public  = false
Private = true
```

# Primitives

In GeometryBasics.jl, a `GeometryPrimitive` is an object from which a mesh can
be constructed.

## Existing GeometryPrimitives

GeometryBasics comes with a few predefined primitives:

#### HyperRectangle

A `Rect{D, T} = HyperRectangle{D, T}` is a D-dimensional axis-aligned
hyperrectangle defined by an origin and a size.

```@repl rects
using GeometryBasics
r1 = HyperRectangle{4, Float64}(Point{4, Float64}(0), Vec{4, Float64}(1))
r2 = Rect3f(Point3f(-1), Vec3f(2))
r3 = Rect2i(0, 0, 1, 1)
```

Rect2 supports normal and texture coordinate generation as well as tessellation.
Without tessellation, the coordinates of 2D Rects are defined in anti-clockwise order.
Rect3 supports normals and texture coordinates, but not tessellation.

Shorthands:

|        |`T`(eltype) |`Float64` |`Float32` |`Int`     |`UInt`    |
|--------|------------|----------|----------|----------|----------|
|`N`(dim)|`Rect{N,T}` |`Rectd{N}`|`Rectf{N}`|`Recti{N}`|`Rectui{N}`|
|`2`     |`Rect2{T}`  |`Rect2d`  |`Rect2f`  |`Rect2i`  |`Rect2ui` |
|`3`     |`Rect3{T}`  |`Rect3d`  |`Rect3f`  |`Rect3i`  |`Rect3ui` |

#### Sphere and Circle

`Circle` and `Sphere` are the 2 and 3 dimensional variants of `HyperSphere`.
They are defined by an origin and a radius.
While you can technically create a HyperSphere of any dimension, decomposition
is only defined in 2D and 3D.

```@setup hypersphere
using GeometryBasics
```
```@repl hypersphere
s1 = HyperSphere{4, Int}(Point{4, Int}(0), 5)
s2 = Sphere(Point3f(0, 0, 1), 1)
s3 = Circle(Point2d(0), 2.0)
```

Circle and Sphere support normal and texture coordinate generation as well as tessellation.
The coordinates of Circle are defined in anti-clockwise order.

#### Cylinder

A `Cylinder` is a 3D shape defined by two points and a radius.

```@setup cylinder
using GeometryBasics
```
```@repl cylinder
c = Cylinder(Point3f(-1, 0, 0), Point3f(0, 0, 1), 0.3f0) # start point, end point, radius
```

Cylinder supports normals and Tessellation, but currently no texture coordinates.

#### Cone

A `Cone` is also defined by two points and a radius, but the radius decreases to 0 from the start point to the tip.

```@setup cone
using GeometryBasics
```
```@repl cone
c = Cone(Point3f(-1, 0, 0), Point3f(0, 0, 1), 0.3f0) # start point, tip point, radius
```

Cone supports normals and Tessellation, but currently no texture coordinates.

#### Pyramid

`Pyramid` corresponds to a pyramid shape with a square base and four triangles
coming together into a sharp point.
It is defined by by the center point of the base, its height and its width.

```@setup pyramid
using GeometryBasics
```
```@repl pyramid
p = Pyramid(Point3f(0), 1f0, 0.3f0) # center, height, width
```

Pyramid supports normals, but currently no texture coordinates or tessellation

## Tessellation

In GeometryBasics `Tessellation` is a wrapper type for primitives which communicates
how dense the mesh generated from one should be.

```@setup tessellation
using GeometryBasics
```
```@repl tessellation
t = Tessellation(Cylinder(Point3f(0), Point3f(0,0,1), 0.2), 32) # 32 vertices for each circle
normal_mesh(t)

t = Tessellation(Rect2(Point2f(0), Vec2f(1)), (8, 6)) # 8 vertices in x direction by 6 in y direction
triangle_mesh(t)
```

## Primitive Interface / Implementing a new GeometryPrimitive

Every primitive should inherit from `GeometryPrimitive{Dim, eltype}` and implement at least `coordinates(primitive)` and `faces(primitive)` so that a mesh can be build from it.
This will also be enough to automatically generate normals for a 3D primitive and texture coordinates for a 2D primitive.
You can also implement functions to generate them directly with `normals(primitive)` and `texturecoordinates(primitive)`.
Depending on your primitive this might be necessary to get the normals and uvs you want.

To be compatible with `Tessellation` all of the functions mentioned above should implement a second tessellation argument.
This will be the second argument passed to the Tessellation constructor.
It's up to you to decide what makes sense here, though typically it's just an integer that more or less corresponds to the number of generated vertices.

#### Example

As an example, let's implement a parallelepiped, i.e. a 3D version or a parallelogram.
In this case we need an origin and 3 vectors telling us how far and in which directions the object extends.

```julia
struct Parallelepiped{T} <: GeometryPrimitive{3, T}
    origin::Point{3, T}
    v1::Vec{3, T}
    v2::Vec{3, T}
    v3::Vec{3, T}
end
```

Like the `Rect{3}`, this object comes with 8 unique positions which we want to return as its `coordinates`.

```julia
function GeometryBasics.coordinates(primitive::Parallelepiped{T}) where {T}
    o = primitive.origin
    v1 = primitive.v1; v2 = primitive.v2; v3 = primitive.v3
    return Point{3, T}[o, o+v2, o+v1+v2, o+v1,  o+v3, o+v2+v3, o+v1+v2+v3, o+v1+v3]
end
```

To connect these points into a mesh, we need to generate a set of faces.
The faces of a parallelepiped are parallelograms, which we can describe with `QuadFace`.
Here we should be conscious of the winding direction of faces.
They are often used to determine the front vs the backside of a (2D) face.
For example GeometryBasics normal generation and OpenGL's backface culling assume a counter-clockwise winding direction to correspond to a front-facing face.
This means that if we look at a face from outside the shape, the positions referred to by that face should be ordered counter-clockwise.
With that in mind the faces of our primitive become:

```julia
function GeometryBasics.faces(::Parallelepiped)
    return QuadFace{Int}[
        (1, 2, 3, 4), (5, 8, 7, 6), # facing -n3, +n3 (n3 being the normal of v1 x v2)
        (1, 5, 6, 2), (4, 3, 7, 8), # facing -n2, +n2
        (2, 6, 7, 3), (1, 4, 8, 5), # facing -n1, +n1
    ]
end
```

Note that you can check the correct winding direction fairly easily with Makie and the default generated normals.
After implementing faces and coordinates, you can create a mesh plot of your primitive with `Makie.mesh(primitive)`.
If the mesh reacts to light in a reasonable way, i.e. gets brighter when light shines on it, then your faces have the correct winding direction.
(It maybe useful to compare to other primitives like `Sphere(Point3f(0), 1f0)` here.)

Next on our TODO list are normals.
The default normals produced by `GeometryBasics.normal(primitive)` are vertex normals, which assume that a primitive to be smooth.
Since this is not the case for our primitive, we need to implement custom normals.
Here we could rely on `GeometryBasics.face_normal()` which returns a normal per face, but for this example we will implement them ourselves.

For our shape we want one normal per face, pointing in the normal direction of the corresponding 2D plane.
We can calculate the normal vector as `n = normalize(cross(v, w))` where v and w correspond to combinations of v1, v2 and v3.
To get them to act per face rather than per vertex, we need to overwrite the faces generated by `faces()`.
We can do that by creating a `FaceView` with a new set of faces which only act on normals.
Each of these new faces needs to refer to one normal by index to get what we want.

```julia
using LinearAlgebra
function GeometryBasics.normals(primitive::Parallelepiped)
    n1 = normalize(cross(primitive.v2, primitive.v3))
    n2 = normalize(cross(primitive.v3, primitive.v1))
    n3 = normalize(cross(primitive.v1, primitive.v2))
    ns = [-n3, n3, -n2, n2, -n1, n1]
    fs = QuadFace{Int}[1, 2, 3, 4, 5, 6] # = [QuadFace{Int}(1), QuadFace{Int}(2), ...]
    return FaceView(ns, fs)
end
```

As the last piece of the interface we can implement texture coordinates.
They generally refer to a 2D image with normalized 2D coordinates on a per-vertex basis.
There are many ways to define these coordinates.
Here we will partition the image in 2x3 even sized rectangular sections, split by the sign of the normal directions defined above.

```julia
function GeometryBasics.texturecoordinates(::Parallelepiped{T}) where {T}
    uvs = [Vec2f(x, y) for x in range(0, 1, length=4) for y in range(0, 1, 3)]
    fs = QuadFace{Int}[
        (1, 2, 5, 4),   (2, 3, 6, 5),
        (4, 5, 8, 7),   (5, 6, 9, 8),
        (7, 8, 11, 10), (8, 9, 12, 11)
    ]
    return FaceView(uvs, fs)
end
```

# Meshes

GeometryBasics defines two mesh types to work with - `Mesh` and `MetaMesh`

## Mesh

```@docs; canonical=false
Mesh
```

You can get data from a mesh using a few interface functions:
- `vertex_attributes(mesh) = mesh.vertex_attributes`
- `coordinates(mesh) = mesh.vertex_attributes[:position]`
- `normals(mesh) = mesh.vertex_attributes[:normal]`
- `texturecoordinates(mesh) = mesh.vertex_attributes[:uv]`
- `faces(mesh) = mesh.faces`

You can also grab the contents of `mesh.vertex_attributes` as if they were fields of the `Mesh`, e.g. `mesh.position` works.

### FaceView


```@docs; canonical=false
FaceView
```

The purpose of FaceView is to allow you to add data that doesn't use the same vertex indices as `mesh.faces`
As a minimal example consider a mesh that is just one triangle, i.e. 3 position and one triangle face `TriangleFace(1,2,3)`.
Let's say we want to add a flat color to the triangle.
In this case we only have one color, but our face refers to 3 different vertices (3 different positions).
To avoid duplicating the color data, we can instead define a new triangle face `TriangleFace(1)` and add the color attribute as a `FaceView([color], [TriangleFace(1)])`.
If we ever need the mesh to be defined with just one common set of faces, i.e. no FaceView and appropriately duplicated vertex data, we can use `expand_faceviews(mesh)` to generate it.

On a larger scale this can be useful for memory and performance reason, e.g. when you do calculations with vertex attributes.
It can also simplify some definitions, like for example `Rect3`.
In that case we have 8 positions and 6 normals with FaceViews, or 24 without (assuming per-face normals).

For the relatively common case of per-face data, you can use the `per_face` convenience function.

```@docs
per_face
```

## MetaMesh

```@docs; canonical=false
MetaMesh
```

## How to create a mesh

### GeometryBasics

In GeometryBasics you mainly create meshes from primitives using a few constructors:
- `triangle_mesh(primitive)` generates the most basic mesh (i.e. positions and faces)
- `normal_mesh(primitive)` generates a mesh with normals (generated if the primitive doesn't implement `normal()`)
- `uv_mesh(primitive)` generates a mesh with texture coordinates (generated if the primitive doesn't implement `texturecoordinates()`)
- `uv_normal_mesh(primitive)` generates a mesh with normals and texture coordinates

Each of these constructors also includes keyword arguments for setting types, i.e. `pointtype`, `facetype`, `normaltype` and `uvtype` as appropriate.
Of course you can also construct a mesh directly from data, either with there various `Mesh()` or `GeometryBasics.mesh()` constructors.
The latter also include a `pointtype` and `facetype` conversion.

Finally there is also a `merge(::Vector{Mesh})` function which combines multiple meshes into a single one.
Note that this doesn't remove any data (e.g. hidden or duplicate vertices), and may remove `FaceView`s if they are incompatible between meshes.

### Meshing.jl

### MeshIO.jl

The [`MeshIO.jl`](https://github.com/JuliaIO/MeshIO.jl) package provides load/save support for several file formats which store meshes.

```@example
using GLMakie, GLMakie.FileIO, GeometryBasics

m = load(GLMakie.assetpath("cat.obj"))
GLMakie.mesh(m; color=load(GLMakie.assetpath("diffusemap.png")), axis=(; show_axis=false))
```

# GeometryBasics.jl

Basic geometry types.

This package aims to offer a standard set of geometry types that easily work
with metadata, query frameworks on geometries and different memory layouts. The
aim is to create a solid basis for graphics/plotting, finite element analysis,
geo applications, and general geometry manipulations - while offering a Julian
API that still allows performant C-interop.

This package is a replacement for the discontinued [GeometryTypes](https://github.com/JuliaGeometry/GeometryTypes.jl/).

## Quick start

Create some points:

```@repl quickstart
using GeometryBasics

p1 = Point(3, 1)
p2 = Point(1, 3);
p3 = Point(4, 4);
```

Connect pairs of points as line segments:

```@repl quickstart
l1 = Line(p1, p2)
l2 = Line(p2, p3);
```

Or connect multiple points as a linestring:

```@repl quickstart
LineString([p1, p2, p3])
```

You can also create polygons from points:

```@repl quickstart
Polygon(Point{2, Int}[(3, 1), (4, 4), (2, 4), (1, 2), (3, 1)])
```

Create a rectangle placed at the origin with unit width and height:

```@repl quickstart
rect = Rect(Vec(0.0, 0.0), Vec(1.0, 1.0))
```

Decompose the rectangle into two triangular faces:

```@repl quickstart
rect_faces = decompose(TriangleFace{Int}, rect)
```

Decompose the rectangle into four positions:

```@repl quickstart
rect_positions = decompose(Point{2, Float64}, rect)
```

Combine the vertices and faces into a triangle mesh:

```@repl quickstart
mesh = Mesh(rect_positions, rect_faces)
```

Use `GeometryBasics.mesh` to get a mesh directly from a geometry:

```@repl quickstart
mesh = GeometryBasics.mesh(rect)
```

# Decomposition

## decompose functions

The `decompose` functions allow you to grab certain data from an `AbstractGeometry` like a mesh or primitive and convert it to a requested type, if possible.
They can also be used to convert an array of e.g. faces into a different face type directly.
The default decomposition implemented by GeoemtryBasics are:
- `decompose(::Type{<: Point}, source)` which collects data from `source` using `coordinates(source)` and converts it to the given point type.
- `decompose_normals([::Type{<: Vec},] source) = decompose([::Type{Normals{<: Vec}}},] source)` which collects data with `normals(source)` and converts it to the given Vec type.
- `decompose_uv([::Type{<: Vec},] source) = decompose([::Type{UV{<: Vec}}},] source)` which collects data with `texturecoordinates(source)` and converts it to the given Vec type. This function also exists with `UVW` texture coordinates.
- `decompose(::Type{<: AbstractFace}, source)` which collects data with `faces(source)` and converts it to the given face type. 

### Extending decompose

For `decompose` to work there needs to be a conversion from some element type to some target type. 
GeometryBasics relies on `GeometryBasics.convert_simplex(TargetType, value)` for this.
If you want to add new types to decompose, e.g. a new face type, you will need to add a method to that function.

## Primitive decomposition

GeometryBasics defines an interface to decompose geometry primitives into vertex attributes and faces.
The interface includes four functions:
- `coordinates(primitive[, nvertices])` which produces the positions associated with the primitive
- `faces(primitive[, nvertices])` which produces the faces which connect the vertex positions to a mesh
- `normals(primitive[, nvertices])` which optionally provide normal vectors of the primitive
- `texturecoordinates(primitive[, nvertices])` which optional provide texture coordinates (uv/uvw) of the primitive

# Point, Vec and Mat

GeometryBasics defines its own set of (small) Static Vectors and Matrices:
```julia
Point{N,T} <: StaticVector{N,T} <: AbstractVector{T}
Vec{N,T} <: StaticVector{N,T} <: AbstractVector{T}
Mat{Row, Column, T, L} <: AbstractMatrix{T}
```

These types are used throughout GeometryBasics to speed up calculations similar to how StaticArrays.jl does.

## Aliases

GeometryBasics exports common aliases for Point, Vec, Mat and Rect:

### Vec

|        |`T`(eltype) |`Float64` |`Float32` |`Int`     |`UInt`    |
|--------|------------|----------|----------|----------|----------|
|`N`(dim)|`Vec{N,T}`  |`Vecd{N}` |`Vecf{N}` |`Veci{N}` |`Vecui{N}`|
|`2`     |`Vec2{T}`   |`Vec2d`   |`Vec2f`   |`Vec2i`   |`Vec2ui`  |
|`3`     |`Vec3{T}`   |`Vec3d`   |`Vec3f`   |`Vec3i`   |`Vec3ui`  |

### Point

|        |`T`(eltype) |`Float64` |`Float32` |`Int`     |`UInt`    |
|--------|------------|----------|----------|----------|----------|
|`N`(dim)|`Point{N,T}`|`Pointd{N}`|`Pointf{N}`|`Pointi{N}`|`Pointui{N}`|
|`2`     |`Point2{T}` |`Point2d` |`Point2f` |`Point2i` |`Point2ui`|
|`3`     |`Point3{T}` |`Point3d` |`Point3f` |`Point3i` |`Point3ui`|

### Mat

|        |`T`(eltype) |`Float64` |`Float32` |`Int`     |`UInt`    |
|--------|------------|----------|----------|----------|----------|
|`N`(dim)|`Mat{N,T}`  |`Matd{N}` |`Matf{N}` |`Mati{N}` |`Matui{N}`|
|`2`     |`Mat2{T}`   |`Mat2d`   |`Mat2f`   |`Mat2i`   |`Mat2ui`  |
|`3`     |`Mat3{T}`   |`Mat3d`   |`Mat3f`   |`Mat3i`   |`Mat3ui`  |
